->
-> MeasCOnvRx.e  Aris Basic 1995
->
-> COMPILED_NAME:
->              MeasConvRx
->
-> COPYRIGHT (DISTRIBUTION):
->              GMYware
->    (see MeasConv.guide "GMYWare")
->
-> DESCRIPTION:
-> ArexxHost of MeasConv (untill some better time as separate programm)
->
->
-> HISTORY:
->  31.08.1995  01.00 initial release
->  07.09.1995  01.10 now uses measconv.library
->
->
OPT PREPROCESS

-> Modules

MODULE 'measconv','rexxhost'

->// Global Variables
DEF rexx_host,quit=FALSE,rexxmsg,cmd[20]:STRING,args[41]:STRING,argstr[20]:STRING,
    charcount=0:LONG,argvalue,resultstr[20]:STRING
->///
->// main program
PROC main() HANDLE
    DEF value ->,valuestr[20]:STRING
    IF NIL=(measconvbase:=OpenLibrary('measconv.library',0)) THEN Raise("MCL")
    IF NIL=(rexxhostbase:=OpenLibrary('rexxhost.library',0)) THEN Raise("RXL")
    IF NIL=(rexx_host:=CreateRexxHost('MEASCONV.RX')) THEN Raise("RXH")
        WHILE ((rexxmsg:=GetRexxMsg(rexx_host,TRUE)) AND (quit=FALSE))
            IF args:=GetRexxCommand(rexxmsg)
                GetToken(args,{charcount},cmd,19)
                GetToken(args,{charcount},argstr,19)
                argvalue:=RealVal(argstr)
                IF FALSE=RexxStrCmp(cmd,'cm2inch')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Cm2inch(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'inch2cm')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Inch2cm(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'inch2ft')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Inch2ft(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'ft2inch')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Ft2inch(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'ft2mile')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Ft2mile(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'mile2ft')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Mile2ft(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'mile2km')
                    value:=Mile2km(argvalue)
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,value,6))
                ELSEIF FALSE=RexxStrCmp(cmd,'km2mile')
                    value:=Km2mile(argvalue)
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,value,6))
                ELSEIF FALSE=RexxStrCmp(cmd,'kg2pound')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Kg2pound(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'pound2kg')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Pound2kg(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'celsius2fahreheit')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Cg2fg(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'fahreheit2celsius')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Fg2cg(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'celsius2kelvin')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Cg2kg(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'kelvin2celsius')
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,(Kg2cg(argvalue)),6))
                ELSEIF FALSE=RexxStrCmp(cmd,'fahreheit2kelvin')
                    value:=Fg2kg(argvalue)
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,value,6))
                ELSEIF FALSE=RexxStrCmp(cmd,'kelvin2fahreheit')
                    value:=Kg2fg(argvalue)
                    ReplyRexxCommand(rexxmsg,0,0,RealF(resultstr,value,6))
                ELSEIF FALSE=RexxStrCmp(cmd,'quit')
                    quit:=TRUE
                    ReplyRexxCommand(rexxmsg,0,0,NIL)
                ELSEIF FALSE=RexxStrCmp(cmd,'about')
                    EasyRequestArgs(0,[20,0,'MeasConvRx ABOUT',{version},'OK'],0,NIL)
                    ReplyRexxCommand(rexxmsg,0,0,NIL)
                ELSE
                    ReplyRexxCommand(rexxmsg,10,0,NIL)
                    ENDIF
                charcount:=0
                value:=0
                argvalue:=0
                StrCopy(resultstr,NIL)
                IF quit=TRUE THEN JUMP end
                ENDIF
            ENDWHILE
end:
    Raise(0)
EXCEPT
    IF measconvbase THEN CloseLibrary(measconvbase)
    IF rexxmsg THEN ReplyRexxCommand(rexxmsg,0,0,NIL)
    IF rexx_host THEN DeleteRexxHost(rexx_host)
    IF rexxhostbase THEN CloseLibrary(rexxhostbase)
    SELECT exception
        CASE "MCL"
            PrintF('Can`t open measconv.library !\n')
        CASE "RXL"
            PrintF('Can`t open rexxhost.library !\n')
        CASE "RXH"
            PrintF('Can`t create rexx host !\n')
        DEFAULT
        ENDSELECT
    ENDPROC
->///
version:
CHAR '$VER: MeasConvRx 01.10 (07.09.1995)  Aris Basic\n',0

