->
-> confuncs.e  Aris Basic 1995
->
-> COMPILED NAME:
->              confuncs.m
->
-> COPYRIGHT (DISTRIBUTION):
->              GMYware
->         (see GMYware.readme)
->
-> DESCRIPTION:
-> Conversion functions for MeasConv
->
->
-> HISTORY:
->  17.08.1995  01.00  initail release
->  30.08.1995  01.01  some small cosmetic changes
->

-> Compile Options
OPT MODULE
OPT EXPORT

-> Conversion Functions for Length
PROC cm2inch(cm) IS (!cm*0.3937)            -> centimeters(cm) to inches(")
PROC inch2cm(inch) IS (!inch*2.54)          -> inches(") to centimeters(cm)
PROC inch2ft(inch) IS (!inch/12.0)          -> inches(") to feets(ft or ')
PROC ft2inch(ft) IS (!ft*12.0)              -> feets(ft or ') to inches(")
PROC ft2mile(ft) IS (!ft/5280.0)            -> feets(ft or ') to miles(mi)
PROC mile2ft(mile) IS (!mile*5280.0)        -> miles(mi) to feets(ft or ')

-> Conversion Functions for Weight
PROC kg2pound(kg) IS (!kg*2.30414746)       -> kilograms(kg) to pounds(lb)
PROC pound2kg(pound) IS (!pound*0.434)      -> pounds(lb) to kilograms(kg)

-> Conversion Functions for Temperature
PROC c2f(cg) IS (!(!1.8*cg)+32.0)       -> celsius(C) to fahrenheit(F)
PROC f2c(fg) IS (!(!fg-32.0)*(5.0/9.0))     -> fahrenheit(F) to celsius(C)
PROC k2c(kg) IS (!kg+(-273.2))              -> kelvin(K) to celsius(C)
PROC c2k(cg) IS (!cg+(273.2))               -> celsius(C) to kelvin(K)
