OPT MODULE
OPT EXPORT
OPT PREPROCESS

MODULE 'exec/libraries', 'utility/hooks',
       'graphics/rastport', 'graphics/text',
       'intuition/intuition', 'intuition/screens', 'intuition/classes'

CONST MUI_TRUE = 1
CONST MUIMASTER_VMIN = 10

OBJECT mui_command
   mc_name       :PTR TO CHAR
   mc_template   :PTR TO CHAR
   mc_parameters :LONG
   mc_hook       :PTR TO hook
   mc_reserved[5]:ARRAY OF LONG
ENDOBJECT

OBJECT mui_palette_entry
   mpe_id    :LONG
   mpe_red   :LONG
   mpe_green :LONG
   mpe_blue  :LONG
   mpe_group :LONG
ENDOBJECT

OBJECT mui_scrmodelist_entry
   sme_name   :PTR TO CHAR
   sme_modeid :LONG
ENDOBJECT

OBJECT mui_boopsiquery
   mbq_methodid   :LONG
   mbq_screen     :PTR TO screen
   mbq_flags      :LONG
   mbq_minwidth   :LONG
   mbq_minheight  :LONG
   mbq_maxwidth   :LONG
   mbq_maxheight  :LONG
   mbq_defwidth   :LONG
   mbq_defheight  :LONG
   mbq_renderinfo :PTR TO mui_renderinfo
ENDOBJECT

OBJECT mui_globalinfo
   priv0                 :LONG
   mgi_applicationobject :PTR TO LONG
ENDOBJECT

OBJECT mui_notifydata
   mnd_globalinfo :PTR TO mui_globalinfo
   mnd_userdata   :LONG
   priv1 :LONG
   priv2 :LONG
   priv3 :LONG
   priv4 :LONG
   priv5 :LONG
ENDOBJECT

OBJECT mui_minmax
   minwidth  :INT
   minheight :INT
   maxwidth  :INT
   maxheight :INT
   defwidth  :INT
   defheight :INT
ENDOBJECT

OBJECT mui_areadata
   mad_renderinfo :PTR TO mui_renderinfo
   priv6          :LONG
   mad_font       :PTR TO textfont
   mad_minmax     :mui_minmax
   mad_box        :ibox
   mad_addleft    :CHAR
   mad_addtop     :CHAR
   mad_subwidth   :CHAR
   mad_subheight  :CHAR
   mad_flags      :LONG
ENDOBJECT

OBJECT mui_renderinfo
   mri_windowobject :PTR TO LONG
   mri_screen       :PTR TO screen
   mri_drawinfo     :PTR TO drawinfo
   mri_pens         :PTR TO INT
   mri_window       :PTR TO window
   mri_rastport     :PTR TO rastport
ENDOBJECT

OBJECT mui_customclass
   mcc_userdata      :LONG
   mcc_utilitybase   :PTR TO lib
   mcc_dosbase       :PTR TO lib
   mcc_gfxbase       :PTR TO lib
   mcc_intuitionbase :PTR TO lib
   mcc_super         :PTR TO iclass
   mcc_class         :PTR TO iclass
ENDOBJECT

OBJECT __dummyxfc2__
   mnd :mui_notifydata
   mad :mui_areadata
ENDOBJECT

CONST MUIO_Label        = 1
CONST MUIO_Button       = 2
CONST MUIO_Checkmark    = 3
CONST MUIO_Cycle        = 4
CONST MUIO_Radio        = 5
CONST MUIO_Slider       = 6
CONST MUIO_String       = 7
CONST MUIO_PopButton    = 8
CONST MUIO_HSpace       = 9
CONST MUIO_VSpace      = 10
CONST MUIO_HBar        = 11
CONST MUIO_VBar        = 12
CONST MUIO_MenustripNM = 13
CONST MUIO_Menuitem    = 14
CONST MUIO_BarTitle    = 15
CONST MUIO_Label_SingleFrame = 256
CONST MUIO_Label_DoubleFrame = 512
CONST MUIO_Label_LeftAligned = 1024
CONST MUIO_Label_Centered    = 2048
CONST MC_TEMPLATE_ID = -1
CONST MUI_RXERR_BADDEFINITION  = -1
CONST MUI_RXERR_OUTOFMEMORY    = -2
CONST MUI_RXERR_UNKNOWNCOMMAND = -3
CONST MUI_RXERR_BADSYNTAX      = -4
CONST MUIE_OK                  = 0
CONST MUIE_OutOfMemory         = 1
CONST MUIE_OutOfGfxMemory      = 2
CONST MUIE_InvalidWindowObject = 3
CONST MUIE_MissingLibrary      = 4
CONST MUIE_NoARexx             = 5
CONST MUIE_SingleTask          = 6
CONST MUII_WindowBack     = 0
CONST MUII_RequesterBack  = 1
CONST MUII_ButtonBack     = 2
CONST MUII_ListBack       = 3
CONST MUII_TextBack       = 4
CONST MUII_PropBack       = 5
CONST MUII_PopupBack      = 6
CONST MUII_SelectedBack   = 7
CONST MUII_ListCursor     = 8
CONST MUII_ListSelect     = 9
CONST MUII_ListSelCur    = 10
CONST MUII_ArrowUp       = 11
CONST MUII_ArrowDown     = 12
CONST MUII_ArrowLeft     = 13
CONST MUII_ArrowRight    = 14
CONST MUII_CheckMark     = 15
CONST MUII_RadioButton   = 16
CONST MUII_Cycle         = 17
CONST MUII_PopUp         = 18
CONST MUII_PopFile       = 19
CONST MUII_PopDrawer     = 20
CONST MUII_PropKnob      = 21
CONST MUII_Drawer        = 22
CONST MUII_HardDisk      = 23
CONST MUII_Disk          = 24
CONST MUII_Chip          = 25
CONST MUII_Volume        = 26
CONST MUII_PopUpBack     = 27
CONST MUII_Network       = 28
CONST MUII_Assign        = 29
CONST MUII_TapePlay      = 30
CONST MUII_TapePlayBack  = 31
CONST MUII_TapePause     = 32
CONST MUII_TapeStop      = 33
CONST MUII_TapeRecord    = 34
CONST MUII_GroupBack     = 35
CONST MUII_SliderBack    = 36
CONST MUII_SliderKnob    = 37
CONST MUII_TapeUp        = 38
CONST MUII_TapeDown      = 39
CONST MUII_Count         = 40
CONST MUII_BACKGROUND    = 128
CONST MUII_SHADOW        = 129
CONST MUII_SHINE         = 130
CONST MUII_FILL          = 131
CONST MUII_SHADOWBACK    = 132
CONST MUII_SHADOWFILL    = 133
CONST MUII_SHADOWSHINE   = 134
CONST MUII_FILLBACK      = 135
CONST MUII_FILLSHINE     = 136
CONST MUII_SHINEBACK     = 137
CONST MUII_FILLBACK2     = 138
CONST MUII_HSHINEBACK    = 139
CONST MUII_HSHADOWBACK   = 140
CONST MUII_HSHINESHINE   = 141
CONST MUII_HSHADOWSHADOW = 142
CONST MUII_LASTPAT       = 142
CONST MUIV_TriggerValue    =$49893131
CONST MUIV_NotTriggerValue =$49893133
CONST MUIV_EveryTime       =$49893131
CONST MUIV_Notify_Self        = 1
CONST MUIV_Notify_Window      = 2
CONST MUIV_Notify_Application = 3
CONST MUIV_Application_Save_ENV     = 0
CONST MUIV_Application_Save_ENVARC  = -1
CONST MUIV_Application_Load_ENV     = 0
CONST MUIV_Application_Load_ENVARC  = -1
CONST MUIV_Application_ReturnID_Quit = -1
CONST MUIV_List_Insert_Top             = 0
CONST MUIV_List_Insert_Active         = -1
CONST MUIV_List_Insert_Sorted         = -2
CONST MUIV_List_Insert_Bottom         = -3
CONST MUIV_List_Remove_First           = 0
CONST MUIV_List_Remove_Active         = -1
CONST MUIV_List_Remove_Last           = -2
CONST MUIV_List_Remove_Selected       = -3
CONST MUIV_List_Select_Off             = 0
CONST MUIV_List_Select_On              = 1
CONST MUIV_List_Select_Toggle          = 2
CONST MUIV_List_Select_Ask             = 3
CONST MUIV_List_Jump_Top               = 0
CONST MUIV_List_Jump_Active           = -1
CONST MUIV_List_Jump_Bottom           = -2
CONST MUIV_List_GetEntry_Active       = -1
CONST MUIV_List_Select_Active         = -1
CONST MUIV_List_Select_All            = -2
CONST MUIV_List_Redraw_Active         = -1
CONST MUIV_List_Redraw_All            = -2
CONST MUIV_List_Move_Top = 0
CONST MUIV_List_Move_Active = -1
CONST MUIV_List_Move_Bottom = -2
CONST MUIV_List_Move_Next = -3
CONST MUIV_List_Move_Previous = -4
CONST MUIV_List_Exchange_Top = 0
CONST MUIV_List_Exchange_Active       = -1
CONST MUIV_List_Exchange_Bottom = -2
CONST MUIV_List_Exchange_Next = -3
CONST MUIV_List_Exchange_Previous = -4
CONST MUIV_List_NextSelected_Start = -1
CONST MUIV_List_NextSelected_End = -1
CONST MUIV_Colorpanel_GetColor_Active = -1
CONST MUIV_Colorpanel_SetColor_Active = -1
CONST MUIV_Palette_Entry_End = -1
CONST MUIM_BoopsiQuery =$80427157
CONST MBQF_HORIZ = 1
CONST MBQ_MUI_MAXMAX = 10000
CONST MUIM_CallHook                  =$8042b96b
CONST MUIM_FindUData                 =$8042c196
CONST MUIM_GetUData                  =$8042ed0c
CONST MUIM_KillNotify                =$8042d240
CONST MUIM_MultiSet                  =$8042d356
CONST MUIM_Notify                    =$8042c9cb
CONST MUIM_Set                       =$8042549a
CONST MUIM_SetAsString               =$80422590
CONST MUIM_SetUData                  =$8042c920
CONST MUIM_WriteLong                 =$80428d86
CONST MUIM_WriteString               =$80424bf4
CONST MUIM_NoNotifySet               =$8042216f
CONST MUIA_AppMessage                 =$80421955
CONST MUIA_HelpFile                   =$80423a6e
CONST MUIA_HelpLine                   =$8042a825
CONST MUIA_HelpNode                   =$80420b85
CONST MUIA_NoNotify                   =$804237f9
CONST MUIA_Revision                   =$80427eaa
CONST MUIA_UserData                   =$80420313
CONST MUIA_Version                    =$80422301
CONST MUIM_Family_AddHead            =$8042e200
CONST MUIM_Family_AddTail            =$8042d752
CONST MUIM_Family_Insert             =$80424d34
CONST MUIM_Family_Remove             =$8042f8a9
CONST MUIM_Family_Sort               =$80421c49
CONST MUIM_Family_Transfer           =$8042c14a
CONST MUIA_Family_Child               =$8042c696
CONST MUIA_Menustrip_Enabled          =$8042815b
CONST MUIA_Menu_Enabled               =$8042ed48
CONST MUIA_Menu_Title                 =$8042a0e3
CONST MUIA_Menuitem_Checked           =$8042562a
CONST MUIA_Menuitem_Checkit           =$80425ace
CONST MUIA_Menuitem_Enabled           =$8042ae0f
CONST MUIA_Menuitem_Exclude           =$80420bc6
CONST MUIA_Menuitem_Shortcut          =$80422030
CONST MUIA_Menuitem_Title             =$804218be
CONST MUIA_Menuitem_Toggle            =$80424d5c
CONST MUIA_Menuitem_Trigger           =$80426f32
CONST MUIM_Application_GetMenuCheck  =$8042c0a7
CONST MUIM_Application_GetMenuState  =$8042a58f
CONST MUIM_Application_Input         =$8042d0f5
CONST MUIM_Application_InputBuffered =$80427e59
CONST MUIM_Application_Load          =$8042f90d
CONST MUIM_Application_PushMethod    =$80429ef8
CONST MUIM_Application_ReturnID      =$804276ef
CONST MUIM_Application_Save          =$804227ef
CONST MUIM_Application_SetMenuCheck  =$8042a707
CONST MUIM_Application_SetMenuState  =$80428bef
CONST MUIM_Application_ShowHelp      =$80426479
CONST MUIA_Application_Active         =$804260ab
CONST MUIA_Application_Author         =$80424842
CONST MUIA_Application_Base           =$8042e07a
CONST MUIA_Application_Broker         =$8042dbce
CONST MUIA_Application_BrokerHook     =$80428f4b
CONST MUIA_Application_BrokerPort     =$8042e0ad
CONST MUIA_Application_BrokerPri      =$8042c8d0
CONST MUIA_Application_Commands       =$80428648
CONST MUIA_Application_Copyright      =$8042ef4d
CONST MUIA_Application_Description    =$80421fc6
CONST MUIA_Application_DiskObject     =$804235cb
CONST MUIA_Application_DoubleStart    =$80423bc6
CONST MUIA_Application_DropObject     =$80421266
CONST MUIA_Application_ForceQuit      =$804257df
CONST MUIA_Application_HelpFile       =$804293f4
CONST MUIA_Application_Iconified      =$8042a07f
CONST MUIA_Application_Menu           =$80420e1f
CONST MUIA_Application_MenuAction     =$80428961
CONST MUIA_Application_MenuHelp       =$8042540b
CONST MUIA_Application_Menustrip      =$804252d9
CONST MUIA_Application_RexxHook       =$80427c42
CONST MUIA_Application_RexxMsg        =$8042fd88
CONST MUIA_Application_RexxString     =$8042d711
CONST MUIA_Application_SingleTask     =$8042a2c8
CONST MUIA_Application_Sleep          =$80425711
CONST MUIA_Application_Title          =$804281b8
CONST MUIA_Application_UseCommodities =$80425ee5
CONST MUIA_Application_UseRexx        =$80422387
CONST MUIA_Application_Version        =$8042b33f
CONST MUIA_Application_Window         =$8042bfe0
CONST MUIM_Window_GetMenuCheck       =$80420414
CONST MUIM_Window_GetMenuState       =$80420d2f
CONST MUIM_Window_ScreenToBack       =$8042913d
CONST MUIM_Window_ScreenToFront      =$804227a4
CONST MUIM_Window_SetCycleChain      =$80426510
CONST MUIM_Window_SetMenuCheck       =$80422243
CONST MUIM_Window_SetMenuState       =$80422b5e
CONST MUIM_Window_ToBack             =$8042152e
CONST MUIM_Window_ToFront            =$8042554f
CONST MUIA_Window_Activate            =$80428d2f
CONST MUIA_Window_ActiveObject        =$80427925
CONST MUIA_Window_AltHeight           =$8042cce3
CONST MUIA_Window_AltLeftEdge         =$80422d65
CONST MUIA_Window_AltTopEdge          =$8042e99b
CONST MUIA_Window_AltWidth            =$804260f4
CONST MUIA_Window_AppWindow           =$804280cf
CONST MUIA_Window_Backdrop            =$8042c0bb
CONST MUIA_Window_Borderless          =$80429b79
CONST MUIA_Window_CloseGadget         =$8042a110
CONST MUIA_Window_CloseRequest        =$8042e86e
CONST MUIA_Window_DefaultObject       =$804294d7
CONST MUIA_Window_DepthGadget         =$80421923
CONST MUIA_Window_DragBar             =$8042045d
CONST MUIA_Window_FancyDrawing        =$8042bd0e
CONST MUIA_Window_Height              =$80425846
CONST MUIA_Window_ID                  =$804201bd
CONST MUIA_Window_InputEvent          =$804247d8
CONST MUIA_Window_LeftEdge            =$80426c65
CONST MUIA_Window_Menu                =$8042db94
CONST MUIA_Window_MenuAction          =$80427521
CONST MUIA_Window_Menustrip           =$8042855e
CONST MUIA_Window_MouseObject         =$8042bf9b
CONST MUIA_Window_NeedsMouseObject    =$8042372a
CONST MUIA_Window_NoMenus             =$80429df5
CONST MUIA_Window_Open                =$80428aa0
CONST MUIA_Window_PublicScreen        =$804278e4
CONST MUIA_Window_RefWindow           =$804201f4
CONST MUIA_Window_RootObject          =$8042cba5
CONST MUIA_Window_Screen              =$8042df4f
CONST MUIA_Window_ScreenTitle         =$804234b0
CONST MUIA_Window_SizeGadget          =$8042e33d
CONST MUIA_Window_SizeRight           =$80424780
CONST MUIA_Window_Sleep               =$8042e7db
CONST MUIA_Window_Title               =$8042ad3d
CONST MUIA_Window_TopEdge             =$80427c66
CONST MUIA_Window_Width               =$8042dcae
CONST MUIA_Window_Window              =$80426a42
CONST MUIV_Window_ActiveObject_None = 0
CONST MUIV_Window_ActiveObject_Next = -1
CONST MUIV_Window_ActiveObject_Prev = -2
CONST MUIV_Window_AltHeight_Scaled = -1000
CONST MUIV_Window_AltLeftEdge_Centered = -1
CONST MUIV_Window_AltLeftEdge_Moused = -2
CONST MUIV_Window_AltLeftEdge_NoChange = -1000
CONST MUIV_Window_AltTopEdge_Centered = -1
CONST MUIV_Window_AltTopEdge_Moused = -2
CONST MUIV_Window_AltTopEdge_NoChange = -1000
CONST MUIV_Window_AltWidth_Scaled = -1000
CONST MUIV_Window_Height_Scaled = -1000
CONST MUIV_Window_Height_Default = -1001
CONST MUIV_Window_LeftEdge_Centered = -1
CONST MUIV_Window_LeftEdge_Moused = -2
CONST MUIV_Window_Menu_NoMenu = -1
CONST MUIV_Window_TopEdge_Centered = -1
CONST MUIV_Window_TopEdge_Moused = -2
CONST MUIV_Window_Width_Scaled = -1000
CONST MUIV_Window_Width_Default = -1001
CONST MUIM_AskMinMax                 =$80423874
CONST MUIM_Cleanup                   =$8042d985
CONST MUIM_Draw                      =$80426f3f
CONST MUIM_HandleInput               =$80422a1a
CONST MUIM_Hide                      =$8042f20f
CONST MUIM_Setup                     =$80428354
CONST MUIM_Show                      =$8042cc84
CONST MUIA_ApplicationObject          =$8042d3ee
CONST MUIA_Background                 =$8042545b
CONST MUIA_BottomEdge                 =$8042e552
CONST MUIA_ControlChar                =$8042120b
CONST MUIA_Disabled                   =$80423661
CONST MUIA_ExportID                   =$8042d76e
CONST MUIA_FixHeight                  =$8042a92b
CONST MUIA_FixHeightTxt               =$804276f2
CONST MUIA_FixWidth                   =$8042a3f1
CONST MUIA_FixWidthTxt                =$8042d044
CONST MUIA_Font                       =$8042be50
CONST MUIA_Frame                      =$8042ac64
CONST MUIA_FramePhantomHoriz          =$8042ed76
CONST MUIA_FrameTitle                 =$8042d1c7
CONST MUIA_Height                     =$80423237
CONST MUIA_HorizWeight                =$80426db9
CONST MUIA_InnerBottom                =$8042f2c0
CONST MUIA_InnerLeft                  =$804228f8
CONST MUIA_InnerRight                 =$804297ff
CONST MUIA_InnerTop                   =$80421eb6
CONST MUIA_InputMode                  =$8042fb04
CONST MUIA_LeftEdge                   =$8042bec6
CONST MUIA_Pressed                    =$80423535
CONST MUIA_RightEdge                  =$8042ba82
CONST MUIA_Selected                   =$8042654b
CONST MUIA_ShowMe                     =$80429ba8
CONST MUIA_ShowSelState               =$8042caac
CONST MUIA_Timer                      =$80426435
CONST MUIA_TopEdge                    =$8042509b
CONST MUIA_VertWeight                 =$804298d0
CONST MUIA_Weight                     =$80421d1f
CONST MUIA_Width                      =$8042b59c
CONST MUIA_Window                     =$80421591
CONST MUIA_WindowObject               =$8042669e
CONST MUIV_Font_Inherit = 0
CONST MUIV_Font_Normal = -1
CONST MUIV_Font_List = -2
CONST MUIV_Font_Tiny = -3
CONST MUIV_Font_Fixed = -4
CONST MUIV_Font_Title = -5
CONST MUIV_Font_Big = -6
CONST MUIV_Frame_None = 0
CONST MUIV_Frame_Button = 1
CONST MUIV_Frame_ImageButton = 2
CONST MUIV_Frame_Text = 3
CONST MUIV_Frame_String = 4
CONST MUIV_Frame_ReadList = 5
CONST MUIV_Frame_InputList = 6
CONST MUIV_Frame_Prop = 7
CONST MUIV_Frame_Gauge = 8
CONST MUIV_Frame_Group = 9
CONST MUIV_Frame_PopUp = 10
CONST MUIV_Frame_Virtual = 11
CONST MUIV_Frame_Slider = 12
CONST MUIV_Frame_Count = 13
CONST MUIV_InputMode_None = 0
CONST MUIV_InputMode_RelVerify = 1
CONST MUIV_InputMode_Immediate = 2
CONST MUIV_InputMode_Toggle = 3
CONST MUIA_Rectangle_HBar             =$8042c943
CONST MUIA_Rectangle_VBar             =$80422204
CONST MUIA_Image_FontMatch            =$8042815d
CONST MUIA_Image_FontMatchHeight      =$80429f26
CONST MUIA_Image_FontMatchWidth       =$804239bf
CONST MUIA_Image_FreeHoriz            =$8042da84
CONST MUIA_Image_FreeVert             =$8042ea28
CONST MUIA_Image_OldImage             =$80424f3d
CONST MUIA_Image_Spec                 =$804233d5
CONST MUIA_Image_State                =$8042a3ad
CONST MUIA_Bitmap_Bitmap              =$804279bd
CONST MUIA_Bitmap_Height              =$80421560
CONST MUIA_Bitmap_MappingTable        =$8042e23d
CONST MUIA_Bitmap_SourceColors        =$80425360
CONST MUIA_Bitmap_Transparent         =$80422805
CONST MUIA_Bitmap_Width               =$8042eb3a
CONST MUIA_Bodychunk_Body             =$8042ca67
CONST MUIA_Bodychunk_Compression      =$8042de5f
CONST MUIA_Bodychunk_Depth            =$8042c392
CONST MUIA_Bodychunk_Masking          =$80423b0e
CONST MUIA_Text_Contents              =$8042f8dc
CONST MUIA_Text_HiChar                =$804218ff
CONST MUIA_Text_PreParse              =$8042566d
CONST MUIA_Text_SetMax                =$80424d0a
CONST MUIA_Text_SetMin                =$80424e10
CONST MUIA_String_Accept              =$8042e3e1
CONST MUIA_String_Acknowledge         =$8042026c
CONST MUIA_String_AttachedList        =$80420fd2
CONST MUIA_String_BufferPos           =$80428b6c
CONST MUIA_String_Contents            =$80428ffd
CONST MUIA_String_DisplayPos          =$8042ccbf
CONST MUIA_String_EditHook            =$80424c33
CONST MUIA_String_Format              =$80427484
CONST MUIA_String_Integer             =$80426e8a
CONST MUIA_String_MaxLen              =$80424984
CONST MUIA_String_Reject              =$8042179c
CONST MUIA_String_Secret              =$80428769
CONST MUIV_String_Format_Left = 0
CONST MUIV_String_Format_Center = 1
CONST MUIV_String_Format_Right = 2
CONST MUIA_Prop_Entries               =$8042fbdb
CONST MUIA_Prop_First                 =$8042d4b2
CONST MUIA_Prop_Horiz                 =$8042f4f3
CONST MUIA_Prop_Slider                =$80429c3a
CONST MUIA_Prop_Visible               =$8042fea6
CONST MUIA_Gauge_Current              =$8042f0dd
CONST MUIA_Gauge_Divide               =$8042d8df
CONST MUIA_Gauge_Horiz                =$804232dd
CONST MUIA_Gauge_InfoText             =$8042bf15
CONST MUIA_Gauge_Max                  =$8042bcdb
CONST MUIA_Scale_Horiz                =$8042919a
CONST MUIA_Boopsi_Class               =$80426999
CONST MUIA_Boopsi_ClassID             =$8042bfa3
CONST MUIA_Boopsi_MaxHeight           =$8042757f
CONST MUIA_Boopsi_MaxWidth            =$8042bcb1
CONST MUIA_Boopsi_MinHeight           =$80422c93
CONST MUIA_Boopsi_MinWidth            =$80428fb2
CONST MUIA_Boopsi_Object              =$80420178
CONST MUIA_Boopsi_Remember            =$8042f4bd
CONST MUIA_Boopsi_Smart               =$8042b8d7
CONST MUIA_Boopsi_TagDrawInfo         =$8042bae7
CONST MUIA_Boopsi_TagScreen           =$8042bc71
CONST MUIA_Boopsi_TagWindow           =$8042e11d
CONST MUIA_Colorfield_Blue            =$8042d3b0
CONST MUIA_Colorfield_Green           =$80424466
CONST MUIA_Colorfield_Pen             =$8042713a
CONST MUIA_Colorfield_Red             =$804279f6
CONST MUIA_Colorfield_RGB             =$8042677a
CONST MUIM_List_Clear                =$8042ad89
CONST MUIM_List_Exchange             =$8042468c
CONST MUIM_List_GetEntry             =$804280ec
CONST MUIM_List_Insert               =$80426c87
CONST MUIM_List_InsertSingle         =$804254d5
CONST MUIM_List_Jump                 =$8042baab
CONST MUIM_List_NextSelected         =$80425f17
CONST MUIM_List_Redraw               =$80427993
CONST MUIM_List_Remove               =$8042647e
CONST MUIM_List_Select               =$804252d8
CONST MUIM_List_Sort                 =$80422275
CONST MUIM_List_Move                  =$804253c2
CONST MUIA_List_Active                =$8042391c
CONST MUIA_List_AdjustHeight          =$8042850d
CONST MUIA_List_AdjustWidth           =$8042354a
CONST MUIA_List_CompareHook           =$80425c14
CONST MUIA_List_ConstructHook         =$8042894f
CONST MUIA_List_DestructHook          =$804297ce
CONST MUIA_List_DisplayHook           =$8042b4d5
CONST MUIA_List_Entries               =$80421654
CONST MUIA_List_First                 =$804238d4
CONST MUIA_List_Format                =$80423c0a
CONST MUIA_List_MultiTestHook         =$8042c2c6
CONST MUIA_List_Quiet                 =$8042d8c7
CONST MUIA_List_SourceArray           =$8042c0a0
CONST MUIA_List_Title                 =$80423e66
CONST MUIA_List_Visible               =$8042191f
CONST MUIA_List_InsertPosition        =$8042d0cd
CONST MUIV_List_Active_Off = -1
CONST MUIV_List_Active_Top = -2
CONST MUIV_List_Active_Bottom = -3
CONST MUIV_List_Active_Up = -4
CONST MUIV_List_Active_Down = -5
CONST MUIV_List_Active_PageUp = -6
CONST MUIV_List_Active_PageDown = -7
CONST MUIV_List_ConstructHook_String = -1
CONST MUIV_List_CopyHook_String = -1
CONST MUIV_List_CursorType_None = 0
CONST MUIV_List_CursorType_Bar = 1
CONST MUIV_List_CursorType_Rect = 2
CONST MUIV_List_DestructHook_String = -1
CONST MUIA_Floattext_Justify          =$8042dc03
CONST MUIA_Floattext_SkipChars        =$80425c7d
CONST MUIA_Floattext_TabSize          =$80427d17
CONST MUIA_Floattext_Text             =$8042d16a
CONST MUIM_Dirlist_ReRead            =$80422d71
CONST MUIA_Dirlist_AcceptPattern      =$8042760a
CONST MUIA_Dirlist_Directory          =$8042ea41
CONST MUIA_Dirlist_DrawersOnly        =$8042b379
CONST MUIA_Dirlist_FilesOnly          =$8042896a
CONST MUIA_Dirlist_FilterDrawers      =$80424ad2
CONST MUIA_Dirlist_FilterHook         =$8042ae19
CONST MUIA_Dirlist_MultiSelDirs       =$80428653
CONST MUIA_Dirlist_NumBytes           =$80429e26
CONST MUIA_Dirlist_NumDrawers         =$80429cb8
CONST MUIA_Dirlist_NumFiles           =$8042a6f0
CONST MUIA_Dirlist_Path               =$80426176
CONST MUIA_Dirlist_RejectIcons        =$80424808
CONST MUIA_Dirlist_RejectPattern      =$804259c7
CONST MUIA_Dirlist_SortDirs           =$8042bbb9
CONST MUIA_Dirlist_SortHighLow        =$80421896
CONST MUIA_Dirlist_SortType           =$804228bc
CONST MUIA_Dirlist_Status             =$804240de
CONST MUIV_Dirlist_SortDirs_First = 0
CONST MUIV_Dirlist_SortDirs_Last = 1
CONST MUIV_Dirlist_SortDirs_Mix = 2
CONST MUIV_Dirlist_SortType_Name = 0
CONST MUIV_Dirlist_SortType_Date = 1
CONST MUIV_Dirlist_SortType_Size = 2
CONST MUIV_Dirlist_Status_Invalid = 0
CONST MUIV_Dirlist_Status_Reading = 1
CONST MUIV_Dirlist_Status_Valid = 2
CONST MUIA_Group_ActivePage           =$80424199
CONST MUIA_Group_Child                =$804226e6
CONST MUIA_Group_Columns              =$8042f416
CONST MUIA_Group_Horiz                =$8042536b
CONST MUIA_Group_HorizSpacing         =$8042c651
CONST MUIA_Group_PageMode             =$80421a5f
CONST MUIA_Group_Rows                 =$8042b68f
CONST MUIA_Group_SameHeight           =$8042037e
CONST MUIA_Group_SameSize             =$80420860
CONST MUIA_Group_SameWidth            =$8042b3ec
CONST MUIA_Group_Spacing              =$8042866d
CONST MUIA_Group_VertSpacing          =$8042e1bf
CONST MUIV_Group_ActivePage_First = 0
CONST MUIV_Group_ActivePage_Last = -1
CONST MUIV_Group_ActivePage_Prev = -2
CONST MUIV_Group_ActivePage_Next = -3
CONST MUIA_Register_Frame             =$8042349b
CONST MUIA_Register_Titles            =$804297ec
CONST MUIA_Virtgroup_Height           =$80423038
CONST MUIA_Virtgroup_Left             =$80429371
CONST MUIA_Virtgroup_Top              =$80425200
CONST MUIA_Virtgroup_Width            =$80427c49
CONST MUIA_Scrollgroup_Contents       =$80421261
CONST MUIA_Scrollgroup_FreeHoriz      =$804292f3
CONST MUIA_Scrollgroup_FreeVert       =$804224f2
CONST MUIA_Listview_ClickColumn       =$8042d1b3
CONST MUIA_Listview_DefClickColumn    =$8042b296
CONST MUIA_Listview_DoubleClick       =$80424635
CONST MUIA_Listview_Input             =$8042682d
CONST MUIA_Listview_List              =$8042bcce
CONST MUIA_Listview_MultiSelect       =$80427e08
CONST MUIA_Listview_ScrollerPos       =$8042b1b4
CONST MUIA_Listview_SelectChange      =$8042178f
CONST MUIV_Listview_MultiSelect_None    = 0
CONST MUIV_Listview_MultiSelect_Default = 1
CONST MUIV_Listview_MultiSelect_Shifted = 2
CONST MUIV_Listview_MultiSelect_Always  = 3
CONST MUIV_Listview_ScrollerPos_Default = 0
CONST MUIV_Listview_ScrollerPos_Left    = 1
CONST MUIV_Listview_ScrollerPos_Right   = 2
CONST MUIA_Radio_Active               =$80429b41
CONST MUIA_Radio_Entries              =$8042b6a1
CONST MUIA_Cycle_Active               =$80421788
CONST MUIA_Cycle_Entries              =$80420629
CONST MUIV_Cycle_Active_Next = -1
CONST MUIV_Cycle_Active_Prev = -2
CONST MUIA_Slider_Level               =$8042ae3a
CONST MUIA_Slider_Max                 =$8042d78a
CONST MUIA_Slider_Min                 =$8042e404
CONST MUIA_Slider_Quiet               =$80420b26
CONST MUIA_Slider_Reverse             =$8042f2a0
CONST MUIA_Coloradjust_Blue           =$8042b8a3
CONST MUIA_Coloradjust_Green          =$804285ab
CONST MUIA_Coloradjust_ModeID         =$8042ec59
CONST MUIA_Coloradjust_Red            =$80420eaa
CONST MUIA_Coloradjust_RGB            =$8042f899
CONST MUIA_Palette_Entries            =$8042a3d8
CONST MUIA_Palette_Groupable          =$80423e67
CONST MUIA_Palette_Names              =$8042c3a2
CONST MUIM_Popstring_Close           =$8042dc52
CONST MUIM_Popstring_Open            =$804258ba
CONST MUIA_Popstring_Button           =$8042d0b9
CONST MUIA_Popstring_CloseHook        =$804256bf
CONST MUIA_Popstring_OpenHook         =$80429d00
CONST MUIA_Popstring_String           =$804239ea
CONST MUIA_Popstring_Toggle           =$80422b7a
CONST MUIA_Popobject_Follow           =$80424cb5
CONST MUIA_Popobject_Light            =$8042a5a3
CONST MUIA_Popobject_Object           =$804293e3
CONST MUIA_Popobject_ObjStrHook       =$8042db44
CONST MUIA_Popobject_StrObjHook       =$8042fbe1
CONST MUIA_Popobject_Volatile         =$804252ec
CONST MUIA_Popobject_WindowHook       =$8042f194
CONST MUIA_Poplist_Array              =$8042084c
CONST MUIA_Popasl_Active              =$80421b37
CONST MUIA_Popasl_StartHook           =$8042b703
CONST MUIA_Popasl_StopHook            =$8042d8d2
CONST MUIA_Popasl_Type                =$8042df3d
CONST MUI_MAXMAX = 10000
CONST MADF_DRAWOBJECT = 1
CONST MADF_DRAWUPDATE = 2
CONST MPEN_SHINE      = 0
CONST MPEN_HALFSHINE  = 1
CONST MPEN_BACKGROUND = 2
CONST MPEN_HALFSHADOW = 3
CONST MPEN_SHADOW     = 4
CONST MPEN_TEXT       = 5
CONST MPEN_FILL       = 6
CONST MPEN_ACTIVEOBJ  = 7
CONST MPEN_COUNT      = 8
CONST MUIKEY_RELEASE    = -2
CONST MUIKEY_NONE       = -1
CONST MUIKEY_PRESS       = 0
CONST MUIKEY_TOGGLE      = 1
CONST MUIKEY_UP          = 2
CONST MUIKEY_DOWN        = 3
CONST MUIKEY_PAGEUP      = 4
CONST MUIKEY_PAGEDOWN    = 5
CONST MUIKEY_TOP         = 6
CONST MUIKEY_BOTTOM      = 7
CONST MUIKEY_LEFT        = 8
CONST MUIKEY_RIGHT       = 9
CONST MUIKEY_WORDLEFT   = 10
CONST MUIKEY_WORDRIGHT  = 11
CONST MUIKEY_LINESTART  = 12
CONST MUIKEY_LINEEND    = 13
CONST MUIKEY_GADGET_NEXT    = 14
CONST MUIKEY_GADGET_PREV    = 15
CONST MUIKEY_GADGET_OFF     = 16
CONST MUIKEY_WINDOW_CLOSE   = 17
CONST MUIKEY_WINDOW_NEXT    = 18
CONST MUIKEY_WINDOW_PREV    = 19
CONST MUIKEY_HELP           = 20
CONST MUIKEY_POPUP          = 21
CONST MUIKEY_COUNT          = 22

/**************************** MACROS *******************************/

#define MUIMASTER_NAME 'muimaster.library'

#define MUIC_Notify      'Notify.mui'
#define MUIC_Family      'Family.mui'
#define MUIC_Menustrip   'Menustrip.mui'
#define MUIC_Menu        'Menu.mui'
#define MUIC_Menuitem    'Menuitem.mui'
#define MUIC_Application 'Application.mui'
#define MUIC_Window      'Window.mui'
#define MUIC_Area        'Area.mui'
#define MUIC_Rectangle   'Rectangle.mui'
#define MUIC_Image       'Image.mui'
#define MUIC_Bitmap      'Bitmap.mui'
#define MUIC_Bodychunk   'Bodychunk.mui'
#define MUIC_Text        'Text.mui'
#define MUIC_String      'String.mui'
#define MUIC_Prop        'Prop.mui'
#define MUIC_Gauge       'Gauge.mui'
#define MUIC_Scale       'Scale.mui'
#define MUIC_Boopsi      'Boopsi.mui'
#define MUIC_Colorfield  'Colorfield.mui'
#define MUIC_List        'List.mui'
#define MUIC_Floattext   'Floattext.mui'
#define MUIC_Volumelist  'Volumelist.mui'
#define MUIC_Scrmodelist 'Scrmodelist.mui'
#define MUIC_Dirlist     'Dirlist.mui'
#define MUIC_Group       'Group.mui'
#define MUIC_Register    'Register.mui'
#define MUIC_Virtgroup   'Virtgroup.mui'
#define MUIC_Scrollgroup 'Scrollgroup.mui'
#define MUIC_Scrollbar   'Scrollbar.mui'
#define MUIC_Listview    'Listview.mui'
#define MUIC_Radio       'Radio.mui'
#define MUIC_Cycle       'Cycle.mui'
#define MUIC_Slider      'Slider.mui'
#define MUIC_Coloradjust 'Coloradjust.mui'
#define MUIC_Palette     'Palette.mui'
#define MUIC_Colorpanel  'Colorpanel.mui'
#define MUIC_Popstring   'Popstring.mui'
#define MUIC_Popobject   'Popobject.mui'
#define MUIC_Poplist     'Poplist.mui'
#define MUIC_Popasl      'Popasl.mui'

#define MUIX_R '\er'
#define MUIX_C '\ec'
#define MUIX_L '\el'
#define MUIX_N '\en'
#define MUIX_B '\eb'
#define MUIX_I '\ei'
#define MUIX_U '\eu'
#define MUIX_PT '\e2'
#define MUIX_PH '\e8'

#define MenustripObject   Mui_NewObjectA(MUIC_Menustrip,[TAG_IGNORE,0
#define MenuObject        Mui_NewObjectA(MUIC_Menu,[TAG_IGNORE,0
#define MenuObjectT(name) Mui_NewObjectA(MUIC_Menu,[MUIA_Menu_Title,name
#define MenuitemObject    Mui_NewObjectA(MUIC_Menuitem,[TAG_IGNORE,0
#define WindowObject      Mui_NewObjectA(MUIC_Window,[TAG_IGNORE,0
#define ImageObject       Mui_NewObjectA(MUIC_Image,[TAG_IGNORE,0
#define BitmapObject      Mui_NewObjectA(MUIC_Bitmap,[TAG_IGNORE,0
#define BodychunkObject   Mui_NewObjectA(MUIC_Bodychunk,[TAG_IGNORE,0
#define NotifyObject      Mui_NewObjectA(MUIC_Notify,[TAG_IGNORE,0
#define ApplicationObject Mui_NewObjectA(MUIC_Application,[TAG_IGNORE,0
#define TextObject        Mui_NewObjectA(MUIC_Text,[TAG_IGNORE,0
#define RectangleObject   Mui_NewObjectA(MUIC_Rectangle,[TAG_IGNORE,0
#define ListObject        Mui_NewObjectA(MUIC_List,[TAG_IGNORE,0
#define PropObject        Mui_NewObjectA(MUIC_Prop,[TAG_IGNORE,0
#define StringObject      Mui_NewObjectA(MUIC_String,[TAG_IGNORE,0
#define ScrollbarObject   Mui_NewObjectA(MUIC_Scrollbar,[TAG_IGNORE,0
#define ListviewObject    Mui_NewObjectA(MUIC_Listview,[TAG_IGNORE,0
#define RadioObject       Mui_NewObjectA(MUIC_Radio,[TAG_IGNORE,0
#define VolumelistObject  Mui_NewObjectA(MUIC_Volumelist,[TAG_IGNORE,0
#define FloattextObject   Mui_NewObjectA(MUIC_Floattext,[TAG_IGNORE,0
#define DirlistObject     Mui_NewObjectA(MUIC_Dirlist,[TAG_IGNORE,0
#define SliderObject      Mui_NewObjectA(MUIC_Slider,[TAG_IGNORE,0
#define CycleObject       Mui_NewObjectA(MUIC_Cycle,[TAG_IGNORE,0
#define GaugeObject       Mui_NewObjectA(MUIC_Gauge,[TAG_IGNORE,0
#define ScaleObject       Mui_NewObjectA(MUIC_Scale,[TAG_IGNORE,0
#define BoopsiObject      Mui_NewObjectA(MUIC_Boopsi,[TAG_IGNORE,0
#define ColorfieldObject  Mui_NewObjectA(MUIC_Colorfield,[TAG_IGNORE,0
#define ColorpanelObject  Mui_NewObjectA(MUIC_Colorpanel,[TAG_IGNORE,0
#define ColoradjustObject Mui_NewObjectA(MUIC_Coloradjust,[TAG_IGNORE,0
#define PaletteObject     Mui_NewObjectA(MUIC_Palette,[TAG_IGNORE,0
#define GroupObject       Mui_NewObjectA(MUIC_Group,[TAG_IGNORE,0
#define RegisterObject    Mui_NewObjectA(MUIC_Register,[TAG_IGNORE,0
#define VirtgroupObject   Mui_NewObjectA(MUIC_Virtgroup,[TAG_IGNORE,0
#define ScrollgroupObject Mui_NewObjectA(MUIC_Scrollgroup,[TAG_IGNORE,0
#define PopstringObject   Mui_NewObjectA(MUIC_Popstring,[TAG_IGNORE,0
#define PopobjectObject   Mui_NewObjectA(MUIC_Popobject,[TAG_IGNORE,0
#define PoplistObject     Mui_NewObjectA(MUIC_Poplist,[TAG_IGNORE,0
#define PopaslObject      Mui_NewObjectA(MUIC_Popasl,[TAG_IGNORE,0
#define ScrmodelistObject Mui_NewObjectA(MUIC_Scrmodelist,[TAG_IGNORE,0
#define VGroup            Mui_NewObjectA(MUIC_Group,[TAG_IGNORE,0
#define HGroup            Mui_NewObjectA(MUIC_Group,[MUIA_Group_Horiz,MUI_TRUE
#define ColGroup(cols)    Mui_NewObjectA(MUIC_Group,[MUIA_Group_Columns,(cols)
#define RowGroup(rows)    Mui_NewObjectA(MUIC_Group,[MUIA_Group_Rows   ,(rows)
#define PageGroup         Mui_NewObjectA(MUIC_Group,[MUIA_Group_PageMode,MUI_TRUE
#define VGroupV           Mui_NewObjectA(MUIC_Virtgroup,[TAG_IGNORE,0
#define HGroupV           Mui_NewObjectA(MUIC_Virtgroup,[MUIA_Group_Horiz,MUI_TRUE
#define ColGroupV(cols)   Mui_NewObjectA(MUIC_Virtgroup,[MUIA_Group_Columns,(cols)
#define RowGroupV(rows)   Mui_NewObjectA(MUIC_Virtgroup,[MUIA_Group_Rows   ,(rows)
#define PageGroupV        Mui_NewObjectA(MUIC_Virtgroup,[MUIA_Group_PageMode,MUI_TRUE
#define RegisterGroup(t)  Mui_NewObjectA(MUIC_Register,[MUIA_Register_Titles,(t)
#define End               TAG_DONE])

#define Child             MUIA_Group_Child
#define SubWindow         MUIA_Application_Window
#define WindowContents    MUIA_Window_RootObject

#define NoFrame          MUIA_Frame, MUIV_Frame_None
#define ButtonFrame      MUIA_Frame, MUIV_Frame_Button
#define ImageButtonFrame MUIA_Frame, MUIV_Frame_ImageButton
#define TextFrame        MUIA_Frame, MUIV_Frame_Text
#define StringFrame      MUIA_Frame, MUIV_Frame_String
#define ReadListFrame    MUIA_Frame, MUIV_Frame_ReadList
#define InputListFrame   MUIA_Frame, MUIV_Frame_InputList
#define PropFrame        MUIA_Frame, MUIV_Frame_Prop
#define SliderFrame      MUIA_Frame, MUIV_Frame_Slider
#define GaugeFrame       MUIA_Frame, MUIV_Frame_Gauge
#define VirtualFrame     MUIA_Frame, MUIV_Frame_Virtual
#define GroupFrame       MUIA_Frame, MUIV_Frame_Group
#define GroupFrameT(s)   MUIA_Frame, MUIV_Frame_Group, MUIA_FrameTitle, s
#define HVSpace           Mui_NewObjectA(MUIC_Rectangle,[TAG_DONE])
#define HSpace(x)         Mui_MakeObjectA(MUIO_HSpace,[x])
#define VSpace(x)         Mui_MakeObjectA(MUIO_VSpace,[x])
#define HCenter(obj)      HGroup, GroupSpacing(0), Child, HSpace(0), Child, (obj), Child, HSpace(0), End
#define VCenter(obj)      VGroup, GroupSpacing(0), Child, VSpace(0), Child, (obj), Child, VSpace(0), End
#define InnerSpacing(h,v) MUIA_InnerLeft,(h),MUIA_InnerRight,(h),MUIA_InnerTop,(v),MUIA_InnerBottom,(v)
#define GroupSpacing(x)   MUIA_Group_Spacing,x

#define StringMUI(contents,maxlen)\
        StringObject,\
                StringFrame,\
                MUIA_String_MaxLen  , maxlen,\
                MUIA_String_Contents, contents,\
                End

#define KeyString(contents,maxlen,controlchar)\
        StringObject,\
                StringFrame,\
                MUIA_ControlChar    , controlchar,\
                MUIA_String_MaxLen  , maxlen,\
                MUIA_String_Contents, contents,\
                End

#define CheckMark(selected)\
        ImageObject,\
                ImageButtonFrame,\
                MUIA_InputMode        , MUIV_InputMode_Toggle,\
                MUIA_Image_Spec       , MUII_CheckMark,\
                MUIA_Image_FreeVert   , MUI_TRUE,\
                MUIA_Selected         , selected,\
                MUIA_Background       , MUII_ButtonBack,\
                MUIA_ShowSelState     , FALSE,\
                End

#define KeyCheckMark(selected,control)\
        ImageObject,\
                ImageButtonFrame,\
                MUIA_InputMode        , MUIV_InputMode_Toggle,\
                MUIA_Image_Spec       , MUII_CheckMark,\
                MUIA_Image_FreeVert   , MUI_TRUE,\
                MUIA_Selected         , selected,\
                MUIA_Background       , MUII_ButtonBack,\
                MUIA_ShowSelState     , FALSE,\
                MUIA_ControlChar      , control,\
                End

#define SimpleButton(label) Mui_MakeObjectA(MUIO_Button,[label])

#define KeyButton(name,key)\
        TextObject,\
                ButtonFrame,\
                MUIA_Text_Contents, name,\
                MUIA_Text_PreParse, '\ec',\
                MUIA_Text_HiChar  , key,\
                MUIA_ControlChar  , key,\
                MUIA_InputMode    , MUIV_InputMode_RelVerify,\
                MUIA_Background   , MUII_ButtonBack,\
                End

#define Cycle(entries)        CycleObject, MUIA_Cycle_Entries, entries, End
#define KeyCycle(entries,key) CycleObject, MUIA_Cycle_Entries, entries, MUIA_ControlChar, key, End

#define Radio(name,array)\
        RadioObject,\
                GroupFrameT(name),\
                MUIA_Radio_Entries,array,\
                End

#define KeyRadio(name,array,key)\
        RadioObject,\
                GroupFrameT(name),\
                MUIA_Radio_Entries,array,\
                MUIA_ControlChar, key,\
                End

#define Slider(min,max,level)\
        SliderObject,\
                MUIA_Slider_Min  , min,\
                MUIA_Slider_Max  , max,\
                MUIA_Slider_Level, level,\
                End

#define KeySlider(min,max,level,key)\
        SliderObject,\
                MUIA_Slider_Min  , min,\
                MUIA_Slider_Max  , max,\
                MUIA_Slider_Level, level,\
                MUIA_ControlChar , key,\
                End

#define PopButton(img) Mui_MakeObjectA(MUIO_PopButton,[img])

#define Label(label)   Mui_MakeObjectA(MUIO_Label,[label,0])
#define Label1(label)  Mui_MakeObjectA(MUIO_Label,[label,MUIO_Label_SingleFrame])
#define Label2(label)  Mui_MakeObjectA(MUIO_Label,[label,MUIO_Label_DoubleFrame])
#define LLabel(label)  Mui_MakeObjectA(MUIO_Label,[label,MUIO_Label_LeftAligned])
#define LLabel1(label) Mui_MakeObjectA(MUIO_Label,[label,MUIO_Label_LeftAligned + MUIO_Label_SingleFrame])
#define LLabel2(label) Mui_MakeObjectA(MUIO_Label,[label,MUIO_Label_LeftAligned + MUIO_Label_DoubleFrame])

#define KeyLabel(label,key)   Mui_MakeObjectA(MUIO_Label,[label,key])
#define KeyLabel1(label,key)  Mui_MakeObjectA(MUIO_Label,[label,Or(MUIO_Label_SingleFrame,key)])
#define KeyLabel2(label,key)  Mui_MakeObjectA(MUIO_Label,[label,Or(MUIO_Label_DoubleFrame,key)])
#define KeyLLabel(label,key)  Mui_MakeObjectA(MUIO_Label,[label,Or(MUIO_Label_LeftAligned,key)])
#define KeyLLabel1(label,key) Mui_MakeObjectA(MUIO_Label,[label,Or(MUIO_Label_LeftAligned + MUIO_Label_SingleFrame,key)])
#define KeyLLabel2(label,key) Mui_MakeObjectA(MUIO_Label,[label,Or(MUIO_Label_LeftAligned + MUIO_Label_DoubleFrame,key)])

#define get(obj,attr,store) GetAttr(attr,obj,store)
#define set(obj,attr,value) SetAttrsA(obj,[Eval(`(attr)),value,TAG_DONE])
#define nnset(obj,attr,value) SetAttrsA(obj,[MUIA_NoNotify,MUI_TRUE,Eval(`(attr)),value,TAG_DONE])

#define setmutex(obj,n)     set(obj,MUIA_Radio_Active,n)
#define setcycle(obj,n)     set(obj,MUIA_Cycle_Active,n)
#define setstring(obj,s)    set(obj,MUIA_String_Contents,s)
#define setcheckmark(obj,b) set(obj,MUIA_Selected,b)
#define setslider(obj,l)    set(obj,MUIA_Slider_Level,l)

#define MUIP_BoopsiQuery MUI_BoopsiQuery

#define MUIV_Window_AltHeight_MinMax(p) (0-(p))
#define MUIV_Window_AltHeight_Visible(p) (-100-(p))
#define MUIV_Window_AltHeight_Screen(p) (-200-(p))
#define MUIV_Window_AltTopEdge_Delta(p) (-3-(p))
#define MUIV_Window_AltWidth_MinMax(p) (0-(p))
#define MUIV_Window_AltWidth_Visible(p) (-100-(p))
#define MUIV_Window_AltWidth_Screen(p) (-200-(p))
#define MUIV_Window_Height_MinMax(p) (0-(p))
#define MUIV_Window_Height_Visible(p) (-100-(p))
#define MUIV_Window_Height_Screen(p) (-200-(p))
#define MUIV_Window_TopEdge_Delta(p) (-3-(p))
#define MUIV_Window_Width_MinMax(p) (0-(p))
#define MUIV_Window_Width_Visible(p) (-100-(p))
#define MUIV_Window_Width_Screen(p) (-200-(p))

/*********************** ATTENTION **************************
  To use the following macros, <obj> MUST be a <var> (not a
  <varexp> or <exp>) and it  MUST be defined like:
  
  DEF obj:PTR TO <object>    or    DEF obj:<object>
  
  with <object> any possible OBJECT (e.g. __dummyxfc2__ )
 ************************************************************/

#define muiNotifyData(obj) obj::__dummyxfc2__.mnd
#define muiAreaData(obj)   obj::__dummyxfc2__.mad
#define muiGlobalInfo(obj) obj::__dummyxfc2__.mnd.mnd_GlobalInfo
#define muiUserData(obj)   obj::__dummyxfc2__.mnd.mnd_UserData
#define muiRenderInfo(obj) obj::__dummyxfc2__.mad.mad_RenderInfo

#define _app(obj)         (muiGlobalInfo(obj).mgi_ApplicationObject)
#define _win(obj)         (muiRenderInfo(obj).mri_WindowObject)
#define _dri(obj)         (muiRenderInfo(obj).mri_DrawInfo)
#define _window(obj)      (muiRenderInfo(obj).mri_Window)
#define _screen(obj)      (muiRenderInfo(obj).mri_Screen)
#define _rp(obj)          (muiRenderInfo(obj).mri_RastPort)
#define _left(obj)        (muiAreaData(obj).mad_Box.Left)
#define _top(obj)         (muiAreaData(obj).mad_Box.Top)
#define _width(obj)       (muiAreaData(obj).mad_Box.Width)
#define _height(obj)      (muiAreaData(obj).mad_Box.Height)
#define _right(obj)       (_left(obj)+_width(obj)-1)
#define _bottom(obj)      (_top(obj)+_height(obj)-1)
#define _addleft(obj)     (muiAreaData(obj).mad_addleft)
#define _addtop(obj)      (muiAreaData(obj).mad_addtop)
#define _subwidth(obj)    (muiAreaData(obj).mad_subwidth)
#define _subheight(obj)   (muiAreaData(obj).mad_subheight)
#define _mleft(obj)       (_left(obj)+_addleft(obj))
#define _mtop(obj)        (_top(obj)+_addtop(obj))
#define _mwidth(obj)      (_width(obj)-_subwidth(obj))
#define _mheight(obj)     (_height(obj)-_subheight(obj))
#define _mright(obj)      (_mleft(obj)+_mwidth(obj)-1)
#define _mbottom(obj)     (_mtop(obj)+_mheight(obj)-1)
#define _font(obj)        (muiAreaData(obj).mad_Font)
#define _flags(obj)       (muiAreaData(obj).mad_Flags)


