/**************************************************************************
 *                                                                        *
 * Section: Macros, Definitions, Includes, Structures                     *
 *                                                                        *
 **************************************************************************/

/************************************* Includes ***********/
#include <proto/exec.h>
#include <proto/dos.h>

/************************************* Defines ************/
#define TEMPLATE "FILE1/A,FILE2/A,-v=VERBOSE/S"

/************************************* Prototypes *********/
void perror(void);

/************************************* global Variables ***/
struct DosLibrary *DOSBase;

static const char __Version[] = "$VER: cmp 1.0 " __AMIGADATE__ ;

/**************************************************************************
 *                                                                        *
 * Section: Main()                                                        *
 *                                                                        *
 **************************************************************************/

int __saveds __asm main(void)
{
        struct Args {
                STRPTR file1;
                STRPTR file2;
                LONG verbose;
        } Args;
        struct RDArgs *RDArgs;
        BPTR fh1, fh2;
        LONG match = 20, c1, c2;

        if (DOSBase = (struct DosLibrary *) OpenLibrary(DOSNAME, 37L)) {
                if (RDArgs = ReadArgs(TEMPLATE, (LONG *) & Args, NULL)) {
                        if (fh1 = Open(Args.file1, MODE_OLDFILE)) {
                                if (fh2 = Open(Args.file2, MODE_OLDFILE)) {
                                        match = 0;
                                        do {
                                                c1 = FGetC(fh1);
                                                c2 = FGetC(fh2);
                                                if (c1 != c2) {
                                                        match = 1;
                                                        break;
                                                }
                                        } while(c1 != -1L);
                                        if (Args.verbose) {
                                                Printf("The two are %sindentical.\n", (match) ? "not " : "");
                                        }

                                        Close(fh2);
                                }
                                else
                                        perror();
                                Close(fh1);
                        }
                        else
                                perror();
                        FreeArgs(RDArgs);
                }
                else
                        perror();

                CloseLibrary((struct Library *) DOSBase);
        }

        return match;
}


void perror(void)
{
        PrintFault(IoErr(), "cmp");
}

