/*
 *      $Filename: banfile.c $
 *      $Revision: 3.0 $
 *      $Date: 1994/06/22 14:18:57 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: banfile.c,v 3.0 1994/06/22 14:18:57 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include <dos.h>
#include <proto/exec.h>

#include "listserv.h"

/************************************* defines ************/

/************************************* prototypes *********/

/************************************* global variables ***/
static char rcssid[] = "$Id: banfile.c,v 3.0 1994/06/22 14:18:57 simons Exp simons $";

/************************************* program ************/
int IsBanned(char *address, char *listname)
{
        BPTR banfile;
        char *banfilename, *addressline, *patternbuf;
        int banned = 0;

        if (!(banfilename = AllocMemPooled(256+1024+1024, 0L)))
                return 0;
        addressline = banfilename + 256;
        patternbuf = addressline + 1024;

        if (listname && *listname)
                sprintf(banfilename, "%s%s/Banned", LISTDIR, listname);
        else
                sprintf(banfilename, "%sBanned", SERVDIR);

        LockFile(banfilename);
        if (banfile = Open(banfilename, MODE_OLDFILE)) {
                while (FGets(banfile, addressline, 1024-1)) {
                        addressline[strlen(addressline)-1] = '\0';      /* remove the trailig newline */
                        if (ParsePatternNoCase(addressline, patternbuf, 1024) != -1L
                         && MatchPatternNoCase(patternbuf, address)) {
                                banned = 1;
                                break;
                        }
                }
                Close(banfile);
        }
        UnLockFile(banfilename);

        free(banfilename);
        return banned;
}
