/*
 *      $Filename: commands.c $
 *      $Revision: 3.1 $
 *      $Date: 1994/06/22 15:02:13 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: commands.c,v 3.1 1994/06/22 15:02:13 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include "listserv.h"
#include "protos.h"

/************************************* global variables ***/
static char rcsid[] = "$Id: commands.c,v 3.1 1994/06/22 15:02:13 simons Exp simons $";

/************************************* program ************/
void sendhelp(char *from, char *request)
{
        callmailer("", from, request);
        mailcat(HELPFILE,"");
        PClose(mailer);
        return;
        }

void listhelp(char *from,
              char *grp,
              char *request)
{
        char tmp[128];

        callmailer("", from, request);
        sprintf(tmp, "%s%s/Description", LISTDIR, grp);
        mailcat(tmp ,"");
        PClose(mailer);
        return;
        }

void sendindex(char *from,
               char *request,
               int longi)
{
        DIR *listdir;
        struct dirent *entry;
        char tmp[128];

#ifdef EVALUATION
        if (longi) {
                callmailer("", from, request);
                FPrintf(mailer, "Sorry, but this is only an evaluation version of ListSERV,\nwhich has the LONGINDEX command disabled. Please ask the\nadministrator to register. :-)\n");
                PClose(mailer);
                return;
        }
#endif

        listdir = opendir(LISTDIR);
        if (!listdir) {
                perror(LISTDIR);
                exit(1);
        }

        callmailer("", from, request);
        FPrintf(mailer, "------------------------ Index of mailing lists ----------------------\n");

        while (entry = readdir(listdir)) {
                FPrintf(mailer, "%s\n", entry->d_name);
#ifndef EVALUATION
                if (longi) {
                        sprintf(tmp, "%s%s/Description", LISTDIR, entry->d_name);
                        LockFile(tmp);
                        if(!access(tmp,R_OK)) {
                                UnLockFile(tmp);
                                mailcat(tmp, "     ");
                                FPrintf(mailer, "\n", entry->d_name);
                        }
                        else
                                UnLockFile(tmp);
                }
#endif
        }

        closedir(listdir);
        FPrintf(mailer, "----------------------------------------------------------------------\n");
        PClose(mailer);
        return;
}
