/*
 *      $Filename: faq.c $
 *      $Revision: 3.1 $
 *      $Date: 1994/06/22 15:02:13 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: faq.c,v 3.1 1994/06/22 15:02:13 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include "listserv.h"
#include "protos.h"

/************************************* global variables ***/
static char rcsid[] = "$Id: faq.c,v 3.1 1994/06/22 15:02:13 simons Exp simons $";

/************************************* program ************/
#ifndef EVALUATION
void sendfaq(char *from, char *command)
{
        int i;
        char grp[256], tmp[512];

        i = sscanf(command, "%s%s", tmp, grp);
        if (i == 1 && def_listname)
                strcpy(grp, def_listname);
        else if (i != 2) {
                sendhelp(from, command);
                return;
        }

        sprintf(tmp, "%s%s/FAQ", LISTDIR, grp);
        callmailer("", from, command);
        LockFile(tmp);
        if(access(tmp,R_OK) == 0) {
                UnLockFile(tmp);
                mailcat(tmp, "");
                PClose(mailer);
                return;
        }
        else {
                UnLockFile(tmp);
                FPrintf(mailer, "There is no FAQ available for mailing list \"%s\".\n", grp);
                PClose(mailer);
                return;
                }
        }


void faqindex(char *from,
              char *request)
{
        DIR *listdir;
        struct dirent *entry;
        char tmp[128];

        if (!(listdir = opendir(LISTDIR))) {
                perror(LISTDIR);
                exit(1);
        }

        callmailer("", from, request);
        FPrintf(mailer, "------------------------ Index of available FAQs ---------------------\n");

        while (entry = readdir(listdir)) {
                sprintf(tmp, "%s%s/FAQ", LISTDIR, entry->d_name);
                LockFile(tmp);
                if (!access(tmp, R_OK))
                        FPrintf(mailer, "%s\n", entry->d_name);
                UnLockFile(tmp);
        }
        closedir(listdir);

        FPrintf(mailer, "----------------------------------------------------------------------\n");
        PClose(mailer);
        return;
}

#else /* EVALUATION is defined */

void sendfaq(char *from, char *command)
{
        callmailer("", from, command);
        FPrintf(mailer, "Sorry, but this is only an evaluation version of\nListSERV, which has the FAQ command disabled.\nPlease ask the administrator to register. :-)\n");
        PClose(mailer);
}


void faqindex(char *from, char *request)
{
        callmailer("", from, request);
        FPrintf(mailer, "Sorry, but this is only an evaluation version of\nListSERV, which has the FAQ command disabled.\nPlease ask the administrator to register. :-)\n");
        PClose(mailer);
}

#endif
