/*
 * CopyDate 1.0
 *
 * written by Peter Simons <simons@peti.GUN.de>
 *
 *
 * CopyDate copies the filedate of one file to another. This may be useful
 * to preserve the date of files after certain file manipulations, such as
 * uudecoding, etc...
 *                                        written for Frank Bergknecht :-)
 */

#include <proto/exec.h>
#include <proto/dos.h>

#define TEMPLATE "SourceFile/A,DestFile/A"
#define PRGNAME "CopyDate"

void perror(void);

struct DosLibrary *DOSBase;
static const char __Version[] = "$VER: " PRGNAME " 1.0 " __AMIGADATE__;

int __saveds __asm main(void)
{
	struct Args {
		STRPTR file1;
		STRPTR file2;
	} Args;
	struct RDArgs *RDArgs;
	struct FileInfoBlock __aligned fib;
	BPTR fh;
	LONG rc = 20;

	if (DOSBase = (struct DosLibrary *) OpenLibrary(DOSNAME, 37L)) {
		if (RDArgs = ReadArgs(TEMPLATE, (LONG *) & Args, NULL)) {
			rc = 10;
			if (fh = Lock(Args.file1, ACCESS_READ)) {
				if (Examine(fh, &fib))
					if (SetFileDate(Args.file2, &fib.fib_Date))
						rc = 0;
					else
						perror();
				else
					perror();
				UnLock(fh);
			}
			else
				perror();
			FreeArgs(RDArgs);
		}
		else
			perror();

		CloseLibrary((struct Library *) DOSBase);
	}

	return rc;
}

void perror(void)
{
	PrintFault(IoErr(), PRGNAME);
}
