#ifndef MEMORYHANDLING_H
#define MEMORYHANDLING_H

/*
 * ATTENTION: These routines are for internal usage in the library ONLY!
 *
 */


/*
 * This routine returns a pointer to the task's static memory
 * structure. The fields MUST NOT be modified. If your routine
 * requires static data, tell me and I'll reserve a field for you.
 */
#pragma libcall NetSupportBase GetStaticBuffer 2A 0
struct StaticBuffer * __asm GetStaticBuffer(void);


/*
 * These routines are nearly equal to the routines publically
 * available. The only difference is that the allocations are tracked
 * on the internal memory list.
 *
 * That's why the library can determine if the task has not freed all
 * memory at exit time!
 */
void * __asm NSPAllocMemPooled(register __d0 ULONG, register __d1 ULONG);
int __asm NSPFreeMemPooled(register __a1 void *);


/*
 * StaticBuffer structure
 */
struct StaticBuffer {
        struct  StaticBuffer *nspsb_NextEntry;
        ULONG   nspsb_TaskID;
        void *  nspsb_InternalMemList;
        void *  nspsb_TaskMemList;
        void *  nspsb_GCEntryBuffer;
        struct List *   nspsb_LockedFileList;
        STRPTR  nspsb_TempNameBuffer;
        STRPTR  nspsb_NSPConfigName;
};


#endif /* MEMORYHANDLING_H */

