#ifndef _INLINE_NETSUPPORT_H
#define _INLINE_NETSUPPORT_H

/*
 *      $Filename: netsupport.h $
 *      $Version: 0.1 $
 *      $Date: 1994/06/10 18:03:49 $
 *      $Author: eku $
 *
 *      C inline file for the NetSupport.Library
 *
 *	To contact me send a mail to erik@amigo.tomcat.de
 */

#include <dos/dos.h>
#include <sys/cdefs.h>
#include <inline/stubs.h>

__BEGIN_DECLS

#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct NetSupportLibrary*  NetSupportBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME NetSupportBase
#endif

static __inline void *
AllocMemPooled (BASE_PAR_DECL ULONG size, ULONG attributs)
{
  BASE_EXT_DECL
  register void * _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register ULONG d0 __asm("d0") = size;
  register ULONG d1 __asm("d1") = attributs;
  __asm __volatile ("jsr a6@(-0x1e)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
FreeMemPooled (BASE_PAR_DECL void * MemBlock)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register void * a1 __asm("a1") = MemBlock;
  __asm __volatile ("jsr a6@(-0x24)"
  : "=r" (_res)
  : "r" (a6), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline STRPTR 
GetConfig (BASE_PAR_DECL STRPTR filename, STRPTR keyword, STRPTR dosvarname, STRPTR default_value)
{
  BASE_EXT_DECL
  register STRPTR  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  register STRPTR a1 __asm("a1") = keyword;
  register STRPTR a2 __asm("a2") = dosvarname;
  register STRPTR a3 __asm("a3") = default_value;
  __asm __volatile ("jsr a6@(-0x3c)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1), "r" (a2), "r" (a3)
  : "a0","a1","a2","a3","d0","d1", "memory");
  return _res;
}
static __inline STRPTR 
GetConfigEntry (BASE_PAR_DECL STRPTR filename, STRPTR keyword, STRPTR default_value)
{
  BASE_EXT_DECL
  register STRPTR  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  register STRPTR a1 __asm("a1") = keyword;
  register STRPTR a2 __asm("a2") = default_value;
  __asm __volatile ("jsr a6@(-0x30)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
static __inline ULONG 
GetSeq (BASE_PAR_DECL ULONG bump)
{
  BASE_EXT_DECL
  register ULONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register ULONG d0 __asm("d0") = bump;
  __asm __volatile ("jsr a6@(-0x72)"
  : "=r" (_res)
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
IsFileLocked (BASE_PAR_DECL STRPTR filename)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  __asm __volatile ("jsr a6@(-0x5a)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
LockFile (BASE_PAR_DECL STRPTR filename)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  __asm __volatile ("jsr a6@(-0x42)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
LockFileAttempt (BASE_PAR_DECL STRPTR filename)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  __asm __volatile ("jsr a6@(-0x54)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void 
MakeLogEntry (BASE_PAR_DECL STRPTR system, ULONG class, STRPTR logmessage, APTR **parameter)
{
  BASE_EXT_DECL
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = system;
  register ULONG d0 __asm("d0") = class;
  register STRPTR a1 __asm("a1") = logmessage;
  register APTR ** a2 __asm("a2") = parameter;
  __asm __volatile ("jsr a6@(-0x36)"
  : /* no output */
  : "r" (a6), "r" (a0), "r" (d0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
}
static __inline LONG 
PClose (BASE_PAR_DECL BPTR pipehandle)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register BPTR d0 __asm("d0") = pipehandle;
  __asm __volatile ("jsr a6@(-0x7e)"
  : "=r" (_res)
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline BPTR 
POpen (BASE_PAR_DECL STRPTR command, LONG mode)
{
  BASE_EXT_DECL
  register BPTR  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = command;
  register LONG d0 __asm("d0") = mode;
  __asm __volatile ("jsr a6@(-0x78)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
SetConfigEntry (BASE_PAR_DECL STRPTR filename, STRPTR keyword, STRPTR parameter)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  register STRPTR a1 __asm("a1") = keyword;
  register STRPTR a2 __asm("a2") = parameter;
  __asm __volatile ("jsr a6@(-0x60)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
static __inline STRPTR 
TempName (BASE_PAR_DECL STRPTR buffer)
{
  BASE_EXT_DECL
  register STRPTR  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR  a0 __asm("a0") = buffer;
  __asm __volatile ("jsr a6@(-0x66)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline STRPTR 
TempNameT (BASE_PAR_DECL STRPTR buffer)
{
  BASE_EXT_DECL
  register STRPTR  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = buffer;
  __asm __volatile ("jsr a6@(-0x6c)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
UnLockFile (BASE_PAR_DECL STRPTR filename)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  register STRPTR a0 __asm("a0") = filename;
  __asm __volatile ("jsr a6@(-0x48)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
UnLockFiles (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct NetSupportLibrary* a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x4e)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME

__END_DECLS

#endif /* _INLINE_NETSUPPORT_H */
