        IFND    LIBRARIES_NETSUPPORT_I
LIBRARIES_NETSUPPORT_I  EQU     1

*
*       $Filename: netsupport.i $
*       $Version: 1.25 $
*       $Date: 1994/03/12 $
*       $Author: simons $
*
*       Assembler include file for the NetSupport.Library
*


;-------------------------------------- Macros -------------
        IFND EXEC_LIBRARIES_I
                INCLUDE "exec/libraries.i"
        ENDC
        IFND EXEC_SEMAPHORES_I
                INCLUDE "exec/semaphores.i"
        ENDC
        IFND UTILITY_TAGITEM_I
                INCLUDE "utility/tagitem.i"
        ENDC

;-------------------------------------- Offsets -------------
                LIBINIT
                LIBDEF  _LVOAllocMemPooled
                LIBDEF  _LVOFreeMemPooled
                LIBDEF  _LVONSPPrivate1
                LIBDEF  _LVOGetConfigEntry
                LIBDEF  _LVOMakeLogEntry
                LIBDEF  _LVOGetConfig
                LIBDEF  _LVOLockFile
                LIBDEF  _LVOUnLockFile
                LIBDEF  _LVOUnLockFiles
                LIBDEF  _LVOLockFileAttempt
                LIBDEF  _LVOIsFileLocked
                LIBDEF  _LVOSetConfigEntry
                LIBDEF  _LVOTempName
                LIBDEF  _LVOTempNameT
                LIBDEF  _LVOGetSeq
                LIBDEF  _LVOPOpen
                LIBDEF  _LVOPClose

;-------------------------------------- LibraryName --------
NETSUPPORTNAME  MACRO
                CSTR    "netsupport.library"
                EVEN
                ENDM

;-------------------------------------- LibraryBase --------
            STRUCTURE NetSupportLibrary,LIB_SIZE
                ULONG   nsp_DOSBase
                ULONG   nsp_SegList
                ULONG   nsp_StaticBufferSemaphore
                ULONG   nsp_StaticBufferList
                ULONG   nsp_UtilityBase
                ULONG   nsp_UniqueNumber
                ULONG   nsp_AnyMemPoolSemaphore
                ULONG   nsp_AnyMemPool
                ULONG   nsp_obsolete
                STRUCT  nsp_ResModules,MLH_SIZE
                ULONG   nsp_ResidentListSemaphore
                STRUCT  nsp_MsgPortList,MLH_SIZE
                ULONG   nsp_MsgPortListSemaphore
                LABEL   nsp_SIZEOF


;-------------------------------------- GetConfig ----------
                ; I didn't have enough time to convert these defines
                ; to macros. If someone wants to volunteer? :-)
                ;                                       -peter
*
* Here's a bunch of defines for common keywords used in the UUCP
* main config file. All these keywords have an equivalent of the same
* name as local/global variable and you should support them!
*
*
* #define USERNAME        "UserName"
* #define NODENAME        "NodeName"
* #define REALNAME        "RealName"
* #define DEBUGNAME       "Debug"
* #define NEWSFEED        "NewsFeed"
* #define ORGANIZATION    "Organization"
* #define FILTER          "Filter"
* #define RFILTER         "RFilter"
* #define EDITOR          "MailEditor"
* #define NEWSEDITOR      "NewsEditor"
* #define DOMAINNAME      "DomainName"
* #define TIMEZONE        "TimeZone"
* #define DEFAULTNODE     "DefaultNode"
* #define MAILREADYCMD    "MailReadyCmd"
* #define NEWSREADYCMD    "NewsReadyCmd"
* #define AUTOBATCH       "AutoBatch"
* #define MAXRMAILLEN     "MaxRMailLen"
* #define BATCHBITS       "BatchBits"
* #define MAILBOUNCE      "MailBounce"
* #define DOMAINPATH      "DomainPath"
* #define SPOOLSIZE       "SpoolSize"
* #define MUNGECASE       "MungeCase"
* #define JUNKSAVE        "JunkSave"
*
*
*  /*
*   * The following keywords are paths and names of executables. The
*   * default value is always the name of the keyword, eg. "Sendmail".
*   */
*
* #define BATCHNEWS       "BatchNews"
* #define UUX             "Uux"
* #define SENDMAIL        "Sendmail"
* #define POSTNEWS        "Postnews"
* #define UUXQT           "Uuxqt"
* #define RMAIL           "RMail"
* #define CUNBATCH        "CUnbatch"
* #define RNEWS           "RNews"
* #define FRNEWS          "FRNews"
* #define RSMTP           "RSMTP"
* #define RCSMTP          "RCSMTP"
*
*
*  /*
*   * The following keywords are directory paths. The common default
*   * value is specified as comment behing the keyword.
*   */
*
* #define UUSPOOL         "UUSpool"       /* "UUSPOOL:"    */
* #define UUNEWS          "UUNews"        /* "UUNEWS:"     */
* #define UUMAIL          "UUMail"        /* "UUMAIL:"     */
* #define UULIB           "UULib"         /* "UULIB:"      */
* #define UUPUB           "UUPub"         /* "UUPUB:"      */
* #define UUMAN           "UUMan"         /* "UUMAN:"      */
* #define SUUCP           "UUCP"          /* "UUCP:"       */
* #define UUALTSPOOL      "UUAltSpool"    /* "UUALTSPOOL:" */
* #define LOCKDIR         "LockDir"       /* "T:"          */

;-------------------------------------- POpen --------------
MODE_PIPETO     equ     $00000000
MODE_PIPEFROM   equ     $00000001


;-------------------------------------- MakeLogEntry -------
MLE_DEFAULT     equ      0
MLE_INFO        equ      5
MLE_DEBUG1      equ     11
MLE_DEBUG2      equ     12
MLE_DEBUG3      equ     13
MLE_DEBUG4      equ     14
MLE_DEBUG5      equ     15
MLE_DEBUG6      equ     16
MLE_DEBUG7      equ     17
MLE_DEBUG8      equ     18
MLE_DEBUG9      equ     19
MLE_ERROR       equ     50
MLE_FATAL_ERROR equ     -1


        ENDC    ; LIBRARIES_NETSUPPORT_I

