/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
NODE * __regargs GetHead(LIST *list)
{	if(list && list->lh_Head && list->lh_Head->ln_Succ)
		return(list->lh_Head);
	return(NULL);	
}

LIST * __regargs GetListHeader(NODE * node)
{
	if(!node)
		return(NULL);
	while(node && node->ln_Succ)
		node = node->ln_Succ;
	return((LIST *)( ((ULONG)node) - offsetof(struct List,lh_Tail)));
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
/*
 * $Id: nn_filesize.c,v 1.4 93/10/20 18:11:28 wasp Exp Locker: wasp $
 *
 *  by Walter Mildenberger in 1992-1993; All Rights reserved
 *
 * $Log:	nn_filesize.c,v $
 * Revision 1.4  93/10/20  18:11:28  wasp
 * peanuts
 * 
 * Revision 1.3  92/04/26  20:29:19  wasp
 * *** empty log message ***
 * 
 * Revision 1.2  92/03/23  20:33:58  wasp
 * MyEnv now declared as far
 * 
 * Revision 1.1  92/03/11  18:08:12  wasp
 * Initial revision
 * 
 */

#include "nn.h"

Prototype LONG __regargs GetFileSize(FILE *fp,char *name);

/* GetFileSize()
 *		gets the size of a file:
 *		either an already opened level-2 file (FILE *fh != NULL),
 *		or the (complete) name of the file!
 */
LONG __regargs GetFileSize(FILE *fp,char *name)
{	struct FileInfoBlock __aligned fib;
	BPTR lock;
	LONG size = 0, pos;
	CALLED("GetFileSize");
	if(fp)
	{	pos = ftell(fp);
		fseek(fp,0,2);
		size = ftell(fp);
		fseek(fp,pos,0);
		clrerr(fp);
	}
	else
	{	if(lock = Lock(name,SHARED_LOCK))
		{	if(Examine(lock,&fib))
				size = fib.fib_Size;
			UnLock(lock);
		}
	}
	return size;
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
void * __regargs mymalloc(int size)
{	void * ptr;
	register long mem;

	CALLED("mymalloc");
redo:
	mem  = AvailMem(0L);
	if(mem > LOW_MEM_LIMIT)
		ptr = malloc(size);
	else
	{	ptr = NULL;
		DDEBUG(0,__FILE__ "(%d) AvailMem() returned %ld, actual limit is %ld",__LINE__,mem,(long)LOW_MEM_LIMIT);
	}
	if(!ptr)
	{	if(AutoRequest(MyEnv.AnnWindow,&lowMem[0],&lowMem[1],&lowMem[2],0L,0L,-320,100L))
			goto redo;
	}
	if(ptr)
		memclr(ptr,size);
	else
		DDEBUG(0,__FILE__ "(%d) mymalloc(%ld) failed !",__LINE__,size);
	
	return(ptr);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
/*
 * $Id: nn_time.c,v 1.7 93/10/20 18:15:19 wasp Exp Locker: wasp $
 *
 *  by Walter Mildenberger in 1992-1993; All Rights reserved
 *
 * $Log:	nn_time.c,v $
 * Revision 1.7  93/10/20  18:15:19  wasp
 * peanuts
 * 
 * Revision 1.6  92/11/05  19:16:49  wasp
 * some minor changes...
 * 
 * Revision 1.5  92/04/26  20:31:01  wasp
 * changed back to hhmm-format, but displays GMT for +0000
 * 
 * Revision 1.4  92/03/23  20:36:03  wasp
 * MyEnv now declared as far
 * 
 * Revision 1.3  92/03/20  22:50:39  wasp
 * MyEnv dereferred as far
 * 
 * Revision 1.2  92/03/15  19:04:46  wasp
 * uses gmt instead of local
 * 
 * Revision 1.1  92/03/11  18:07:30  wasp
 * Initial revision
 * 
 */

#include "nn.h"

Prototype void __regargs SPrintRFCtime(time_t mytime, char *timestr);
Prototype void __regargs SetRFCtime(char *timestr);

static char *dotw[ 7] = {	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
static char *moty[12] = {	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
       			            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

extern struct Environment far MyEnv;

void __regargs SPrintRFCtime(time_t mytime, char *timestr)
{	time_t t;
	struct tm *lt;
	CALLED("PrintRFCtime");
	t = mytime;
	lt = localtime(&t);
//	lt = gmtime(&t);
	sprintf(timestr,"%s, %02d %s %4d %02d:%02d:%02d %s",dotw[lt->tm_wday],lt->tm_mday,
	moty[lt->tm_mon],1900+lt->tm_year,lt->tm_hour,lt->tm_min,lt->tm_sec,((strncmp("+0000",MyEnv.TZOFFS,5)==0) ? "GMT" : MyEnv.TZOFFS));
}

void __regargs SetRFCtime(char *timestr)
{
	CALLED("SetRFCtime");
	SPrintRFCtime(time(NULL),timestr);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
/*
 * $Id: nn_var.c,v 1.4 93/10/20 18:15:29 wasp Exp Locker: wasp $
 *
 *  by Walter Mildenberger in 1992-1993; All Rights reserved.
 *
 * $Log:	nn_var.c,v $
 * Revision 1.4  93/10/20  18:15:29  wasp
 * peanuts
 * 
 * Revision 1.3  92/11/05  19:17:24  wasp
 * heavy modified...
 * 
 * Revision 1.2  92/10/23  15:50:55  wasp
 * Moved GetGlobalVar and myGetEnv() from config.c to this extra file.
 * 
 * Revision 1.1  92/10/23  15:48:56  wasp
 * Initial revision
 * 
 */

#include "nn.h"

Prototype char * __regargs GetGlobalVar(char *varname,char *progname);
Prototype char * __regargs myGetEnv(char *varname,char *progname);

static char var_buf[80];

char * __regargs GetGlobalVar(char *varname,char *progname)
{	FILE *env = NULL;
	short int len;
	strcpy(var_buf,"ENV:");
	if((progname) && (strlen(progname)))
	{	strcat(var_buf,progname);
		strcat(var_buf,"/");
		strcat(var_buf,varname);
		env = fopen(var_buf,"r");
	}
	if(!env)
	{	strcpy(var_buf,"ENV:");
		strcat(var_buf,varname);
		env = fopen(var_buf,"r");
	}
	if(env)
	{	fgets(var_buf,sizeof(var_buf),env);
		fclose(env);
		if(len = strlen(var_buf))
		{	if(var_buf[--len] == '\n')
			{	var_buf[len] = '\0';
			}
		}
		return(var_buf);
	}
	else
		return(NULL);
}

char * __regargs myGetEnv(char *varname,char *progname)
{	LONG len = -1;
	if(MyEnv.flags.DOS2)			/* suche erst set ann/<varname> , */
	{	if((progname) && (strlen(progname)))
		{	strcpy(var_buf,progname);	/* dann set <varname>, dann */
			strcat(var_buf,"/");
			strcat(var_buf,varname); /* setenv ann/<varname>, dann setenv <varname> */
			len = GetVar(varname,var_buf,sizeof(var_buf),GVF_LOCAL_ONLY);
		}
		if(len == -1L)
		{	strcpy(var_buf,varname);
			len = GetVar(varname,var_buf,sizeof(var_buf),GVF_LOCAL_ONLY);
		}
	}
	if(len == -1)
		return(GetGlobalVar(varname,progname));
	else
		return(var_buf);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
	if(Z->header[HK_FROM])
	{	if(ptr = strchr(Z->header[HK_FROM],'(')) /* From: in der Form user@node ($Realname) */
		{	 stccpy(realname,stpblk(ptr+1),sizeof(realname));
			 if(ptr = strrchr(realname,')'))
				 *ptr = 0;
		}
		else /* From in der Form $Realname <user@node> */
		{	stccpy(realname,stpblk(Z->header[HK_FROM]),sizeof(realname));
			if(ptr = strchr(realname,'<'))
				*ptr = 0;
		}
		if(realname[0] == '\0')
			stccpy(realname,stpblk(Z->header[HK_FROM]),sizeof(realname));
	}
   if(realname[0] == '\0')
      strcpy(realname,"<???>");
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
static int __regargs GetLines(GruppenPtr GPtr,char *name)
{	FILE *fp;
	char iot_buffer[MAX_LINELEN];
	int header =TRUE,counter = 0;

	CALLED("GetLines");

	ASSERT_PTR(name);

	DDEBUG(8,__FILE__ "(%d) article %s in %s hasn't got a LINE:-Keyword, have to count for myself (ntw)",__LINE__,name,GROUPNAME(GPtr));
	fp = myfopen(name,"r");
	if(fp)
	{	while(! feof(fp))
		{	myfgets(iot_buffer,sizeof(iot_buffer),fp);
			if(! header)
				counter++;
			else
				if(iot_buffer[0] == '\n')
					header =FALSE;
		}
		myfclose(fp);
	}
	return(counter);
}

static   char _NNdirectory[GS_DIRECTORYSIZE],	gs_buffer[GS_MAXHEADERSIZE+1],
		*_NNptrs[GS_MAXHEADERLINES];

static BOOL __regargs _NNScanHeader(GruppenPtr Gruppe,ArtikelPtr ptr, ULONG flags)
{	ULONG number;
	register char *p;	
	register int size;
	BPTR fp;

	CALLED("ScanHeader");

	ASSERT_PTR(Gruppe);
	ASSERT_PTR(ptr);

	stcl_d(gs_buffer,ptr->nummer);
	fp = Open(gs_buffer,MODE_OLDFILE);
	if(fp)
	{	register ULONG i,j,flag;
		Read(fp,gs_buffer,GS_MAXHEADERSIZE); /* Den Anfang einlesen => Header sollte */
		Close(fp);				/* eigentlich vollstaendig 'reinpassen (HEURISMUS) */
		Cr2Null(gs_buffer,GS_MAXHEADERSIZE); /* Ersetze alle CR durch String- */
						/* ende, beachte dabei RFC1036-konforme line-continuation */
		number = strbpl(_NNptrs,MAXNEWSGROUPS,gs_buffer);
		for(i=0; (i < number) && (MyEnv.extern_msg[0] == 0); i++) /* gehe alle strings durch... */
		{	for(j=0, flag=1;(j <= HK_NUMBER); j++, flag <<= 1)
			{	if(flag & flags)
				{	register ULONG len = strlen(HeaderKeyWords[j]);
					if(strnicmp(_NNptrs[i],HeaderKeyWords[j],len)==0)
					{	p = stpblk(_NNptrs[i] + len);
						size = strlen(p) + 1;
						if(ptr->header[j] = mymalloc(size))
							stccpy(ptr->header[j],p,size);
						else
						{	sprintf(MyEnv.extern_msg,"Can't alloc memory for %s!",HeaderKeyWords[j]);
							return(FALSE);
						}
					}
				}
			} /* End of inner-for */
		} /* End of for */
		if((flags & HKF_LINES) && (!(ptr->header[HK_LINES])))
		{	static char iot_buffer[50];
			if(MyEnv.flags.RequireLines)
				strcpy(iot_buffer,"-");
			else
			{	stcl_d(iot_buffer,ptr->nummer);
				stcl_d(iot_buffer,GetLines(Gruppe,iot_buffer));
			}
			if(ptr->header[HK_LINES] = mymalloc(strlen(iot_buffer) + 1))
				strcpy(ptr->header[HK_LINES],iot_buffer);
			else
			{	sprintf(MyEnv.extern_msg,"Can't alloc memory for %s!",HeaderKeyWords[HK_LINES]);
				return(FALSE);
			}
		}
		if((flags & HKF_DATE) && (ptr->header[HK_DATE]))
			ptr->date_val = (LONG)getdate(ptr->header[HK_DATE],NULL);
	} /* End of Artikel gefunden */
	else /* nicht gefunden, ggf. schon expired . */
	{	DDEBUG(1,__FILE__ "(%d) can't open %s !",__LINE__,gs_buffer);
		ptr->hide = TRUE;
		Gruppe->anzahl--;
		return(FALSE);
	}
	return(TRUE);
}/* End of noch-nicht-gelesen */
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
/*
 * $Id: mime.c,v 1.4 93/10/20 18:22:35 wasp Exp Locker: wasp $
 *
 *  by Walter Mildenberger in 1992-1993; All Rights reserved
 *
 * $Log:	mime.c,v $
 * Revision 1.4  93/10/20  18:22:35  wasp
 * peanuts
 * 
 * Revision 1.3  93/09/26  16:14:23  wasp
 * missing semicolon added
 * 
 * Revision 1.2  93/04/09  11:36:27  wasp
 * forgotten '\n' in representation of mime-conforming content-type encoded
 * articles added.
 * 
 * Revision 1.1  93/02/19  15:17:58  wasp
 * Initial revision
 * 
 */

#include "nn_includes.h"
#include "nn_defines.h"
#include "nn_types.h"
#include "nn_globals.h"
#include "protos/nnlib_protos.h"
#include "protos/protos_all.h"

#ifndef index
# define index(x,y)	strchr(x,y)
#endif

static int char64(char);
static int hexchar(char);
static void from64(FILE *,FILE *,char **,int *);
static void fromqp(FILE *,FILE *,char **,int *);
static void DoMimeConversion(FILE *fin,FILE *fout, void (* func)(FILE *infile, FILE *outfile, char **boundaries, int *boundaryct));
Prototype BOOL __regargs MimeConversion(char *oldfile, char *newfile);

static char basis_64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static char basis_hex[] = "0123456789ABCDEF";

static int char64(c)
char c;
{
    char *s = (char *) index(basis_64, c);
    if (s) return(s-basis_64);
    return(-1);
}

static int hexchar(c)
char c;
{
    char *s;
    if (islower(c)) c = toupper(c);
    s = (char *) index(basis_hex, c);
    if (s) return(s-basis_hex);
    return(-1);
}

static void from64(infile, outfile, boundaries, boundaryct) 
FILE *infile, *outfile;
char **boundaries;
int *boundaryct;
{

    int c1, c2, c3, c4;
    int newline = 1;

    while ((c1 = getc(infile)) != EOF) {
        if (isspace(c1)) {
            if (c1 == '\n') {
                newline = 1;
            } else {
                newline = 0;
            }
            continue;
        }
        newline = 0;
        do {
            c2 = getc(infile);
        } while (c2 != EOF && isspace(c2));
        do {
            c3 = getc(infile);
        } while (c3 != EOF && isspace(c3));
        do {
            c4 = getc(infile);
        } while (c4 != EOF && isspace(c4));
        if (c2 == EOF || c3 == EOF || c4 == EOF) {
            fprintf(stderr, "Premature EOF!\n");
            return;
        }
        c1 = char64(c1);
        c2 = char64(c2);
        putc(((c1<<2) | ((c2&0x30)>>4)), outfile);
        if (c3 != '=') {
            c3 = char64(c3);
            putc((((c2&0XF) << 4) | ((c3&0x3C) >> 2)), outfile);
            if (c4 != '=') {
                c4 = char64(c4);
                putc((((c3&0x03) <<6) | c4), outfile);
            }
        }
    }
}

static void fromqp(FILE *infile, FILE *outfile, char **boundaries, int *boundaryct)
{
    int c1, c2, sawnewline = 1;

    while ((c1 = getc(infile)) != EOF) {
        if (sawnewline && boundaries && (c1 == '-')) {
            char Buf[200], *s;

            ungetc(c1, infile);
            fgets(Buf, sizeof(Buf), infile);
            /* Not a boundary, now we must treat THIS line as q-p, sigh */
            for (s=Buf; *s; ++s) {
                if (*s == '=') {
                    if (!*++s) break;
                    if (*s == '\n') {
                        /* ignore it */
                        sawnewline = 1;
                    } else {
                        c1 = hexchar(*s);
                        if (!*++s) break;
                        c2 = hexchar(*s);
                        putc(c1<<4 | c2, outfile);
                    }
                } else {
                    putc(*s, outfile);
                }
            }
        } else {
            sawnewline = (c1 == '\n') ? 1 : 0;
            if (c1 == '=') {
                c1 = getc(infile);
                if (c1 == '\n') {
                    /* ignore it */
                    sawnewline = 1;
                } else {
                    c2 = getc(infile);
                    c1 = hexchar(c1);
                    c2 = hexchar(c2);
                    putc(c1<<4 | c2, outfile);
                    if (c2 == '\n') sawnewline = 1;
                }
            } else {
                putc(c1, outfile);
            }
        }
    }
}

#undef REQUIRE_MIME_VER

static void DoMimeConversion(FILE *fin,FILE *fout, void (* func)(FILE *infile, FILE *outfile, char **boundaries, int *boundaryct))
{	static char  buf[MAX_LINELEN];
	rewind(fin);
	do
	{	fgets(buf,sizeof(buf),fin);
		if(!ferror(fin))
			fputs(buf,fout);
	}while(!(feof(fin) || ferror(fin) || (buf[0] == '\n') || (buf[0] == '\0') || ferror(fout)));
	if(buf[0] == '\n')
		func(fin,fout,NULL,0);
	return;
}

BOOL __regargs MimeConversion(char *oldfile, char *newfile)
{	/* oldfile and newfile can point to the same location */
	BOOL result = FALSE;
	FILE *fin,*fout;
	char buffer[80], *ptr;

	fin = fopen(oldfile,"r");
	if(!fin)
		return(result);
#ifdef REQUIRE_MIME_VER
	if(ptr = findheader(fin,HeaderKeyWords[HK_MIME_VER]))
	{
		if(strnicmp(ptr,"1.0",3)==0)
		{
			free(ptr);
#endif
			if(ptr = findheader(fin,HeaderKeyWords[HK_CONTENT_TYPE]))
			{
				if((strnicmp(ptr,"text/plain",10)==0) && (strnicmp(stpblk(ptr+11),"charset=iso-8859-1",18)==0))
				{	free(ptr);
					if(ptr = findheader(fin,HeaderKeyWords[HK_TRANSFER_ENCODING]))
					{	if(strnicmp(ptr,"quoted-printable",16)==0)
						{	/* q-p wandeln */
							strcpy(buffer,"T:quoted-printable");
							fout = fopen(buffer,"w");
							if(fout)
							{	DoMimeConversion(fin,fout,fromqp);
								strcpy(newfile,buffer);
								result = TRUE;
								fclose(fout);
							}
						}
						else if(strnicmp(ptr,"base64",6)==0)
						{	/* q-p wandeln */
							strcpy(buffer,"T:base64");
							fout = fopen(buffer,"w");
							if(fout)
							{	DoMimeConversion(fin,fout,from64);
								strcpy(newfile,buffer);
								result = TRUE;
								fclose(fout);
							}
						}
					}
				}
				else
				{	DDEBUG(2,"Don't know how to handle Content-Type: %s",ptr );
					free(ptr);
				}
			}
#ifdef REQUIRE_MIME_VER
		}
				else
		{	strcpy(buffer,"Sorry, can't handle Mime-Version: ");
			strcat(buffer,ptr);
			DDEBUG(2,buffer);
			Notify(buffer);
			free(ptr);
		}
	}
#endif
	fclose(fin);
	return(result);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
# define HK_APPROVED			0
# define HKF_APPROVED		(1L << HK_APPROVED)
# define HK_CONTROL			1
# define HKF_CONTROL			(1L << HK_CONTROL)
# define HK_DATE				2
# define HKF_DATE				(1L << HK_DATE)
# define HK_DISTRIBUTION	3
# define HKF_DISTRIBUTION	(1L << HK_DISTRIBUTION)
# define HK_EXPIRES			4
# define HKF_EXPIRES			(1L << HK_EXPIRES)
# define HK_FOLLOWUP			5
# define HKF_FOLLOWUP		(1L << HK_FOLLOWUP)
# define HK_FROM				6
# define HKF_FROM				(1L << HK_FROM)
# define HK_KEYWORDS			7
# define HKF_KEYWORDS		(1L << HK_KEYWORDS)
# define HK_LINES				8
# define HKF_LINES			(1L << HK_LINES)
# define HK_MESSAGEID		9
# define HKF_MESSAGEID		(1L << HK_MESSAGEID)
# define HK_NEWSGROUPS		10
# define HKF_NEWSGROUPS		(1L << HK_NEWSGROUPS)
# define HK_ORGANIZATION	11
# define HKF_ORGANIZATION	(1L << HK_ORGANIZATION)
# define HK_PATH				12
# define HKF_PATH				(1L << HK_PATH)
# define HK_REFERENCES		13
# define HKF_REFERENCES		(1L << HK_REFERENCES)
# define HK_REPLYTO			14
# define HKF_REPLYTO			(1L << HK_REPLYTO)
# define HK_SENDER			15
# define HKF_SENDER			(1L << HK_SENDER)
# define HK_SUBJECT			16
# define HKF_SUBJECT			(1L << HK_SUBJECT)
# define HK_SUMMARY			17
# define HKF_SUMMARY			(1L << HK_SUMMARY)

# define HK_NUMBER			(HK_SUMMARY+1)

/* This were the rfc1036-conform headers, now comes self-brewn and mail-header */
# define HK_USER				18
# define HKF_USER				(1L << HK_USER)
# define HK_POSTED			19
# define HKF_POSTED			(1L << HK_POSTED)
# define HK_TO					20
# define HKF_TO				(1L << HK_TO)
# define HK_CC					21
# define HKF_CC				(1L << HK_CC)
# define HK_BCC				22
# define HKF_BCC				(1L << HK_BCC)
# define HK_INREPLYTO		23
# define HKF_INREPLYTO		(1L << HK_INREPLYTO)
# define HK_POSTER			24
# define HKF_POSTER			(1L << HK_POSTER)

/* now the MIME-Extensions RFC-1??? */
# define HK_MIME_VER					25
# define HKF_MIME_VER				(1L << HK_MIME_VER)
# define HK_CONTENT_TYPE			26
# define HKF_CONTENT_TYPE			(1L << HK_CONTENT_TYPE)
# define HK_TRANSFER_ENCODING		27
# define HKF_TRANSFER_ENCODING	(1L << HK_TRANSFER_ENCODING)

# define HK_STRINGS			(HK_TRANSFER_ENCODING + 1)
# define HK_FORCE				31
# define HKF_FORCE			(1L << HK_FORCE)

extern	char		*HeaderKeyWords[];
extern	char		*EnvKeyWords[];
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
CHAR *HeaderKeyWords[] =
{	"Approved:",	/* 00 */
	"Control:",		/* 01 */
	"Date:",			/* 02 */
	"Distribution:",/* 03 */
	"Expires:",		/* 04 */
	"Followup-To:",/* 05 */
	"From:",			/* 06 */
	"Keywords:",	/* 07 */
	"Lines:",		/* 08 */
	"Message-ID:",	/* 09 */
	"Newsgroups:",	/* 10 */
	"Organization:",/* 11 */
	"Path:",			/* 12 */
	"References:",	/* 13 */
	"Reply-To:",	/* 14 */
	"Sender:",		/* 15 */
	"Subject:",		/* 16 */
	"Summary:",		/* 17 */
	"X-",				/* 18 */
	"Posted:",		/* 19 */
	"To:",			/* 20 */
	"Cc:",			/* 21 */
	"Bcc:",			/* 22 */
	"In-Reply-To:",/* 23 */
	"Poster:",		/* 24 */
	"MIME-Version:",	/* 25 */
	"Content-Type:",	/* 26 */
	"Content-Transfer-Encoding:",	/* 27 */
	NULL
};
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
static	BOOLEAN __regargs	DisplayHeader(char *msg, BOOLEAN verbose)
{	BOOLEAN ok,fertig;
	static BOOLEAN old_verbose = FALSE;
	struct RastPort *rp = MyEnv.AnnRPort;
	int i;
	long j;

	assert((int)msg);

	if(isspace(*msg)) /* erlaube line-continuation */
		verbose = old_verbose;

	CALLED("DisplayHeader");

	j = 1L << (HK_USER+1);
	ok = fertig = FALSE;

	for(i=0;(i <= HK_USER) && (! fertig); i++)
	{	if(0==strnicmp(msg,HeaderKeyWords[i],strlen(HeaderKeyWords[i])))
		{	j = (1L << i);
			ok = verbose;
			fertig = TRUE;
			if(!ok)
				ok = (BOOLEAN)((MyEnv.DisplayFlags & j) != 0L);
		}
	}
	if((!fertig) && verbose)
		ok = TRUE;
	if(ok)
	{	if(MyEnv.HiLightFlags & j)
		{	SetInvers(rp);
			myWriteLn(msg,NULL);
			SetNormal(rp);
		}
		else
			myWriteLn(msg,NULL);
	}
	old_verbose = ok;
	return(ok);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
BOOLEAN __regargs HandleCrossPost(char *filename)
{	BOOLEAN rc = FALSE;
	register GruppenPtr GPtr;
	register ArtikelPtr APtr;
	char *ptr, *ptr2;
	LONG number;
	FILE *fp; 
	
	assert((int)filename);

	CALLED("HandleCrossPost");
	fp = fopen(filename,"r");
	if(! fp)
		return(rc);
	if(ptr = findheader(fp,"Xref:"))/* ist es ueberhaupt ge-CrossPostet ? */
	{	DDEBUG(6,__FILE__ " HandleCrossPost: %s",ptr);
		stccpy(Buf,ptr,BUF_SIZE);
		free(ptr);
		for(ptr = stpblk(Buf); ptr && (isalnum(*ptr) || (*ptr == '.')); ptr++) ; /* skip systemname */
		if(ptr && strlen(ptr))
		{	strcpy(Buf,ptr+1);
			ptr = strchr(Buf,':');
			while(ptr && strlen(ptr))
			{	*ptr++ = 0;
				number = atol(ptr);
				if(GPtr = FindGroup(NULL,Buf,FALSE))
				{	APtr = FirstArticle(GPtr);
					while(APtr && (APtr->nummer != number))
						APtr = NextArticle(APtr);
					if(APtr)
					{	Forbid();
						APtr->hide = TRUE;
						(GPtr->anzahl)--;
						Permit();
						rc = TRUE;
					}
				}
				ptr2 = strchr(ptr,' ');
				if(!ptr2)
					ptr2 = strchr(ptr,'\t');
				if(ptr2)
					ptr = stpblk(ptr2);
				if(ptr)
				{	strcpy(Buf,ptr);
					ptr = strchr(Buf,':');
				}
			}/* end of while ptr valid */
		} /* end of if */
	}/* End of crosspost */
	if(fp)
		fclose(fp);
	return(rc);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
static void __regargs Rot13(char *fn)
{	char filename[30];
	register BOOLEAN header = TRUE;
	FILE *fout, *fp=fopen(fn,"r");

	assert((int)fn);

	CALLED("Rot13");
	sprintf(filename,"t:rot13%lx",(LONG)MyEnv.Ann_Tasks[0]);
	fout = myfopen(filename,"w");
	if(fout)
	{	while(!(feof(fp) || ferror(fp)))
		{	myfgets(Buf,BUF_SIZE,fp);
			if(Buf[0] == '\n')
				header = FALSE;
			if(! header)
				rot13(Buf);
			myfputs(Buf,fout);
		}
		myfclose(fout);
		sprintf(Buf,"%s %s",MyEnv.NewsReader,filename);
		mySystem(Buf);
		remove(filename);
	}
	if(fp)	fclose(fp);
}

static void __regargs rot13(char *Buf)
{	register char *p = Buf;
	CALLED("rot13");
	while(*p)
	{	if((*p >= 'A') && (*p <= 'M') || (*p >= 'a') && (*p <= 'm'))
			*p += 13;
		else if((*p >= 'N') && (*p <= 'Z') || (*p >= 'n') && (*p <= 'z'))
			*p -= 13;
		++p;
	}
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
/*
 * $Id: select.c,v 1.4 93/10/20 18:29:49 wasp Exp Locker: wasp $
 *
 *  by Walter Mildenberger in 1992-1993; All Rights reserved
 *
 * $Log:	select.c,v $
 * Revision 1.4  93/10/20  18:29:49  wasp
 * peanuts
 * 
 * Revision 1.3  93/02/19  15:10:57  wasp
 * peanuts...
 * 
 * Revision 1.2  92/11/05  19:41:29  wasp
 * GROUPNAME()-macro added
 * 
 * Revision 1.1  92/06/09  16:15:13  wasp
 * Initial revision
 * 
 */

#include "nn_includes.h"
#include "nn_defines.h"
#include "nn_types.h"
#include "nn_globals.h"
#include "protos/nnlib_protos.h"
#include "protos/protos_all.h"

#include <libraries/gadtools.h>
#include <intuition/gadgetclass.h>
#include <clib/gadtools_protos.h>
#include <pragmas/gadtools_pragmas.h>

typedef struct Gadget      GADGET;

static		NODE *		__regargs SelectList(struct Window *win,struct TextAttr *ta,struct List *list);
static		VOID			__regargs DeleteGadgets(struct RastPort *rp);
static		VOID			__regargs ReDrawGadgets(struct RastPort *rp);
static		BOOL			__regargs Ok(void);
static		BOOL			__regargs Forget(void);
static		VOID			__regargs ActivateOk(void);
static		VOID			__regargs Select(LONG code);
static		BOOL			__regargs HandleGadget(struct IntuiMessage *msg);
static		BOOL			__regargs HandleMsg(void);
Prototype	GruppenPtr	__regargs SelectGroup(char ch,GruppenPtr OldGroup,char *buffer, UWORD buffersize);

static struct TextAttr DefaultTextAttr =
{  (STRPTR)"topaz.font",
   8,
   FS_NORMAL,
   FPF_ROMFONT|FPF_DISKFONT
};

static struct TextAttr *SelectTextAttr = NULL;
static struct TextFont *SelectTextFont = NULL;

static struct NewWindow SelectNewWindow =
{  0,0,
   320,200,
   0,1,
   NULL, /* modified my ModifyIDCMP() later ! */
   WFLG_DRAGBAR | WFLG_DEPTHGADGET | WFLG_CLOSEGADGET | WFLG_SIZEGADGET
   | WFLG_SIZEBBOTTOM | WFLG_SIMPLE_REFRESH | WFLG_ACTIVATE | WFLG_RMBTRAP,
   NULL, /* gadget, filled in later */
   NULL, /* checkmark, not used anyway */
   (STRPTR)"Select group!",
   NULL, /* Screen, filled in later */
   NULL, /* BitMap */
   160,100,
   (UWORD)~0,(UWORD)~0,
   CUSTOMSCREEN
};

static WORD SelectZoom[4] = {0,0,~0,~0};

static struct TagItem WindowTags[] =
{  
   {WA_AutoAdjust,TRUE},
   {WA_Zoom, (ULONG)SelectZoom},
   {TAG_DONE,0}
};

static struct Window *SelectWindow = NULL;

static APTR SelectVisualInfo = NULL;

static struct Gadget
   *SelectContext = NULL,
   *GadgetList = NULL,
   *gadget[3] = {NULL,NULL,NULL};

#define GAD_LIST     0
#define GAD_OK       1
#define GAD_FORGET   2

static struct NewGadget SelectNewGadget[3] =
{  {  0,0,
      0,0,
      NULL,
      NULL,
      GAD_LIST,
      0L,
      NULL,
      NULL
   },
   {  0,0,
      0,0,
      "Ok",
      NULL,
      GAD_OK,
      PLACETEXT_IN,
      NULL,
      NULL
   },
   {  0,0,
      0,0,
      "Forget",
      NULL,
      GAD_FORGET,
      PLACETEXT_IN,
      NULL,
      NULL
   }
};

#define error(x)   fputs(x,stderr);

NODE *SelectedVal = NULL;
ULONG SelectedNum = ~0;
ULONG SelectMaxNum = 0;
static LIST *SList = NULL;

static NODE * __regargs SelectList(struct Window *win,struct TextAttr *ta,LIST *list)
{  BOOL Schluss = FALSE;
   ULONG oldIDCMP;
   WORD offset;
	GruppenPtr GPtr;

   oldIDCMP = win->IDCMPFlags;
   ModifyIDCMP(win,IDCMP_REFRESHWINDOW);
   SetPointer(win,Stopwatch,16,16,-6,0);
   SList = (LIST *)list;
	MESSAGE("Busy, please wait syncronization");
	for(GPtr = FirstGroup(); GPtr; GPtr = NextGroup(NULL,GPtr,FALSE))
		SelectMaxNum++;
	--SelectMaxNum;
   if(IntuitionBase)
   {  if(GadToolsBase)
      {  SelectTextAttr = ta ? ta : &DefaultTextAttr;
         SelectTextFont = OpenDiskFont(SelectTextAttr);
         if(SelectTextFont)
         {  SelectVisualInfo = GetVisualInfo(win->WScreen,TAG_DONE);
            if(SelectVisualInfo)
            {  SelectZoom[2]  = win->WScreen->Width  >> 1;
               SelectZoom[3]  = win->WScreen->Height;
               SelectNewWindow.Screen     = win->WScreen;
               SelectNewWindow.TopEdge    = win->TopEdge + win->BorderTop + 1;
               SelectNewWindow.Height     = win->Height - win->BorderTop - win->BorderBottom - 1;
               SelectNewWindow.Width      = 320;
               SelectNewWindow.LeftEdge   = win->LeftEdge + win->BorderLeft;
               offset = win->Width - win->BorderLeft - win->BorderRight - SelectNewWindow.Width;
               if(offset > 0)
                  SelectNewWindow.LeftEdge += (offset >> 1);
               SelectNewWindow.FirstGadget = SelectContext;
               SelectWindow = OpenWindowTagList(&SelectNewWindow,WindowTags);
               if(SelectWindow)
               {  SetFont(SelectWindow->RPort,SelectTextFont);
                  {  WORD i;
                     for(i=0; i < 3; i++)
                     {  SelectNewGadget[i].ng_VisualInfo = SelectVisualInfo;
                        SelectNewGadget[i].ng_TextAttr   = SelectTextAttr;
                     }
                  }
                  ReDrawGadgets(SelectWindow->RPort);
                  ModifyIDCMP(
                     SelectWindow,
                     IDCMP_SIZEVERIFY | IDCMP_NEWSIZE | IDCMP_REFRESHWINDOW
                     | LISTVIEWIDCMP | IDCMP_CLOSEWINDOW
                     | IDCMP_VANILLAKEY | IDCMP_RAWKEY
                  );
                  while(!Schluss)
                  {  WaitPort(SelectWindow->UserPort);
                     Schluss = HandleMsg();
                  }
                  DeleteGadgets(SelectWindow->RPort);
                  CloseWindow(SelectWindow);
               } else error("can't create window !\n");
               FreeVisualInfo(SelectVisualInfo);
            } else error("can't get visual info !\n");
            CloseFont(SelectTextFont);
         } else error("can't open selected diskfont !\n");
      } else error("gadtools not open!\n");
   } else error("Intuition not open!\n");
   ClearPointer(win);
   ModifyIDCMP(win,oldIDCMP);
   return(SelectedVal);
}

static void __regargs DeleteGadgets(struct RastPort *rp)
{  register struct Window *win = SelectWindow;
   if(SelectContext)
   {  RemoveGList(SelectWindow,SelectContext,-1);
      FreeGadgets(SelectContext);
      SelectContext = NULL;
      EraseRect(win->RPort,win->BorderLeft,win->BorderTop,win->Width - win->BorderRight,win->Height - win->BorderBottom);
      RefreshWindowFrame(SelectWindow);
   }
}

static void __regargs ReDrawGadgets(struct RastPort *rp)
{  static BOOL again = FALSE;

   SelectContext = CreateContext(&GadgetList);
   if(SelectContext)
   {  if(!again)
      {  SelectNewGadget[1].ng_Width      = TextLength(rp,SelectNewGadget[2].ng_GadgetText,strlen(SelectNewGadget[2].ng_GadgetText)) + 2*INTERWIDTH;
         SelectNewGadget[2].ng_Width      = SelectNewGadget[1].ng_Width;
         SelectNewGadget[1].ng_Height     = rp->TxHeight + INTERHEIGHT;
         SelectNewGadget[2].ng_Height     = SelectNewGadget[1].ng_Height;
         WindowLimits(SelectWindow,
            2*SelectNewGadget[1].ng_Width
               + 3*INTERWIDTH
               + SelectWindow->BorderLeft
               + SelectWindow->BorderRight,
            3*INTERWIDTH
               + SelectNewGadget[1].ng_Height
               + 3*rp->TxHeight
               + SelectWindow->BorderTop
               + SelectWindow->BorderBottom,
            0,
            0
         );
         again = TRUE;
      }
      SelectNewGadget[1].ng_LeftEdge   = SelectWindow->BorderLeft + INTERWIDTH;
      SelectNewGadget[2].ng_LeftEdge   = SelectWindow->Width - SelectWindow->BorderRight - SelectNewGadget[2].ng_Width - INTERWIDTH;
      SelectNewGadget[1].ng_TopEdge    = SelectWindow->Height - SelectWindow->BorderBottom - SelectNewGadget[1].ng_Height - INTERHEIGHT;
      SelectNewGadget[2].ng_TopEdge    = SelectNewGadget[1].ng_TopEdge;

      SelectNewGadget[0].ng_LeftEdge   = SelectWindow->BorderLeft + INTERWIDTH;
      SelectNewGadget[0].ng_TopEdge    = SelectWindow->BorderTop  + INTERHEIGHT;
      SelectNewGadget[0].ng_Width      = SelectWindow->Width  - SelectWindow->BorderRight  - SelectWindow->BorderLeft - 2*INTERWIDTH;
      SelectNewGadget[0].ng_Height     = SelectWindow->Height - SelectWindow->BorderBottom - SelectWindow->BorderTop - 3*INTERHEIGHT - SelectNewGadget[1].ng_Height;

      gadget[GAD_LIST] = CreateGadget(LISTVIEW_KIND,SelectContext,&SelectNewGadget[GAD_LIST],
                                       GTLV_Top,(SelectedNum == ~0 ? 0 : SelectedNum),
                                       GTLV_Labels, (ULONG)SList,
                                       GTLV_ShowSelected, 0L,
                                       GTLV_Selected,SelectedNum,
                                       TAG_DONE
                                     );
      if(!gadget[GAD_LIST])
      {  fputs("can't create ListView-Gadget !\n",stderr);
         return;
      }
      gadget[GAD_OK] = CreateGadget(BUTTON_KIND,gadget[GAD_LIST],&SelectNewGadget[GAD_OK],
                        GA_Disabled,(ULONG)(SelectedVal ? FALSE : TRUE),
                        TAG_DONE);
      if(!gadget[GAD_OK])
      {  fputs("can't create OK-Gadget",stderr);
         return;
      }
      gadget[GAD_FORGET] = CreateGadget(BUTTON_KIND,gadget[GAD_OK],&SelectNewGadget[GAD_FORGET],TAG_DONE);
      if(!gadget[GAD_FORGET])
      {  fputs("can't create Forget-Gadget",stderr);
         return;
      }
      AddGList(SelectWindow,SelectContext,~0,~0,NULL);
      RefreshGadgets(SelectWindow->FirstGadget,SelectWindow,NULL);
      GT_RefreshWindow(SelectWindow,NULL);
   }
}

static BOOL __regargs Ok(void)
{
   if(SelectedVal)
      return(TRUE);
   return(FALSE);
}

static BOOL __regargs Forget(void)
{  SelectedVal = NULL;
   SelectedNum = ~0;
   return(TRUE);
}

static VOID __regargs ActivateOk(VOID)
{  static BOOL done = FALSE;
   if(done)
      return;
   GT_SetGadgetAttrs(gadget[GAD_OK],SelectWindow,NULL,GA_Disabled,FALSE,TAG_DONE);
   RefreshGadgets(gadget[GAD_OK],SelectWindow,NULL);
   done = TRUE;
}

static VOID __regargs Select(LONG code)
{  GruppenPtr Gruppe = FirstGroup();
   UWORD i;
   SelectedNum = (code < 0) ? 0 : code;
redo:
	MESSAGE("Busy, please wait syncronization");
   for(i=0; (i < SelectedNum) && Gruppe; i++)
      Gruppe = NextGroup(SelectWindow,Gruppe,TRUE);
   if(!Gruppe)
   {  SelectedNum = i-1;
      goto redo;
   }
   SelectedVal = (NODE *)Gruppe;
   ActivateOk();
   GT_SetGadgetAttrs(gadget[GAD_LIST],SelectWindow,NULL,
      GTLV_Top,SelectedNum,
      GTLV_Selected,SelectedNum,
      TAG_DONE);
}

static BOOL __regargs HandleGadget(struct IntuiMessage *msg)
{  BOOL Schluss = FALSE;
   GADGET *gad;

   if(!msg)
      return(Forget());
   gad = msg->IAddress;
   if(!gad)
      return(Forget());
   if(gad->GadgetID == GAD_OK)
      Schluss = Ok();
   else if(gad->GadgetID == GAD_FORGET)
      Schluss = Forget();
   else if(gad->GadgetID == GAD_LIST)
      Select(msg->Code);
   else
      return(Forget());
   return(Schluss);
}

static BOOL __regargs HandleMsg(void)
{  BOOL Schluss = FALSE;
   struct IntuiMessage *msg;
   static char name[80];
   static UWORD i = 0;
   GruppenPtr Gruppe;

   while(msg = GT_GetIMsg(SelectWindow->UserPort))
   {  switch(msg->Class) {
         case IDCMP_SIZEVERIFY:
            DeleteGadgets(SelectWindow->RPort);
            break;
         case IDCMP_NEWSIZE:
            ReDrawGadgets(SelectWindow->RPort);
            break;
         case IDCMP_REFRESHWINDOW:
            GT_BeginRefresh(SelectWindow);
            GT_EndRefresh(SelectWindow,TRUE);
            break;
         case IDCMP_GADGETUP:
            Schluss = HandleGadget(msg);
            break;
         case IDCMP_CLOSEWINDOW:
            Schluss = Forget();
            break;
         case IDCMP_VANILLAKEY:
            switch(msg->Code){
               case 27:
                  Schluss = Forget();
                  break;
               case 13:
                  Schluss = Ok();
                  break;
               default:
                  if(msg->Code == 8)
                  {  if(i > 0)
                        --i;
                     name[i] = '\0';
                  }
                  else
                  {  name[i++] = (char)(msg->Code);
                     name[i] = '\0';
                  }
                  Gruppe = MatchFirstGroup(SelectWindow,name,TRUE);
                  SelectedVal = (NODE *)Gruppe;
                  ActivateOk();
               break;
            }/* End of inner-switch */
            break;
         case IDCMP_RAWKEY:
            if(msg->Code == 0x4C)
            {  if(SelectedNum)
                  --SelectedNum;
               Select(SelectedNum);
            }
            else if(msg->Code == 0x4D)
            {  if(SelectedNum < SelectMaxNum)
						++SelectedNum;
					Select(SelectedNum);
            }
            break;
         case IDCMP_MOUSEBUTTONS:
         case IDCMP_INTUITICKS:
         default:
            break;
      }/* End of switch */
      GT_ReplyIMsg(msg);
   } /* End of while */
   return(Schluss);
}

GruppenPtr __regargs SelectGroup(char ch,GruppenPtr OldGroup,char *buffer, UWORD buffersize)
{  GruppenPtr GroupPtr;
   if(MyEnv.flags.DOS2 && (ch >= 'A') && (ch <= 'Z'))
      GroupPtr = (GruppenPtr)SelectList(MyEnv.AnnWindow,MyEnv.AnnTextAttr,&MyEnv.GruppenListe);
   else
   {  if(UserRequest("Goto group: ",buffer,buffersize,FALSE))
      {  if(strlen(buffer))
         {  GroupPtr = FindGroup(MyEnv.AnnWindow,buffer,TRUE);
            if(!GroupPtr)
            {  Notify("Can't find Group !");
               GroupPtr = OldGroup;
            }
         }
      }
   }
   if(!GroupPtr)
      GroupPtr = OldGroup;
   if(! GroupPtr->subscribed)
   {  sprintf(buffer,"%s is unsubscribed, resubscibe [Ny] ?",GROUPNAME(GroupPtr));
      ch = More(buffer,FALSE);
      if((ch == 'Y') || (ch == 'y') || (ch == 'J') || (ch == 'j'))
         GroupPtr->subscribed = TRUE;
   }
   return(GroupPtr);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
static void __regargs CopyReference(char *to,CONST char *from)
{	register BOOL inmsgid = FALSE, firsttime=TRUE;
	while(*from != '\0')
	{	if(*from == '<')
		{	inmsgid = TRUE;
			if(firsttime)
				firsttime=FALSE;
			else
				*(to++) = ' ';
		}
		else
		{	if(*from == '>')
			{	inmsgid = FALSE;
				*to++ = '>';
			}
		}
		if(inmsgid)
			*to++ = *from;
		from++;
	}/* end of while*/
	*to = '\0';
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
BOOL __regargs PreFill(FILE *fp,char *group)
{	char * ptr;
	int i;
	BOOL rc;

	assert((int)group);

	rc = FALSE;

	CALLED("PreFill");
	for(i = 0; i < HK_STRINGS; i++)
	{	if(i != HK_REFERENCES)
			Header.Line[i][0] = '\0';
		else
		{	if(Header.Line[i])
			{	free(Header.Line[i]);
				Header.Line[i] = NULL;
			}
		}
	}
	stccpy(Header.Line[HK_ORGANIZATION],MyEnv.Organization,HEADER_LEN);

	/* Approved is only used by ChangeHeader() */
	/* Control is only used by ChangeHeader() / Cancel() */
	/* Date is filled in later */
	if(ptr = findheader(fp,HeaderKeyWords[HK_DISTRIBUTION]))
	{	stccpy(Header.Line[HK_DISTRIBUTION],ptr,HEADER_LEN);
		free(ptr);
	}
	else
		strcpy(Header.Line[HK_DISTRIBUTION], MyEnv.DefDist);
	/* Expires is only used by ChangeHeader() */
	/* Followup is only used by ChangeHeader() */
	/* From is filled in later */
	/* keywords is only used by ChangeHeader() */
	/* Lines is computed later */
	/* Message-Id is computed later */
	if(ptr = findheader(fp,HeaderKeyWords[HK_FOLLOWUP]))
	{	if(0==(strnicmp(ptr,"poster",6))) /*siehe RFC1036 =>"Followup-To: poster" */
		{	rc = TRUE;
			stccpy(Header.Line[HK_NEWSGROUPS],group ? group : "",HEADER_LEN);
		}
		else
			stccpy(Header.Line[HK_NEWSGROUPS],ptr,HEADER_LEN);
		free(ptr);
	}
	else /* kein FollowUp-To: gefunden => normale NewsGroup */
	{	if(ptr = findheader(fp,HeaderKeyWords[HK_NEWSGROUPS]))
		{	stccpy(Header.Line[HK_NEWSGROUPS],ptr,HEADER_LEN);
			free(ptr);
		}
		else /* should not happen !!!! */
			stccpy(Header.Line[HK_NEWSGROUPS],group ? group : "",HEADER_LEN);
	}

	/* Path is filled in later */
	if(ptr = findheader(fp,HeaderKeyWords[HK_REFERENCES]))
	{	CopyReference(Buf,ptr);
		strcat(Buf," ");
		free(ptr);
	}
	else
	{	Buf[0] = ' ';
		Buf[1] = '\0';
	}
	ptr = findheader(fp,HeaderKeyWords[HK_MESSAGEID]);
	if(ptr)
	{	register char *ptr2 = stpblk(ptr);
		strcat(Buf,ptr2);
		stccpy(Header.Line[HK_MESSAGEID],ptr2,HEADER_LEN);
		stccpy(Header.Line[HK_INREPLYTO],ptr2,HEADER_LEN);
		free(ptr);
	}
	Header.Line[HK_REFERENCES] = mymalloc(strlen(Buf)+0); /* !! */
	if(Header.Line[HK_REFERENCES]==NULL)
		Notify("can't get memory for references-list, line dropped!");
	else
		strcpy(Header.Line[HK_REFERENCES],&(Buf[1]));

	stccpy(Header.Line[HK_REPLYTO],MyEnv.ReplyTo,HEADER_LEN);
	/* Sender is probably filled in later */
	if(ptr = findheader(fp,HeaderKeyWords[HK_SUBJECT]))
	{	if(((strnicmp(ptr,"Re:",3)) && (strnicmp(ptr,"Re^",3))))
			strcpy(Header.Line[HK_SUBJECT],"Re: ");
		strncat(Header.Line[HK_SUBJECT],ptr,HEADER_LEN);
		free(ptr);
	}
	/* Summary is only used in ChangeHeader() */
	/* X-User is only used in ChangeHeader() */
	if(ptr = findheader(fp,HeaderKeyWords[HK_DATE]))
	{	stccpy(Header.Line[HK_POSTED],ptr,HEADER_LEN);
		free(ptr);
	}
	if(ptr =findheader(fp,HeaderKeyWords[HK_FROM]))
	{	stccpy(Header.Line[HK_POSTER],ptr,HEADER_LEN);
		free(ptr);
	}
	if(ptr =findheader(fp,HeaderKeyWords[HK_REPLYTO]))
	{	stccpy(Header.Line[HK_TO],ptr,HEADER_LEN);
		free(ptr);
	}
	else
		stccpy(Header.Line[HK_TO],Header.Line[HK_POSTER],HEADER_LEN);
	/* CC, Bcc, InReplyTo is only used in ChangeHeader/Reply() */
	if(!fp)
		return(FALSE);
	return(rc);
}
/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
