head	1.5;
access;
symbols
	v0_2:1.5
	v0_1:1.5;
locks
	simons:1.5; strict;
comment	@ * @;


1.5
date	94.04.27.19.46.54;	author simons;	state Exp;
branches;
next	1.4;

1.4
date	94.04.27.16.30.06;	author simons;	state Exp;
branches;
next	1.3;

1.3
date	94.04.27.15.28.17;	author simons;	state Exp;
branches;
next	1.2;

1.2
date	94.04.27.14.25.34;	author simons;	state Exp;
branches;
next	1.1;

1.1
date	94.04.24.21.36.50;	author simons;	state Exp;
branches;
next	;


desc
@Routines responsible for adding entries in the sys-file list.
@


1.5
log
@Added security checks whether strdup() failed or not.
@
text
@/*
 *      $Filename: add.c $
 *      $Revision: 1.4 $
 *      $Date: 1994/04/27 16:30:06 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: add.c 1.4 1994/04/27 16:30:06 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "newsserv.h"
#include "protos.h"

/************************************* defines ************/

/************************************* prototypes *********/

/************************************* global variables ***/
static const char __RCSId[] = "$Id: add.c 1.4 1994/04/27 16:30:06 simons Exp simons $";

/************************************* program ************/

int AddSysEntry(struct ListHead *lh, char *sitename, char *entry)
{
        struct NewsEntry *ne, *new;

        if (!(entry = strdup(entry)))
                return FALSE;

        while (lh) {
                if (!stricmp(lh->lh_SystemName, sitename))
                        break;
                lh = lh->lh_NextListHead;
        }

        if (lh) {
                ne = lh->lh_FirstNewsEntry;
                if (ne) {
                        while (ne) {
                                if (stricmp(ne->ne_NewsEntry, entry))
                                        ne = ne->ne_NextEntry;
                                else
                                        return TRUE;
                        }
                        ne = lh->lh_FirstNewsEntry;
                        while (ne->ne_NextEntry)
                                ne = ne->ne_NextEntry;
                        if (!(new = malloc(sizeof(struct NewsEntry))))
                                return FALSE;
                        new->ne_NextEntry = NULL;
                        new->ne_NewsEntry = entry;
                        ne->ne_NextEntry = new;
                }
                else {
                        if (!(new = malloc(sizeof(struct NewsEntry))))
                                return FALSE;
                        new->ne_NextEntry = NULL;
                        new->ne_NewsEntry = entry;
                        lh->lh_FirstNewsEntry = new;
                }
        }
        else
                return FALSE;

        return TRUE;
}

@


1.4
log
@Removed the tmp variable. We can modify lh, because it's a local
copy.
@
text
@d3 2
a4 2
 *      $Revision: 1.3 $
 *      $Date: 1994/04/27 15:28:17 $
d22 1
a22 1
 *      $Id: add.c 1.3 1994/04/27 15:28:17 simons Exp simons $
d40 1
a40 1
static const char __RCSId[] = "$Id: add.c 1.3 1994/04/27 15:28:17 simons Exp simons $";
d48 3
d72 1
a72 1
                        new->ne_NewsEntry = strdup(entry);
d79 1
a79 1
                        new->ne_NewsEntry = strdup(entry);
@


1.3
log
@Added first version of AddSysEntry().
@
text
@d3 2
a4 2
 *      $Revision: 1.2 $
 *      $Date: 1994/04/27 14:25:34 $
d22 1
a22 1
 *      $Id: add.c 1.2 1994/04/27 14:25:34 simons Exp simons $
d40 1
a40 1
static const char __RCSId[] = "$Id: add.c 1.2 1994/04/27 14:25:34 simons Exp simons $";
a45 1
        struct ListHead *tmp = lh;
d48 2
a49 2
        while (tmp) {
                if (!stricmp(tmp->lh_SystemName, sitename))
d51 1
a51 1
                tmp = tmp->lh_NextListHead;
d54 2
a55 2
        if (tmp) {
                ne = tmp->lh_FirstNewsEntry;
d63 1
a63 1
                        ne = tmp->lh_FirstNewsEntry;
d69 1
a69 1
                        new->ne_NewsEntry = entry;
d76 2
a77 2
                        new->ne_NewsEntry = entry;
                        tmp->lh_FirstNewsEntry = new;
@


1.2
log
@Add RCS ident string.
@
text
@d3 2
a4 2
 *      $Revision: 1.1 $
 *      $Date: 1994/04/24 21:36:50 $
d22 1
a22 1
 *      $Id: add.c 1.1 1994/04/24 21:36:50 simons Exp simons $
d40 1
a40 1
static const char __RCSId[] = "$Id$";
a43 2
/*

d46 2
a47 1
        struct ListHead *lh_tmp = lh;
d49 2
a50 2
        while (lh_tmp) {
                if (!stricmp(lh_tmp->lh_SystemName, sitename))
d52 1
a52 1
                lh_tmp = lh_tmp->lh_NextListHead;
d55 28
a82 1
        if (lh_tmp) {
d84 1
a84 1
        }
a86 1
*/
@


1.1
log
@Initial revision
@
text
@d3 2
a4 2
 *      $Revision$
 *      $Date$
d22 1
a22 1
 *      $Id$
d28 4
d40 1
d44 18
@
