head	1.10;
access;
symbols
	v0_2:1.10
	v0_1:1.9;
locks
	simons:1.10; strict;
comment	@ * @;


1.10
date	94.05.27.14.23.11;	author simons;	state Exp;
branches;
next	1.9;

1.9
date	94.05.06.14.31.38;	author simons;	state Exp;
branches;
next	1.8;

1.8
date	94.05.06.14.15.57;	author simons;	state Exp;
branches;
next	1.7;

1.7
date	94.04.28.18.08.42;	author simons;	state Exp;
branches;
next	1.6;

1.6
date	94.04.27.19.46.54;	author simons;	state Exp;
branches;
next	1.5;

1.5
date	94.04.27.16.30.52;	author simons;	state Exp;
branches;
next	1.4;

1.4
date	94.04.25.00.50.11;	author simons;	state Exp;
branches;
next	1.3;

1.3
date	94.04.25.00.39.27;	author simons;	state Exp;
branches;
next	1.2;

1.2
date	94.04.25.00.24.25;	author simons;	state Exp;
branches;
next	1.1;

1.1
date	94.04.24.21.36.50;	author simons;	state Exp;
branches;
next	;


desc
@Main module of NewsSERV. Contains the RFC parsing stuff and calls
the appropriate routines depending on the commands.
@


1.10
log
@Now using the SYSFILE define rather than a string.
@
text
@/*
 *      $Filename: main.c $
 *      $Revision: 1.9 $
 *      $Date: 1994/05/06 14:31:38 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: main.c 1.9 1994/05/06 14:31:38 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "newsserv.h"
#include "protos.h"
#include "NewsSERV_rev.h"

/************************************* defines ************/
#define STARTUP "Amiga " VERS " -- written by by Peter Simons <simons@@peti.GUN.de>\n"
#define USAGE   "USAGE: NewsSERV <mailfile\n"

/************************************* prototypes *********/
void CleanUp(void);

/************************************* global variables ***/
static char rcssid[] = "$Id: main.c 1.9 1994/05/06 14:31:38 simons Exp simons $";
#ifdef AMIGA
static char dosid[] = VERSTAG;          /* Amiga specific version string */
#endif

FILE *fh;

/************************************* program ************/
long main(int argc, char **argv)
{
        struct ListHead *lh;
        char buffer[1024], *from = NULL, site[64], password[64], newsgroup[64];
        int gotcommand = 0, garbage = 0, modified = 0;


        /*
         * Print startup header, check commandline and initialize
         * the required system resources.
         */
        printf(STARTUP);
        if (argc > 1) {
                printf(USAGE);
                return 0;
        }
        if (!InitSystem())
                return 20;
        if (atexit(CleanUp)) {
                CleanUp();
                return 20;
        }
        *site = '\0';
        *password = '\0';


        /*
         * Parse header for "From:" entry.
         */
        while (gets(buffer) && *buffer != '\0') {
                if (!strnicmp(buffer, "From: ",6))
                        if (from = strdup(&buffer[6]))
                                ParseAddress(from);
        }

        /*
         * Check from validity.
         */
        if (!from || !(*from)) {
                LogFatalError("Received mail without 'From:'-line!");
                return 10;
        }

        /*
         * Load and parse the sys file.
         */
        if (!(lh = ParseSysFile(SYSFILE))) {
                LogFatalError("Can't parse the sys file!! Maybe the file is corrupt?");
                return 10;
        }


        /*
         * Open pipe to sendmail for our reply.
         *
         */
        if (!(fh = SendMail(from, "news", "Re: Your mail to NewsSERV"))) {
                LogFatalError("Can't open pipe to sendmail!");
                return 10;
        }
        fprintf(fh, "Hi, this is Peti's Amiga " VERS " talking to you!\n\n\n");      /* Send welcome message. :-) */


        /*
         * Process mail body.
         */
        while (gets(buffer)) {
                /* check for empty lines */
                if (!(*buffer))
                        continue;

                LogInfo("%s: %s", from, buffer);        /* log the request */
                fprintf(fh, " > %s\n", buffer);

                if (!stricmp(buffer, "help")) {
                        gotcommand++;
                        fprintf(fh, "\n" HELPTEXT "\n\n" );
                        continue;
                }

                else if (!strnicmp(buffer, "SITE ", 5)) {
                        gotcommand++;
                        sscanf(buffer, "%*s%s%s", site, password);
                        fprintf(fh, "\nAll commands refer to system \"%s\" now.\n\n\n", site);
                        continue;
                }

                else if (!strnicmp(buffer, "LIST", 4)) {
                        gotcommand++;
                        fprintf(fh, "\nSystem \"%s\" is subscribed to the following newsgroups:\n", site);
                        ListSysFile(lh, site, fh);
                        fprintf(fh, "\n\n");
                        continue;
                }

                else if (!strnicmp(buffer, "ADD ", 4) || !strnicmp(buffer, "SUBSCRIBE ", 10)) {
                        gotcommand++; modified++;
                        sscanf(buffer, "%*s%s", newsgroup);
                        if (AddSysEntry(lh, site, newsgroup))
                                fprintf(fh, "\nAdded \"%s\" successfully.\n", newsgroup);
                        else
                                fprintf(fh, "\nCouldn't add \"%s\".\n", newsgroup);
                        fprintf(fh, "\n\n");
                        continue;
                }

                else if (!strnicmp(buffer, "DEL ", 4) || !strnicmp(buffer, "UNSUBSCRIBE ", 12)
                      || !strnicmp(buffer, "DELETE ", 7)) {
                        gotcommand++; modified++;
                        sscanf(buffer, "%*s%s", newsgroup);
                        if (DeleteSysEntry(lh, site, newsgroup))
                                fprintf(fh, "\nRemoved \"%s\" successfully.\n", newsgroup);
                        else
                                fprintf(fh, "\nCouldn't remove \"%s\".\n", newsgroup);
                        fprintf(fh, "\n\n");
                        continue;
                }


                /*
                 * Flush message if > 5 lines of garbage
                 */
                if (++garbage > 5) {
                        LogError("%s: Garbled message, flushing...", from);
                        break;
                        }
                }

        if (!gotcommand) {
                LogError("%s: indecipherable mail --> sending HELP back", from);
                fprintf(fh, HELPTEXT);
        }


        /*
         * Save the modified sys file.
         */
        if (modified && !SaveSysFile(SYSFILE, lh)) {
                LogFatalError("An error occured while saving the sys file! Might be corrupted!!");
                return 10;
        }

        return 0;
}


void CleanUp(void)              /* is called by atexit() automatically */
{
        if (fh)
                fclose(fh);
        FreeSystem();
}



FILE *SendMail(char *to, char *cc, char *subject)
{
        FILE *pipe;
        char buffer[512];

        sprintf(buffer, "%s -f NewsSERV -R \"NewsSERV daemon\"", FindConfig(SENDMAIL, SENDMAIL));

        if (pipe = popen(buffer, "w")) {
                fprintf(pipe, "To: %s\n", to);
                if (cc && *cc)
                        fprintf(pipe, "Cc: %s\n", cc);
                fprintf(pipe, "Subject: %s\n", subject);
                fprintf(pipe, "\n");
                return pipe;
        }

        LogError("Couldn't open pipe to sendmail.");
        return NULL;
}

@


1.9
log
@Now the sys file is only written back when a command that changes
the file has been issued. Commands that do not change the sys file
are LIST, SITE and PASSWORD for example.
@
text
@d3 2
a4 2
 *      $Revision: 1.8 $
 *      $Date: 1994/05/06 14:15:57 $
d22 1
a22 1
 *      $Id: main.c 1.8 1994/05/06 14:15:57 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.8 1994/05/06 14:15:57 simons Exp simons $";
d98 1
a98 1
        if (!(lh = ParseSysFile("sys"))) {
d189 1
a189 1
        if (modified && !SaveSysFile("sys", lh)) {
@


1.8
log
@Changed the commandline, sendmail is called with, because the
old parameter style caused problems with wUUCP.
Now we're reading and writing the sys file in the current
directory. For testing purposes only.
@
text
@d3 2
a4 2
 *      $Revision: 1.7 $
 *      $Date: 1994/04/28 18:08:42 $
d22 1
a22 1
 *      $Id: main.c 1.7 1994/04/28 18:08:42 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.7 1994/04/28 18:08:42 simons Exp simons $";
d56 1
a56 1
        int gotcommand = 0, garbage = 0;
d148 1
a148 1
                        gotcommand++;
d160 1
a160 1
                        gotcommand++;
d189 1
a189 1
        if (!SaveSysFile("sys", lh)) {
@


1.7
log
@Changed NewsSERV's behavior: Now all commands are answered in one
reply rather then sending one mail for each reply. The reply-pipe
is opened once after startup and it's file handle is kept in a
global variable.
Removed SendHelpText().
@
text
@d3 2
a4 2
 *      $Revision: 1.6 $
 *      $Date: 1994/04/27 19:46:54 $
d22 1
a22 1
 *      $Id: main.c 1.6 1994/04/27 19:46:54 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.6 1994/04/27 19:46:54 simons Exp simons $";
d98 1
a98 1
        if (!(lh = ParseSysFile("newsctl:sys"))) {
d189 1
a189 1
        if (!SaveSysFile("CONSOLE:", lh)) {
d212 1
a212 1
        sprintf(buffer, "%s -f \"NewsSERV (NewsSERV daemon)\"", FindConfig(SENDMAIL, SENDMAIL));
@


1.6
log
@Added security checks whether strdup() failed or not.
@
text
@d3 2
a4 2
 *      $Revision: 1.5 $
 *      $Date: 1994/04/27 16:30:52 $
d22 1
a22 1
 *      $Id: main.c 1.5 1994/04/27 16:30:52 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.5 1994/04/27 16:30:52 simons Exp simons $";
d49 2
a54 1
        FILE *fh;
a86 1

d105 11
d124 1
d128 1
a128 1
                        SendHelpText(from);
d134 2
a135 1
                        sscanf(buffer, "%*s%s", site);
d139 1
a139 1
                else if (!strnicmp(buffer, "PASSWORD ", 9)) {
d141 3
a143 1
                        sscanf(buffer, "%*s%s", password);
d147 1
a147 1
                else if (!strnicmp(buffer, "LIST", 4)) {
d149 6
a154 5
                        if (fh = SendMail(from, NULL, "LIST")) {
                                fprintf(fh, "System %s is subscribed to the following newsgroups:\n", site);
                                ListSysFile(lh, site, fh);
                                fclose(fh);
                        }
d158 2
a159 1
                else if (!strnicmp(buffer, "ADD ", 4) || !strnicmp(buffer, "SUBSCRIBE ", 10)) {
d162 5
a166 9
                        if (AddSysEntry(lh, site, newsgroup)) {
                                if (fh = SendMail(from, NULL, "ADD")) {
                                        fprintf(fh, "Added \"%s\" successfully.\n", newsgroup);
                                        fclose(fh);
                                }
                        }
                        else {
                        }

d182 1
a182 1
                SendHelpText(from);
d200 2
d207 1
a207 1
FILE *SendMail(char *to, char *cc, char *command)
d218 1
a218 2
                fprintf(pipe, "Subject: Re: Your NewsSERV command '%s'\n", command);
                fprintf(pipe, "X-NewsSERV: Peti's Amiga " VERS "\n");
a224 13
}




void SendHelpText(char *to)
{
        FILE *pipe;

        if (pipe = SendMail(to, NULL, "HELP")) {
                fprintf(pipe, HELPTEXT);
                pclose(pipe);
        }
@


1.5
log
@Added support for "LIST" and "ADD" commands.
Now the sys file is parsed before the mailbody is touched.
The sys file is written back in any case.
@
text
@d3 2
a4 2
 *      $Revision: 1.4 $
 *      $Date: 1994/04/25 00:50:11 $
d22 1
a22 1
 *      $Id: main.c 1.4 1994/04/25 00:50:11 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.4 1994/04/25 00:50:11 simons Exp simons $";
d90 1
a90 1
        if (!from) {
@


1.4
log
@Added "PASSWORD" recognition.
Changed contents of "Subject:"-line slightly.
Now the help text will be returned because of indecipherable mails.
@
text
@d3 2
a4 2
 *      $Revision: 1.3 $
 *      $Date: 1994/04/25 00:39:27 $
d22 1
a22 1
 *      $Id: main.c 1.3 1994/04/25 00:39:27 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.3 1994/04/25 00:39:27 simons Exp simons $";
d52 3
a54 1
        char buffer[1024], *from = NULL, site[64], password[64];
d57 1
d95 8
d132 25
d172 9
a181 1

@


1.3
log
@Added support for the "SITE" command. Currently, you have to
specify SITE because the from address is not parsed for the
name of the machine.
@
text
@d3 2
a4 2
 *      $Revision: 1.2 $
 *      $Date: 1994/04/25 00:24:25 $
d22 1
a22 1
 *      $Id: main.c 1.2 1994/04/25 00:24:25 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.2 1994/04/25 00:24:25 simons Exp simons $";
d52 1
a52 1
        char buffer[1024], *from = NULL, site[64];
d71 1
d115 6
d133 1
d159 1
a159 1
                fprintf(pipe, "Subject: Your NewsSERV command '%s'\n", command);
@


1.2
log
@Added parsing of the piped message: "From:" has to be determined.
Added simple parsing of the messagebody. Currently only HELP requests
are recognized.
Added SendMail() and SendHelpText() routines.
@
text
@d3 2
a4 2
 *      $Revision: 1.1 $
 *      $Date: 1994/04/24 21:36:50 $
d22 1
a22 1
 *      $Id: main.c 1.1 1994/04/24 21:36:50 simons Exp simons $
d44 1
a44 1
static char rcssid[] = "$Id: main.c 1.1 1994/04/24 21:36:50 simons Exp simons $";
d52 1
a52 1
        char buffer[1024], *from = NULL;
d70 1
d107 7
@


1.1
log
@Initial revision
@
text
@d3 2
a4 2
 *      $Revision$
 *      $Date$
d22 1
a22 1
 *      $Id$
d28 4
d44 4
a47 2
static char rcssid[] = "$Id$";
static char dosid[] = VERSTAG;
d52 68
d121 1
d127 37
@
