head	1.6;
access;
symbols
	v0_2:1.6
	v0_1:1.6;
locks
	simons:1.6; strict;
comment	@ * @;


1.6
date	94.05.06.14.17.20;	author simons;	state Exp;
branches;
next	1.5;

1.5
date	94.04.27.19.46.54;	author simons;	state Exp;
branches;
next	1.4;

1.4
date	94.04.27.15.29.16;	author simons;	state Exp;
branches;
next	1.3;

1.3
date	94.04.27.14.25.34;	author simons;	state Exp;
branches;
next	1.2;

1.2
date	94.04.27.14.21.56;	author simons;	state Exp;
branches;
next	1.1;

1.1
date	94.04.24.21.36.50;	author simons;	state Exp;
branches;
next	;


desc
@Routines responsible for parsing the sys-file and generating
the sys-file list.
@


1.6
log
@NewsSERV understands now the '\' line-continuation sign in
the sys file.
@
text
@/*
 *      $Filename: parse.c $
 *      $Revision: 1.5 $
 *      $Date: 1994/04/27 19:46:54 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: parse.c 1.5 1994/04/27 19:46:54 simons Exp simons $
 *
 */

/************************************* includes ***********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "newsserv.h"
#include "protos.h"

/************************************* defines ************/

/************************************* prototypes *********/

/************************************* global variables ***/
static const char __RCSId[] = "$Id: parse.c 1.5 1994/04/27 19:46:54 simons Exp simons $";

/************************************* program ************/

struct ListHead *ParseSysFile(char *filename)
{
        struct ListHead *lh, *first_lh, *tmp;
        FILE *fh;
        int c, firstrun = TRUE;

        if (!(first_lh = lh = calloc(1, sizeof(struct ListHead))))
                return NULL;

        if (fh = fopen(filename, "r")) {

                while (TRUE) {
                        c = getc(fh);
                        switch (c) {
                          case EOF:
                                break;
                          case ' ':
                          case '#':
                                while ( (c = getc(fh)) != EOF && c != '\n' )    ;
                                if (c == EOF)
                                        break;
                          case '\n':
                                continue;
                          default:
                                ungetc(c, fh);
                        }
                        if (c == EOF)
                                break;

                        if (firstrun == FALSE) {
                                if (!(tmp = calloc(1, sizeof(struct ListHead))))
                                        return NULL;
                                lh->lh_NextListHead = tmp;
                                lh = tmp;
                        }
                        else
                                firstrun = FALSE;

                        if (!ParseLine(lh, fh))
                                return NULL;
                }
                fclose(fh);
        }

        return first_lh;
}

int AddEntry(struct ListHead *lh, char *entry)
{
        struct NewsEntry *ne, *tmp;

        if (!entry || !*entry)
                return FALSE;

        if (!(ne = malloc(sizeof(struct NewsEntry))))
                return FALSE;

        ne->ne_NextEntry = NULL;
        if (!(ne->ne_NewsEntry = strdup(entry)))
                return FALSE;

        if (lh->lh_FirstNewsEntry) {
                tmp = lh->lh_FirstNewsEntry;
                while (tmp->ne_NextEntry)
                        tmp = tmp->ne_NextEntry;
                tmp->ne_NextEntry = ne;
        }
        else
                lh->lh_FirstNewsEntry = ne;

        return TRUE;
}

int ParseLine(struct ListHead *lh, FILE * fh)
{
        char buffer[1024];
        int i, c;

        for (i = 0; (c = getc(fh)) != ':'; i++) {
                if (c == EOF)
                        return FALSE;
                buffer[i] = c;
        }
        buffer[i] = '\0';
        if (!(lh->lh_LinePrefix = strdup(buffer)))
                return FALSE;

        for (i = 0; buffer[i] != '/' && buffer[i]; i++) ;
        buffer[i] = '\0';
        if (!(lh->lh_SystemName = strdup(buffer)))
                return FALSE;

        for (i = 0; (c = getc(fh)) != '/'; ) {
                switch(c) {
                  case EOF:
                        return FALSE;
                  case ',':
                        buffer[i] = '\0';
                        if (!AddEntry(lh, buffer))
                                return FALSE;
                        i = 0;
                        break;
                  case '\\':
                        do {
                                if ((c = getc(fh)) == EOF)
                                        return FALSE;
                        } while (c != '\n');
                        do {
                                if ((c = getc(fh)) == EOF)
                                        return FALSE;
                        } while (isspace(c));
                        ungetc(c, fh);
                        break;
                  default:
                        buffer[i++] = c;
                }
        }
        if (i) {
                buffer[i] = '\0';
                if (!AddEntry(lh, buffer))
                        return FALSE;
        }

        if (!fgets(buffer, 1023, fh))
                return FALSE;
        if (!(lh->lh_LineAppendix = strdup(buffer)))
                return TRUE;

        return TRUE;
}
@


1.5
log
@Added security checks whether strdup() failed or not.
@
text
@d3 2
a4 2
 *      $Revision: 1.4 $
 *      $Date: 1994/04/27 15:29:16 $
d22 1
a22 1
 *      $Id: parse.c 1.4 1994/04/27 15:29:16 simons Exp simons $
d30 1
d40 1
a40 1
static const char __RCSId[] = "$Id: parse.c 1.4 1994/04/27 15:29:16 simons Exp simons $";
d136 3
a138 2
        for (i = 0; (c = getc(fh)) != '/';) {
                if (c == EOF)
d140 1
a140 1
                if (c == ',') {
d145 14
a159 2
                else
                        buffer[i++] = c;
@


1.4
log
@Fixed minor bugs that occured when the subscription list for
the site was empty.
@
text
@d3 2
a4 2
 *      $Revision: 1.3 $
 *      $Date: 1994/04/27 14:25:34 $
d22 1
a22 1
 *      $Id: parse.c 1.3 1994/04/27 14:25:34 simons Exp simons $
d39 1
a39 1
static const char __RCSId[] = "$Id: parse.c 1.3 1994/04/27 14:25:34 simons Exp simons $";
d101 2
a102 1
        ne->ne_NewsEntry = strdup(entry);
d127 2
a128 1
        lh->lh_LinePrefix = strdup(buffer);
d132 2
a133 1
        lh->lh_SystemName = strdup(buffer);
d155 2
a156 1
        lh->lh_LineAppendix = strdup(buffer);
@


1.3
log
@Add RCS ident string.
@
text
@d3 2
a4 2
 *      $Revision: 1.2 $
 *      $Date: 1994/04/27 14:21:56 $
d22 1
a22 1
 *      $Id: parse.c 1.2 1994/04/27 14:21:56 simons Exp simons $
d39 1
a39 1
static const char __RCSId[] = "$Id$";
d47 1
a47 1
        int c;
d72 9
a82 5

                        if (!(tmp = calloc(1, sizeof(struct ListHead))))
                                return NULL;
                        lh->lh_NextListHead = tmp;
                        lh = tmp;
d94 3
d98 1
a98 1
                 return FALSE;
d144 5
a148 1
        buffer[i] = '\0';
@


1.2
log
@Added first version of the sysfile parsing code, consisting of
ParseSysFile(), ParseLine() and AddEntry().
@
text
@d3 2
a4 2
 *      $Revision: 1.1 $
 *      $Date: 1994/04/24 21:36:50 $
d22 1
a22 1
 *      $Id: parse.c 1.1 1994/04/24 21:36:50 simons Exp simons $
d39 1
@


1.1
log
@Initial revision
@
text
@d3 2
a4 2
 *      $Revision$
 *      $Date$
d22 1
a22 1
 *      $Id$
d26 4
a30 1
/************************************* includes ***********/
d42 102
@
