head	1.3;
access;
symbols
	v0_2:1.3
	v0_1:1.3;
locks
	simons:1.3; strict;
comment	@ * @;


1.3
date	94.04.25.00.24.25;	author simons;	state Exp;
branches;
next	1.2;

1.2
date	94.04.24.21.55.03;	author simons;	state Exp;
branches;
next	1.1;

1.1
date	94.04.24.21.47.52;	author simons;	state Exp;
branches;
next	;


desc
@System dependent stuff. Might need some work while porting.
@


1.3
log
@Added popen() routines. Can't use the netsupport.library because
we have to use the ANSI-C i/o routines.
Added routines for maintaining a logfile.
Added rootines for parsing config files.
@
text
@/*
 *      $Filename: system.c $
 *      $Revision: 1.2 $
 *      $Date: 1994/04/24 21:55:03 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: system.c 1.2 1994/04/24 21:55:03 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#ifdef AMIGA
#       include <exec/exec.h>
#       include <dos/dos.h>
#       include <libraries/netsupport.h>
#       include <proto/exec.h>
#       include <proto/dos.h>
#       include <proto/netsupport.h>
#endif

#include "newsserv.h"
#include "protos.h"

/************************************* defines ************/

/************************************* prototypes *********/

/************************************* global variables ***/
#ifdef AMIGA
struct NetSupportLibrary *NetSupportBase = NULL;
#endif

static const char __RCSId[] = "$Id: system.c 1.2 1994/04/24 21:55:03 simons Exp simons $";


/************************************* program ************/

 /*
  * Initialize and open all required system resources we'll
  * need for our program.
  */
int InitSystem(void)
{
#ifdef AMIGA
        if (!(NetSupportBase = (struct NetSupportLibrary *) OpenLibrary(NETSUPPORTNAME, 0L))) {
                fprintf(stderr, "FATAL ERROR: Failed opening %s!\n", NETSUPPORTNAME);
                return 0;
        }

        if (!(DOSBase = (struct DosLibrary *) OpenLibrary(DOSNAME, 0L))) {
                CloseLibrary((struct Library *) NetSupportBase);
                fprintf(stderr, "FATAL ERROR: Failed opening %s!\n", DOSNAME);
                return 0;
        }
#endif
        return 1;
}



 /*
  * Free all previously allocated system resources.
  */
void FreeSystem(void)
{
#ifdef AMIGA
        if (NetSupportBase) {
                UnLockFiles();
                CloseLibrary((struct Library *) NetSupportBase);
        }

        if (DOSBase)
                CloseLibrary((struct Library *) DOSBase);
#endif
}


 /*
  * Routines to maintain a logfile.
  */
void LogError(char *fmt, ...)
{
#ifdef AMIGA
        va_list ap;
        va_start(ap, fmt);
        MakeLogEntryA(NEWSSERV, MLE_ERROR, fmt, ap);
#endif
}


void LogFatalError(char *fmt, ...)
{
#ifdef AMIGA
        va_list ap;
        va_start(ap, fmt);
        MakeLogEntryA(NEWSSERV, MLE_FATAL_ERROR, fmt, ap);
#endif
}


void LogInfo(char *fmt, ...)
{
#ifdef AMIGA
        va_list ap;
        va_start(ap, fmt);
        MakeLogEntryA(NEWSSERV, MLE_INFO, fmt, ap);
#endif
}



 /*
  * Routines for piping text to other programs. popen() is usually part
  * of the operating system. Not on the amiga, though. :-)
  */
#ifdef AMIGA
FILE *popen(char *command, char *mode)
{
        static int pipeno = 0;
        FILE *fh = NULL;
        static char pipename[32];
        char *buffer;

        sprintf(pipename, "PIPE:%ld.%d", FindTask(NULL), pipeno++);
        if (!(buffer = malloc(strlen(command)+strlen(pipename)+16)))
                return NULL;

        if (!strcmp(mode, "w")) {
                sprintf(buffer, "run <>NIL: %s <%s", command, pipename);
                fh = fopen(pipename, "w");
        }
        else if (!strcmp(mode, "r")) {
                sprintf(buffer, "run <>NIL: %s >%s", command, pipename);
                fh = fopen(pipename, "r");
        }

        System(buffer, NULL);

        free(buffer);
        return fh;
}


int pclose(FILE *fh)
{
        fclose(fh);
        return 0;
}

#endif  /* AMIGA */


 /*
  * Routines for parsing config files.
  */

char *FindConfig(char *keyword, char *def)
{
#ifdef AMIGA
        /*
         * GetConfig() is part of the netsupport.library and returns a buffer
         * that is only valid until the very next GetConfig()-call. There's
         * no need to free the memory, just be careful then using the contents.
         * Better make a copy for your own use!
         *
         * In case, <keyword> can't be found, the provided default <def>
         * will be returned.
         */

        return (char *) GetConfig(NULL, keyword, NULL, def);
#endif
}
@


1.2
log
@Added InitSystem() and FreeSystem().
@
text
@d3 2
a4 2
 *      $Revision: 1.1 $
 *      $Date: 1994/04/24 21:47:52 $
d22 1
a22 1
 *      $Id: system.c 1.1 1994/04/24 21:47:52 simons Exp simons $
d29 3
d53 1
a53 1
static const char __RCSId[] = "$Id$";
a61 1

d81 3
a83 2
 /* Free all previously allocated system resources. */

d97 96
@


1.1
log
@Initial revision
@
text
@d3 2
a4 2
 *      $Revision$
 *      $Date$
d22 1
a22 1
 *      $Id$
d28 10
d46 6
d54 39
@
