       The sys file line  has  four  fields,  each  separated  by
       colons:

       systemname/exclusion1,exclusion2...:subscription
       list/distributionlist:flags:transmission command

       A # as the first character in a line  denotes  a  comment.
       Empty  lines are ignored.  A logical line may be continued
       to the next physical line by putting a \ at the end of the
       current  physical  line.  Spaces are permitted in sys only
       in comments, transmission command when it really is a com
       mand and not a filename, and, for B news compatibility, at
       the start of a continuation line (after a  \  and  a  new
       line).

       Of  the  sys fields, only the systemname need be present.
       If a field and all the fields after it  are  omitted,  the
       colon  immediately  before  that  field and all the colons
       after it may  be  omitted  too.   The  optional  subfields
       (exclusions   and  distributionlist)  and  their  leading
       slashes may be omitted.

       The system name is the name of the system being  sent  to,
       and  is  checked  against  site  names in Path: headers to
       avoid sending an article back to a site that has seen  it.
       The  exclusions  are also checked against the Path: header
       and articles are not sent to system name if they have vis
       ited any of the exclusions.

       The  special  system  name  ME  stands for the name of the
       machine  news  is   running   on,   as   determined   from
       /usr/lib/news/whoami.   (The ME line, or a line whose sys
       tem name is explicitly that of the machine news is running
       on,  has a rather different meaning from that of the other
       sys file lines: its subscriptionlist subfield  identifies
       the newsgroups that this site subscribes to (i.e. is will
       ing to receive), and its other fields  and  subfields  are
       ignored.)

       subscriptions  is a commaseparated list of newsgroup pat
       terns specifying the newsgroups to be transmitted  to  the
       system; each newsgroup from the Newsgroups: header of each
       article is matched against the pattern list,  and  if  any
       newsgroup  matches the pattern list, the article is trans
       mitted.  The rules for matching a newsgroup against a sin
       gle pattern are:

       o  words  in  a  newsgroup  or  a pattern are delimited by
          periods;

       o  words of a pattern and a newsgroup match only  if  they
          are  identical,  except  that the word all in a pattern
          matches any newsgroup word;

       o  a newsgroup is matched against a pattern word by  word,
          and  all  words  must  match for the newsgroup to match
          that pattern;

       o  if the pattern has fewer words than the newsgroup,  the
          pattern  is  implicitly  extended to the same number of
          words by appending .all as many times as necessary;

       o  if the newsgroup has fewer words than the pattern,  the
          newsgroup does not match the pattern;

       o  if  pattern  matches  a  newsgroup, !pattern mismatches
          that newsgroup.

       A newsgroup matches a pattern list if,  and  only  if,  it
       matches at least one of the patterns and:

       o  the newsgroup does not mismatch any of the patterns, or

       o  the longest matched pattern is longer than the  longest
          mismatched  pattern  (length  is  measured in number of
          words, with each explicit occurrence of all counted  as
          slightly  less  than one word, and does not include the
          implicit extension of patterns with .all).

       Note that order in the lists is not significant, and  that
       ties  are  broken  in  favor of not matching.  An example:
       comp,comp.sys.sun,!comp.sys matches all the  comp  groups,
       except the comp.sys groups but including comp.sys.sun.

       The  distributions  in  the Distribution: header are simi
       larly matched against the distributionlist.  If  no  dis
       tributions  are  supplied,  Distribution:  will be matched
       against the  subscriptions  instead.   (The  Distribution:
       header is ignored when receiving news; it is only signifi
       cant when sending.)

       Note that some older  news  software  reportedly  attached
       magical  significance  to  the distributions ``world'' and

       ``local''; C News treats  them  as  ordinary  distribution
       names with no special properties (except that ``world'' is
       the default distribution of an  article  if  none  appears
       explicitly).   For  example,  a  distributions  list  like
       all,!local will not prevent local articles from being sent
       unless they contain explicit Distribution: local lines.

       The  flags are a set of letters describing how the article
       should be transmitted.  Valid flags include  f  (interpret
       transmission command as a file name and write the name and
       size in bytes of each article on the end of it), F (like f
       but  omit  the  size),  I  (like  F but write MessageID:s
       instead of filenames), n (like F but write  a  MessageID:
       after  each  filename),  Ln  (only send articles generated
       within n hops of here; 0 is the default value  for  n),  m
       (transmit  only moderated groups), u (transmit only unmod
       erated groups).  There are other obsolete ones.

       The transmission command is executed by the shell with the
       article  to  be  transmitted  as  the standard input.  The
       default is `uux - -z -r sysname!rnews' for a command;  the
       PATH searched includes /usr/lib/newsbin/relay, so that the
       commands described in newsmail(8) are available as  alter
       natives to uux.  If one of the flags has caused this field
       to   be   taken   as   a   filename,   the   default    is
       /usr/spool/news/out.going/sysname/togo;  if  a filename is
       given but it does not start with `/', it is assumed to  be
       relative to the /usr/spool/news/out.going directory.

       Some examples:

            # line indicating what we are willing to receive; note local groups on end
            ME:comp,news,sci,rec,misc,soc,talk,to,can,ont,tor,ut
            # sample insignificant feed not using batching
            huey:news.config,to.huey/all::uux  r gd huey!rnews
            # sample major batched feed, including (unnecessary) explicit file name
            dewey:comp,news,sci,rec,misc,soc,talk,to.dewey,can,ont,tor,ut/all:f:dewey/togo
            # sample longhaul feed; note no local groups
            donald:comp,news,sci,rec,misc,soc,talk,to.donald/all:f:
            # sample localpostingsonly feed direct to major site (gets them out fast)
            scrooge:comp,news,sci,rec,misc,soc,talk,to.scrooge/all:Lf:
            # sample ihave/sendme link
            # Send ihave telling louie what we have  batcher turns the batch into a
            # giant control message and posts it to "to.louie".  (#1)
            louie:rec.music.synth/all,!sendme,!ihave:I:louie.ihave/togo
            # Send sendme in response to ihave from louie  again, turned by batcher
            # into giant control message posted to "to.louie".  (#3)
            louiesendids:to.louie/ihave:I:louie.sendme/togo
            # Transmit said giant control messages by normal batching.  (#2,#4)
            louiectl:to.louie/all,!sendme,!ihave:f:louie/togo
            # Send articles in response to sendme messages from louie. (#5)
            louiereal:to.louie/sendme:f:louie/togo
            # Actually the last two could be combined.


       (The  ``to.sysname'' groups are normal newsgroups used for
       testing individual news feeds.)

       Somewhere in the sys file, there must be a  line  for  the
       host system.  This line has no flags or commands.
