head	1.5;
access;
symbols;
locks
	simons:1.5; strict;
comment	@ * @;


1.5
date	95.02.16.18.21.43;	author simons;	state Exp;
branches;
next	1.4;

1.4
date	95.02.16.17.26.33;	author simons;	state Exp;
branches;
next	1.3;

1.3
date	95.02.16.17.16.15;	author simons;	state Exp;
branches;
next	1.2;

1.2
date	95.02.16.16.48.07;	author simons;	state Exp;
branches;
next	1.1;

1.1
date	95.02.16.14.27.08;	author simons;	state Exp;
branches;
next	;


desc
@NotifyRMail can be used to notify the people who write you
that your address will change soon or has already changed.
It will parse the header for the To: header and determine
whether the mail was addressed to your old address. If,
it will send the notification out.
@


1.5
log
@Added the notify-code, which sends the address-change
notification to the envelope.

Added the real piping code of the real message to the
real rmail.

Added LogInfo().
@
text
@/*
 *      $Filename: NotifyRMail.c $
 *      $Revision: 1.4 $
 *      $Date: 1995/02/16 17:26:33 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@@peti.rhein.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: NotifyRMail.c 1.4 1995/02/16 17:26:33 simons Exp simons $
 *
 */


/************************************* includes ***********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <dos/dos.h>
#include <libraries/netsupport.h>
#include <proto/netsupport.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "NotifyRMail_rev.h"

/************************************* defines ************/
#define USAGE   "USAGE: NotifyRMail <mailfile\n address1 address2 [...]"
#define PRGNAME "ModifyRMail"

#define REALRMAIL "RealRMail"
#define OLDSYSTEM "peti.GUN.de"
#define NEWSYSTEM "peti.rhein.de"

#define NOTIFYTEXT \
"You have sent an e-mail to an user of " OLDSYSTEM ". The address of my\n" \
"machine has changed.\n"



/************************************* prototypes *********/
int InitSystem(void);
void FreeSystem(void);
void LogError(char *,...);
void LogInfo(char *fmt,...);
void ParseAddress(char *);
char *TransformAddress(char *);
char *FindString(char *, char *);

/************************************* global variables ***/
static char rcssid[] = "$Id: NotifyRMail.c 1.4 1995/02/16 17:26:33 simons Exp simons $";
static char dosid[] = VERSTAG " written by by Peter Simons <simons@@peti.rhein.de>";
struct NetSupportLibrary *NetSupportBase;
BPTR fh = NULL;

/************************************* program ************/
int main(int argc, char **argv)
{
        char buffer[1024], cmd[1024], tmp[1024], *to, *envelope;
        int i;
        BPTR sendmailfh;

        /*
         * Initialize system resources.
         */
        if (!InitSystem())
                return 50;
        if (atexit(FreeSystem)) {
                FreeSystem();
                return 50;
        }


        /*
         * Check command line syntax.
         */
        if (argc < 2) {
                LogError("USAGE: %s <mailfile address1 address2 [...]", PRGNAME);
                return 20;
        }


        /*
         * Build command line to call the real rmail.
         */
        strcpy(cmd, GetConfig(NULL, REALRMAIL, NULL, REALRMAIL));
        for (i = 1; i < argc; i++) {
                strcat(cmd, " ");
                strcat(cmd, TransformAddress(argv[i]));
        }
        if (!(fh = POpen(cmd, MODE_PIPETO))) {
                LogError("Can't open pipe to \"%s\"!", cmd);
                return 15;
        }

        /*
         * Parse enveloper for return address.
         */
        if (!gets(buffer)) {
                LogError("Couldn't read mail from stdin");
                return 15;
        }
        FPrintf(fh, "%s\n", buffer);
        sscanf(buffer, "%*s%s", tmp);
        envelope = strdup(tmp);


        /*
         * Parse header for "To:" entry.
         */
        while (gets(buffer) && *buffer != '\0') {
                FPrintf(fh, "%s\n", buffer);    /* Pipe line to real mail */
                if (!strnicmp(buffer, "To:", 3))
                        if (to = strdup(buffer+3))
                                ParseAddress(to);
        }
        FPrintf(fh, "\n");


        /*
         * Copy rest of the mail to the real RMail.
         */
        while (gets(buffer)) {
                FPrintf(fh, "%s\n", buffer);    /* Pipe line to real mail */
        }
        PClose(fh); fh = NULL;


        /*
         * Check to validity.
         */
        if (!to || !(*to)) {
                LogError("Received mail without 'To:'-line!");
                return 10;
        }
        if (!envelope || !(*envelope)) {
                LogError("Received mail without valid envelope!");
                return 10;
        }

        /*
         * Shall we send the notification out?
         */
        if (FindString(to, OLDSYSTEM))
                LogInfo("Sending address-change notification to \"%s\"", envelope);
                if (sendmailfh = POpen(GetConfig(NULL, SENDMAIL, NULL, SENDMAIL), MODE_PIPETO)) {
                        FPrintf(sendmailfh, "From: postmaster@@%s", GetConfig(NULL, NODENAME, NULL, NODENAME)); FPrintf(sendmailfh, "%s\n", GetConfig(NULL, DOMAINNAME, NULL, DOMAINNAME));
                        FPrintf(sendmailfh, "To: %s\n", envelope);
                        FPrintf(sendmailfh, "Cc: postmaster\n");
                        FPrintf(sendmailfh, "Subject: Sent address-change notification to \"%s\"\n\n", envelope);
                        FPrintf(sendmailfh, NOTIFYTEXT);
                        PClose(sendmailfh);
                }
                else
                        LogError("Couldn't open pipe to sendmail!");

        return 0;
}


 /*
  * Routines to maintain a logfile.
  */
void LogError(char *fmt, ...)
{
        va_list ap;
        va_start(ap, fmt);
        MakeLogEntryA(PRGNAME, MLE_FATAL_ERROR, fmt, ap);
}
void LogInfo(char *fmt, ...)
{
        va_list ap;
        va_start(ap, fmt);
        MakeLogEntryA(PRGNAME, MLE_INFO, fmt, ap);
}


 /*
  * Find the address part in an RFC line.
  */
void ParseAddress(char *line)
{
        int brackets, i, z;
        char *p1, *p2;

        p1 = p2 = line;
        while(isspace(*p1))
                p1++;
        if (p1 > p2)
                while(*p2++ = *p1++)
                        ;

        for (i = 0, z = 0, brackets = 0; line[i] != '\0'; i++) {
                if (line[i] == '(')
                        brackets++;
                else if (line[i] == ')')
                        brackets--;
                else if (line[i] == '<' && brackets == 0) {
                        i++;
                        while (1) {             /* Forever! */
                                if (line[i] == '>' && (line[i+1] == '\0' || isspace(line[i+1])))
                                        break;
                                line[z++] = line[i++];
                        }
                        line[z] = '\0';
                        break;
                }
        }
        if (z == 0) {   /* No <address> occured. */
                i = 0;
                while (!isspace(line[i]))
                        i++;
                line[i] = '\0';
        }
}

char *TransformAddress(char *address)
{
        char *p;

        if (p = strchr(address, '@@')) {
                if (!(stricmp(OLDSYSTEM, p+1)))
                        *p = '\0';
        }
        else if (!(strnicmp(OLDSYSTEM, address, strlen(OLDSYSTEM))))
                return address+strlen(OLDSYSTEM)+1;

        return address;
}

char *FindString(char *text, char *string)
{
        int i = strlen(text) - strlen(string);

        while(i >= 0) {
                if (!(stricmp(text+i, string)))
                        return text+i;
                i--;
        }

        return NULL;
}


int InitSystem(void)
{
        if (!(NetSupportBase = (struct NetSupportLibrary *) OpenLibrary(NETSUPPORTNAME, 0L)))
                return 0;

        return 1;
}



 /*
  * Free all previously allocated system resources.
  */
void FreeSystem(void)
{
        if (fh)
                PClose(fh);

        if (NetSupportBase) {
                UnLockFiles();
                CloseLibrary((struct Library *) NetSupportBase);
        }
}

@


1.4
log
@Added the real piping code that hands the mail over to
the real RMail.
@
text
@d3 2
a4 2
 *      $Revision: 1.3 $
 *      $Date: 1995/02/16 17:16:15 $
d22 1
a22 1
 *      $Id: NotifyRMail.c 1.3 1995/02/16 17:16:15 simons Exp simons $
d45 1
a45 1
#define REALRMAIL "RMail"
d49 6
d59 1
d65 1
a65 1
static char rcssid[] = "$Id: NotifyRMail.c 1.3 1995/02/16 17:16:15 simons Exp simons $";
d75 1
d100 1
a100 1
        strcpy(cmd, REALRMAIL);
a104 1
        printf("\"%s\"\n", cmd);
d117 1
a117 1
        FPuts(fh, buffer);
d126 1
a126 2
                FPuts(fh, buffer);      /* Pipe line to real mail */
                FPuts(fh, "\n");
d131 1
a131 1
        FPuts(fh, "\n");
d138 1
a138 2
                FPuts(fh, buffer);      /* Pipe line to real mail */
                FPuts(fh, "\n");
d150 4
d159 11
a169 1
                printf("To matches!\n");
d184 6
d261 1
a261 2
        if (!(NetSupportBase = (struct NetSupportLibrary *) OpenLibrary(NETSUPPORTNAME, 0L))) {
                fprintf(stderr, "FATAL ERROR: Failed opening %s!\n", NETSUPPORTNAME);
a262 1
        }
@


1.3
log
@Added code to open pipe to the real RMail.

Added code to determine the envelope address.
@
text
@d3 2
a4 2
 *      $Revision: 1.2 $
 *      $Date: 1995/02/16 16:48:07 $
d22 1
a22 1
 *      $Id: NotifyRMail.c 1.2 1995/02/16 16:48:07 simons Exp simons $
d37 1
d58 1
a58 1
static char rcssid[] = "$Id: NotifyRMail.c 1.2 1995/02/16 16:48:07 simons Exp simons $";
d110 1
d119 2
d125 11
@


1.2
log
@Add code that builds the rmail-command line and recognizes if
a mail is addresses to the old address.

NotifyRMail recognizes if the To: line points to the old
address now.
@
text
@d3 2
a4 2
 *      $Revision: 1.1 $
 *      $Date: 1995/02/16 14:27:08 $
d22 1
a22 1
 *      $Id: NotifyRMail.c 1.1 1995/02/16 14:27:08 simons Exp simons $
a32 1
#include <exec/exec.h>
d35 1
a36 2
#include <proto/dos.h>
#include <proto/netsupport.h>
d44 1
d57 1
a57 1
static char rcssid[] = "$Id: NotifyRMail.c 1.1 1995/02/16 14:27:08 simons Exp simons $";
d60 1
d65 1
a65 1
        char buffer[1024], cmd[1024], *to, *envelope;
d83 1
a83 1
                LogError("USAGE: NotifyRMail <mailfile address1 address2 [...]");
d91 1
a91 1
        strcpy(cmd, "RMail ");
d93 1
a94 1
                strcat(cmd, " ");
d96 5
a100 2
        printf("%s\n", cmd);

d109 2
a140 24
int InitSystem(void)
{
        if (!(NetSupportBase = (struct NetSupportLibrary *) OpenLibrary(NETSUPPORTNAME, 0L))) {
                fprintf(stderr, "FATAL ERROR: Failed opening %s!\n", NETSUPPORTNAME);
                return 0;
        }

        return 1;
}



 /*
  * Free all previously allocated system resources.
  */
void FreeSystem(void)
{
        if (NetSupportBase) {
                UnLockFiles();
                CloseLibrary((struct Library *) NetSupportBase);
        }
}


d216 27
@


1.1
log
@Initial revision
@
text
@d3 2
a4 2
 *      $Revision$
 *      $Date$
d22 1
a22 1
 *      $Id$
d54 2
d58 1
a58 1
static char rcssid[] = "$Id$";
d65 2
a66 1
        char buffer[1024], *to, *envelope;
d89 11
d125 6
a130 1
        printf("To: %s\n", to);
d208 27
@
