head	1.8;
access;
symbols
	v2_0:1.8
	v2_1:1.3;
locks
	simons:1.8; strict;
comment	@ * @;


1.8
date	94.07.08.11.49.24;	author simons;	state Exp;
branches;
next	1.7;

1.7
date	94.03.13.18.40.51;	author simons;	state Exp;
branches;
next	1.6;

1.6
date	94.03.13.18.20.01;	author simons;	state Exp;
branches;
next	1.5;

1.5
date	94.03.10.01.30.40;	author simons;	state Exp;
branches;
next	1.4;

1.4
date	94.03.10.01.22.33;	author simons;	state Exp;
branches;
next	1.3;

1.3
date	94.03.09.22.39.29;	author simons;	state Exp;
branches;
next	1.2;

1.2
date	93.09.24.23.12.19;	author simons;	state Stab;
branches;
next	1.1;

1.1
date	93.09.24.22.47.13;	author simons;	state Exp;
branches;
next	;


desc
@This file contains all routines accessing the AmigaOS. This is
the file you should look into when porting PGPSendMail.
@


1.8
log
@Changed the name of the requester to the VERS macro defined
by bumprev, to avoid warning when compiling a pure version.
@
text
@/*
 *      $Filename: system.c $
 *      $Revision: 1.7 $
 *      $Date: 1994/03/13 18:40:51 $
 *
 *      Copyright (C) 1993 by Peter Simons <simons@@peti.GUN.de>
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *      $Id: system.c 1.7 1994/03/13 18:40:51 simons Exp simons $
 *
 */


/**************************************************************************
 *                                                                        *
 * Sektion: Macros, Definitions, Includes, Structures                     *
 *                                                                        *
 **************************************************************************/

/************************************* Includes ***********/
#include <string.h>

#include <proto/intuition.h>
#include <intuition/intuition.h>

#include "pgpsendmail.h"
#include "pgpsendmail_rev.h"

/************************************* Defines ************/

/************************************* Prototypes *********/

/************************************* global Variables ***/
static const char __RCSId[] = "$Id: system.c 1.7 1994/03/13 18:40:51 simons Exp simons $";


/**************************************************************************
 *                                                                        *
 * Sektion: Subroutines                                                   *
 *                                                                        *
 **************************************************************************/


 /*
  * PORT NOTE: The AmigaOS supports easy requesters which are wonderful for our
  * purpose. Other platforms might have a similar feature.
  */

int ConfirmEncryption(void)
{
        struct EasyStruct es = {
                sizeof(struct EasyStruct),
                0L,
                VERS,
                "A public key for all receipients of this mail is\n" \
                        "available. Shall I encrypt it, using PGP?",
                "encrypt|do not encrypt"
        };

        return EasyRequestArgs(0L, &es, 0L, 0L);
}



 /*
  * PORT NOTE: On the Amiga, a routine get the original, unparsed commandline is available.
  * Other platforms might need to re-build it using the argc and argv parameter.
  */

char *GetOriginalCmdLine(int argc, char **argv)
{
        char *ptr;

        if (ptr = GetArgStr()) {
                ptr[strlen(ptr)-1] = '\0';
                return ptr;
        }
        else
                return "";
}

@


1.7
log
@Changed gadgets texts in the confirm-requester.
Added security check in case GetArgStr() fails and return NULL.
@
text
@d3 2
a4 2
 *      $Revision: 1.6 $
 *      $Date: 1994/03/13 18:20:01 $
d22 1
a22 1
 *      $Id: system.c 1.6 1994/03/13 18:20:01 simons Exp simons $
d40 1
a40 1
#include "protos.h"
d47 1
a47 1
static const char __RCSId[] = "$Id: system.c 1.6 1994/03/13 18:20:01 simons Exp simons $";
d67 1
a67 1
                PRGNAME,
@


1.6
log
@Removed TruncFile(). The new pgpsendmail doesn't need it anymore.
Added GetOriginalCmdLine().
@
text
@d3 2
a4 2
 *      $Revision: 1.5 $
 *      $Date: 1994/03/10 01:30:40 $
d22 1
a22 1
 *      $Id: system.c 1.5 1994/03/10 01:30:40 simons Exp simons $
d47 1
a47 1
static const char __RCSId[] = "$Id: system.c 1.5 1994/03/10 01:30:40 simons Exp simons $";
d70 1
a70 1
                "yes|no"
d87 6
a92 3
        ptr = GetArgStr();
        ptr[strlen(ptr)-1] = '\0';
        return ptr;
@


1.5
log
@Added GNU GPL license to the source header.
@
text
@d3 2
a4 2
 *      $Revision: 1.4 $
 *      $Date: 1994/03/10 01:22:33 $
d22 1
a22 1
 *      $Id: system.c,v 1.4 1994/03/10 01:22:33 simons Exp simons $
d34 2
a35 2
#include <proto/dos.h>
#include <dos/dos.h>
d39 1
d47 1
a47 1
static const char __RCSId[] = "$Id: system.c,v 1.4 1994/03/10 01:22:33 simons Exp simons $";
a55 15
int TruncFile(char *filename, int pos)
        /*
         * Function: This routine truncates a file at a given positition.
         * Comment : AmigaDOS v2.04+ is required.
         */
{
        BPTR fh;

        if ((fh = Open(filename, MODE_OLDFILE)) == NULL)
                return 0;

        pos = SetFileSize(fh, pos, OFFSET_BEGINNING);
        Close(fh);
        return (pos == -1) ? 0 : 1;
}
d57 4
d74 16
@


1.4
log
@Changed all occurances of "PGPSendmail" to PRGNAME. This saves
more than 200 byte!
@
text
@d3 2
a4 2
 *      $Revision: 1.3 $
 *      $Date: 1994/03/09 22:39:29 $
d6 1
a6 2
 *      This file contains all routines accessing the AmigaOS. This is
 *      the file you should look into when porting PGPSendMail.
d8 4
a11 2
 *       Copyright 1993 Peter Simons, Germany
 *        All Rights Reserved
d13 4
a16 1
 *      $Id: system.c,v 1.3 1994/03/09 22:39:29 simons Exp simons $
d18 6
d46 1
a46 1
static const char __RCSId[] = "$Id: system.c,v 1.3 1994/03/09 22:39:29 simons Exp simons $";
@


1.3
log
@Removed the RCS history from the source file.
@
text
@d3 2
a4 2
 *      $Revision: 1.2 $
 *      $Date: 1993/09/24 23:12:19 $
d12 1
a12 1
 *      $Id: system.c,v 1.2 1993/09/24 23:12:19 simons Stab simons $
d29 2
d36 1
a36 1

a37 1
        static const char __RCSId[] = "$Id: system.c,v 1.2 1993/09/24 23:12:19 simons Stab simons $";
a38 1

d67 1
a67 1
                "PGPSendMail",
d75 1
@


1.2
log
@Added ConfirmEncryption().
@
text
@d3 2
a4 2
 *      $Revision: 1.1 $
 *      $Date: 1993/09/24 22:47:13 $
d12 1
a12 1
 *      $Id: system.c,v 1.1 1993/09/24 22:47:13 simons Exp simons $
a13 5
 * ------------------------------ log history ----------------------------
 * $Log: system.c,v $
 * Revision 1.1  1993/09/24  22:47:13  simons
 * Initial revision
 *
d36 1
a36 1
        static const char __RCSId[] = "$Id: system.c,v 1.1 1993/09/24 22:47:13 simons Exp simons $";
@


1.1
log
@Initial revision
@
text
@d3 2
a4 2
 *      $Revision$
 *      $Date$
d12 1
a12 1
 *      $Id$
d15 4
a18 1
 * $Log$
d29 4
d41 1
a41 2

        static const char __RCSId[] = "$Id$";
d50 27
d78 2
@
