;****** Auto-Revision Header (do not edit) *******************************
;*
;*  Copyright by PetiWare - This is shareware!
;*
;* Filename         : PetiMail.asm
;* Created on       : 04-Dez-92
;* Created by       : Peter Simons
;* Current revision : V0.226
;*
;*
;* Purpose: PetiMail - der Allround-Amiga-Mailer
;*
;*
;* V0.226 : Der Keyfileschutz lt sich jetzt per Assembler-Flag
;*          ausschalten.
;*
;* V0.225 : Dies ist ab jetzt die registrierte Version. Der Keyfileschutz
;*          ist teilweise installiert und der Versionstring gendert.
;*          Wird kein gltiges Keyfile vorgefunden, wird vorlufig ein
;*          Requester geffnet und das Programm abgebrochen.
;*                                               Peter Simons (02-Jun-93)
;*
;* V0.224 : Fehler in der Auswertung der Kommandozeile behoben. Wenn
;*          ein Xpr-Optionstring angegeben wurde, crashte PMail.
;*
;* V0.223 : Versionstring auf "PMail_unregistered" gendert. PMail ist
;*          jetzt fertig zum releasen.
;*                                               Peter Simons (16-Apr-93)
;*
;* V0.222 : SerialBuffer von 10 auf 20KByte erhht.
;*
;* V0.221 : OffHook() gendert: Jetzt wird nur noch das "+++ATH" abge-
;*          schickt, 2 Sekunden verzgert und danach getestet ob der
;*          Carrier weg ist.
;*
;* V0.220 : OffHook() bricht jetzt noch laufende Connectversuche ab, auch
;*          wenn der Carrier noch nicht steht.
;*
;* V0.219 : PMail fordert explizit PTool.Library v2 an.
;*
;* V0.218 : Progress-Indikator lokalisiert.
;*
;* V0.217 : Wird des Transfer ohne Fenster gewnscht, zeigt PMail den
;*          Filenamen und die verbleibende Transferzeit im CLI an.
;*
;* V0.216 : Das Auflegen wird jetzt von einer eigenen Modemroutine ge-
;*          macht, da ein simples "+++ath" oft nicht funktioniert.
;*
;* V0.215 : WaitForString() hat bei der Berechnung der Stringlngen recht
;*          seltsame Sachen gemacht.
;*
;* V0.214 : Die Mglichkeit eine TransferNote-Struktur zu installieren
;*          wird jetzt genutzt. Kommende Versionen knnen so die ZModem-
;*          Daten auch ausgeben, ohne ein Fenster zu ffnen.
;*
;* V0.213 : Einige Routinen benutzten nicht ReadSerial() zum Auslesen
;*          des Devices, wodurch die empfangenen Brutto-Byte im XFerStat
;*          nicht stimmten.
;*
;* V0.212 : Das ZModem-Fenster lt sich jetzt ber die Kommandozeile
;*          abschalten.
;*
;* V0.211 : SendModemCMD(): Die Delays gendert! Nach dem "+++" jetzt 2
;*          Sekunden Delay, dann das LF und dann wieder 1 Sekunde Delay.
;*          Wenn nach dem Break kein ausreichender Delay folgt, wird er
;*          nicht erkannt!
;*
;* V0.210 : Das Modembreak ("+++") wird nur noch gesendet, wenn auch
;*          wirklich ein Carrier besteht.
;*
;* V0.209 : SendModemCMD() parsed das angegebene Modemkommando jetzt nach
;*          "\r"s, nach denen er ein Linefeed sendet und die Reaktion des
;*          Modems abwaretet ("OK"). Daduch sind mehrere Kommando auf
;*          einen Schlag mglich geworden: "ATZ\rATS0=0\r".
;*
;* V0.208 : Fehlermeldungen umgestellt: Wenn der Connect nicht geklappt
;*          hat (BUSY) gibt es WARN, ebenso wenn ein laufender ZModem-
;*          Transfer unterbrochen wordem ist. ERROR gibt PMail zurck,
;*          wenn der Login nicht funktioniert hat, oder kein PMail-
;*          Handshake kam.
;*
;* V0.207 : Nachdem WriteXFerStat() alle Datenregister bis D6 braucht,
;*          den Return-Code nach D7 verlagert.
;*
;* V0.206 : WriteXFerStat()'s Register-Benutzung nochmal stark umge-
;*          da in der alten Version die Anzahl der empfangenen Files
;*          "broken" war. (Frei nach Matt Dillon)
;*
;* V0.205 : Zum Auflegen wird kein ATZ mehr verwendet, sondern ein ATH.
;*
;* V0.204 : ReadSerial() und WriteSerial() zhlen jetzt die Anzahl der
;*          insgesamt gesendeten und empfangenen Byte mit.
;*
;* V0.203 : In den XFerStats wird jetzt eine vernnftige Effektivitts-
;*          statistik ausgegeben.
;*
;* V0.202 : Wenn angegeben, werden die Optionen fr die Xpr.Library
;*          gesetzt.
;*
;* V0.201 : Das Returncode-Handling verbessert! Es gibt jetzt 3 Stufen:
;*          Anruf erfolgrich, teilweise erfolgreich und fehlgeschlagen.
;*
;* V0.200 : PetiMail ist jetzt komplett lokalisiert! Dies wurde als Anla
;*          genommen, einige Fehlermeldungen/Logeintrge zu ndern oder
;*          umzustellen.
;*                                               Peter Simons (27-Feb-93)
;*
;* V0.180 : Die Ausfhrung der Kommandos von System() auf Execute() um-
;*          gestellt, da sich nun die Sachen wieder redirecten lassen.
;*
;* V0.179 : Das Serial.Device wird jetzt direkt nach der bertragung
;*          geschlossen. Dadurch kann ein eventuell laufender Getty
;*          schon wieder "on-job" gehen, auch wenn PMail noch Stats be-
;*          rechnet und seine Executes ausfhrt.
;*
;* V0.178 : Wenn jetzt kein Logfile angegeben wurde, oder beim ffnen
;*          ein Fehler auftrat, dann wird die Meldung immer noch auf ins
;*          CLI-Fenster geschrieben.
;*
;* V0.177 : Die Zeit luft jetzt erst nach dem erfolgreichen Login an!
;*          Dadurch wird der CPS-Unterschied von Receiver und Caller
;*          eleminiert!
;*
;* V0.176 : Speicherhandling auf PTAllocRemember() umgestellt
;*
;* V0.175 : einige unbenutzte Eintrge rausgeworfen
;*
;* V0.174 : GetTimeDifference(): Die Routine komplett neu geschrieben,
;*          da hatte keinen Zweck mehr. :-> Aber jetzt rafft diese
;*          Funktion wirklich alles!!!
;*
;* V0.173 : Fehler in GetTimeDifference behoben! Die Berechnungen waren
;*          doch mehr als seltsam. (Obwohl die 27300 CPS in der Statistik
;*          nicht schlecht aussahen. :->)
;*
;* V0.172 : XFerStats werden jetzt auch auf den Bildschirm ausgegeben,
;*          wenn ein File spezifiziert worden ist.
;*
;* V0.171 : Neuer Config-Eintrag: XFERSTATS
;*
;* V0.170 : Das speichern der Daten wurde in die Protokoll-Routinen ver-
;*          lagert, damit eventuell unterbrochene Transfers nicht mit-
;*          gerechnet werden, obwohl die Daten garnicht angekommen sind.
;*
;* V0.169 : Utility.Library doch wieder rausgeworfen, da die Datumsfunk-
;*          tionen nicht das taten, was ich brauchte. Jetzt habe ich die
;*          Sachen selbst geschrieben, was zu Problemen fhren knnte,
;*          wenn jemand ber 24h online bleibt. :->
;*
;* V0.168 : Neue Library: Utility.Library
;*
;* V0.167 : PMail erstellt jetzt die "genormten" XFer-Stats, allerdings
;*          hat die Routine noch einige Schwierigkeiten mit dem blden
;*          Datum.
;*
;* V0.166 : Onlinetimer ausgebaut, da fr die Erstellung des XFerStats
;*          komplette DateStamps gebraucht werden! (TimerIOReq wird auch
;*          garnicht mehr initialisiert.)
;*
;* V0.165 : Die DateTime-Struktur wurde nicht korrekt initialisiert, was
;*          zwar nicht direkt zu Fehlern fhrte, aber halt falsch war!
;*
;* V0.164 : Neuer Parameter von InitSerial(): D3=BruteForce!
;*
;* V0.163 : InitSerial() gendert: Im Getty-Modus reserviert PMail das
;*          Device nicht mehr, da davon ausgegangen werden kann, da die
;*          Parameter von Getty korrekt sind!
;*
;* V0.162 : TimeDate-Struktur war nicht auf einer geraden Adresse:
;*          ----> Absturz auf 68000
;*                             Thanks to Reinhold Pickartz for reporting.
;*
;* V0.161 : Der Test ob das File existiert wird nicht mehr mit
;*          GetFileSize(), sondern mit Lock() durchgefhrt.
;*
;* V0.160 : Fehler behoben: Wenn ein Fehler beim Initialisieren des
;*          Modems auftrat, wurde der Stack nicht richtig korrigiert.
;*
;* V0.159 : PMail hatte die alte Prioritt des CLI nicht zurckgesetzt!!!
;*
;* V0.158 : Konnte das Modem nicht korrekt initialisiert werden, wurde
;*          die Fehlermeldung falsch ausgegeben.
;*
;* V0.157 : Zwei neue Eintrge in den Configs: DEFAULTDEVICE und
;*          MODEMINIT. Ausserdem ein neuer Log-Eintrag, wenn das
;*          Initialisieren des Modems fehlgeschlagen ist!
;*
;* V0.156 : InitSerial bekommt einen neuen Parameter: D2=LockDevice?
;*          Dieser Eintrag wird durch das Configfile gesteuert, und
;*          ermglicht auch einen einwandfreien Betrieb mit Getties, die
;*          das DeviceLocking nicht korrekt beherrschen!
;*
;* V0.155 : Einige interne Verbesserungen machen PMail noch etwas krzer.
;*
;* V0.154 : Nachdem die MetaXpr.Library benutzt wurde, wird jetzt das
;*          Serial.Device geflushed und die Parameter neu gesetzt. Jetzt
;*          luft PMail auch mit der Version 3.5 der Library.
;*
;* V0.153 : Neue Routine: ResetSerialDevice()
;*
;* V0.152 : SendModemCMD()-Timeout hinzugefgt
;*
;* V0.151 : Fehler in MakeHandshake korrigiert! Der Rckgabewert war
;*          nicht korrekt.
;*
;* V0.150 : Die XprModem.Library kann jetzt auch ber die Kommandozeile
;*          eingestellt werden. So ist es mglich, dass man fr jedes
;*          System eine eigene Library verwendet.
;*
;* V0.149 : Zwei neue Eintrge in den Sytemconfigs: XPRLIBRARY und
;*          XPROPTSTRING!
;*
;* V0.148 : Alle Fehlermeldungen und Logeintrge ins Englische bersetzt.
;*
;* V0.147 : MakeConnect() gab einen falschen Wert zurck, wenn der
;*          Connectversuch mit CRTL/C unterbrochen wurde.
;*
;* V0.146 : Die Ausfhrung der Kommandos aus dem Config-File kann jetzt
;*          mit CTRL/D unterbrochen werden, da sich das CTRL/C fast immer
;*          ans Kommando selbst richtet, nicht aber an den PMail.
;*
;* V0.145 : Das Lschen der bertragenen Files machen jetzt die Routinen
;*          MakeCall() und ReceiveCall() selber, wodurch eine weitere
;*          Fehlerquelle zum Datenverlust ausgeschaltet sein drfte!
;*
;* V0.144 : PMail prft vor dem versenden, ob das ausgehende File ber-
;*          haupt existiert.
;*
;* V0.143 : Neue Routine: MakeHandshake()
;*          Diese Routine sendet den Handshakestring bis zu zweimal, wenn
;*          die Anwort des Empfngers nicht innerhalb der Timeout-Zeit
;*          kommt.
;*
;* V0.142 : Der Timeout-Wert ist jetzt variabel, soda zum Beispiel
;*          whrend des Calls ein anderer Wert gelten kann, als whrend
;*          des Connectes, der ja oft lnger dauert!
;*
;* V0.141 : Online-Timer eingefhrt
;*
;* V0.140 : Wenn WaitOnSerialPort() mit CTRL/C abgebrochen wird, wird
;*          jetzt ein Vermerk ins Logfile geschrieben.
;*
;* V0.139 : Bug beseitigt! WaitForString() hat das IO-Kommando in der
;*          IORequest-Struktur nicht neu gesetzt, weshalb die Routine
;*          mit der neuen MetaXPR-Library nicht mehr funktioniert hat.
;*
;* V0.138 : WaitOnSerialPort() erkennt jetzt den Verlust des Carriers.
;*          Ein globales Flag entscheidet dabei, ob der Carrier bestehen
;*          mte oder nicht. Dadurch kann die Routine auch weiterhin
;*          fr Offline-Anwendungen benutzt werden.
;*
;* V0.137 : Das Ausfhren der Kommandos nach dem Transfer kann jetzt
;*          durch CTRL_C abgebrochen werden.
;*
;* V0.136 : PMail setzt jetzt das WARN-Flag, falls ein Anruf nicht er-
;*          folgreich war!
;*
;* V0.135 : MakeCall() und ReceiveCall() geben jetzt Returncodes zurck,
;*          soda zum Beispiel die Userkommandos nur noch ausgefhrt
;*          werden, wenn der Anruf bis zum Handshake erfolgreich war.
;*
;* V0.134 : Ruft jetzt nach einem Anruf mehrere Kommandos auf, die der
;*          User festlegen kann. So kann zum Beispiel automatisch ent-
;*          packt werden.
;*
;* V0.133 : PMail setzt seine Prioritt selbst
;*
;* V0.132 : PMail erkennt jetzt das RING-Signal!
;*
;* V0.131 : Logeintrge fr SendFile() und ReceiveFile() gendert
;*
;* V0.130 : Zahlreiche Fehler-Logmeldungen eingefgt.
;*
;* V0.129 : Die Namen der gesendeten und empfangenen Files werden jetzt
;*          ins Logbuch eingetragen.
;*
;* V0.128 : Mehrere Eintrge ins Logfile hinzugefgt.
;*
;* V0.127 : WaitonSerialPort() erkennt jetzt Timeouts. Der Sekundenwert
;*          fr Timeouts lt sich im Haupt-Configfile einstellen.
;*
;* V0.126 : Routinen zum Handling des Timer.Devices hinzugefgt
;*
;* V0.125 : Befindet sich PMail im Receive-Mode, wird dieses Config-File
;*          nicht geladen, damit nicht fr jedes anrufende System ein
;*          Eintrag bestehen mu.
;*
;* V0.124 : PMail ldt jetzt ein Configfile fr das gewnschte System
;*          nach und holt sich daraus alle vernderbaren Daten.
;*
;* V0.123 : Neues Keyword: SYSTEMCONFIGS
;*          Dieses Keyword gibt den Pfad an, in dem die entsprechenden
;*          System-Config-Dateien zu finden sind. Der Name des Files
;*          soll dann "<System>.PMConfig" sein. (quax.PMConfig, usw...)
;*
;* V0.122 : PMail trgt sich jetzt in Logfile ein.
;*
;* V0.121 : PMail gibt jetzt auf, in welchem Modus er gestartet worden
;*          ist. (Getty-/Call-Mode)
;*
;* V0.120 : Erfolgreicher Testlauf der Getty-Version mit quax.
;*                                               Peter Simons (19-Dez-92)
;*
;* V0.118 : Vor den Transfers wird jetzt ins Spool-Directory gewechselt,
;*          anstatt das der ZModem-Library zu berlassen.
;*
;* V0.117 : Wenn die PTool.Library nicht geffnet werden kann, wird jetzt
;*          eine Fehlermeldung ausgegeben.
;*
;* V0.116 : InitSerial() gab im Fehlerfall keinen Error zurck
;*
;* V0.115 : Alle Fehlermeldungen auf ErrorHandleDos() umgestellt, da
;*          ein Request im vollautomatischen Betrieb den Rechner
;*          praktisch anhalten wuerde.
;*
;* V0.114 : Bei den Filenamen wird jetzt der Spool-Pfad aus dem
;*          Config-File vorgeschaltet.
;*
;* V0.113 : Das Errorhandling auf das Macro der PTool.Library umgestellt.
;*          Dadurch ist der Code krzer und flexibler geworden.
;*
;* V0.112 : Die XPR-Keywords aus dem Logfile entfernt und dafr SPOOL
;*          hinzugefgt.
;*
;* V0.111 : Wenn die Programme die ZModem-Fenster nicht geffnet haben,
;*          gibt es Probleme mit der bertragung! Ich habe mal eine Delay
;*          eingefgt, bevor das ZModem-Handshake gesendet wird.
;*
;* V0.110 : Die Transferroutinen geben jetzt einen Rckgabewert wieder,
;*          damit auch wirklich nur Files gelscht werden, wenn auch ein
;*          erfolgreicher Transfer stattfand.
;*
;* V0.109 : Eigenes Config-File eingefhrt
;*
;* V0.108 : Files die erfolgreich gesendet werden konnten werden jetzt
;*          nach dem Transfer gelscht!
;*
;* V0.107 : Sollte das Senden eines Files miglcken, so wird in File-
;*          nameArray der erste Buchstabe des Namens durch eine -1 ber-
;*          schrieben. So kann dieses File beim deleten ausgespart
;*          werden.
;*
;* V0.106 : Der FilenameBuffer wird jetzt reserviert anstatt ans Programm
;*          angehngt. Ausserdem wird das FilenameArray auf dem Stack er-
;*          zeugt und nicht im Datensegment abgelegt.
;*
;* V0.105 : Ich hatte den Mailer mal zwischenzeitlich in ein Code und ein
;*          BSS-Segment unterteilt, was aber nur minimal Platzersparnis
;*          gebracht hat.
;*
;* V0.104 : MakeConnect() jetzt in die Modem-Routinen verlegt
;*
;* V0.103 : Das Transferprotokoll beherrscht jetzt das Verschicken
;*          mehrerer Files in einem Anruf.
;*
;* V0.102 : Der Name des Systems wird jetzt aus dem UULIB:Config gelesen
;*
;* V0.101 : Ist jetzt das GETTY-FLAG gesetzt, so wird das Serial.Device
;*          nicht resetet oder dessen Parameter verndert.
;*
;* V0.100 : Erfolg!!!!!!! Es ging in beide Richtungen! Ohne Fehler!
;*                                               Peter Simons (08-Dez-92)
;*
;* V0.030 : An die fnfzig Testlufe gemacht, und davon waren nur knapp
;*          3 erfolreich!! Es ist zum Heulen: Wenn ich einen Fehler finde
;*          dann sind direkt 5 neue da!
;*                                         Danke nochmal an Thielscher!!!
;*
;* V0.023 : Die eigentlichen Filetransferroutinen hinzugefgt:
;*          MakeCall() und ReceiveCall()
;*
;* V0.022 : Commandline-Parsing eingebaut
;*
;* V0.021 : Testweise mal den Filetransfer implementiert
;*
;* V0.020 : Nach tausenden von Testlufen und hunderten von geopferten
;*          Einheiten sieht es so aus, als ob Thielscher's 50 MHz-Rechner
;*          das serial.device berfordert, wenn ich in einer Schleife
;*          Requests schicke! Abhilfe: 1/4 Sekunde Delay eingefhrt
;*
;* V0.011 : Neue Routinen: MakeConnect() und LogIn()
;*
;* V0.010 : Der interne Puffer wird jetzt ber AllocVec() reserviert.
;*
;* V0.009 : WaitForString(), Converse() und SendModemCMD() hinzugefgt
;*
;* V0.008 : Das gewhlte Device wird UUCP-Konform gelocked
;*
;* V0.007 : WaitOnSerial() erkennt jetzt CTRL/C
;*
;* V0.006 : Version-String hinzugefgt
;*
;* V0.005 : Neue Unterroutinen: ReadSerial(), WriteSerial(),
;*                              WaitOnSerialPort(), SerialBufferLen()
;*
;* V0.004 : InitSerial() bentigt jetzt noch die einzustellende Baudrate.
;*
;* V0.003 : Die Modem-/Serialunterroutinen sind jetzt ausgelagert und
;*          knnen zum Hauptprogramm gelinkt werden.
;*
;* V0.002 : Das Serial.Device wird jetzt geffnet und ausserdem drei
;*          ExtIORequest-Strukturen fr Lese-/Schreib- und Statuszugriffe
;*          eingerichtet. Sollte das Reservieren fehlschlagen, wird alles
;*          selbststndig freigegeben.
;*
;* V0.001 : Die Systemanforderungen werden geprft, sowie mehrere
;*          Libraries geffnet.
;*
;* V0.000 : --- Initial release ---
;*
;*************************************************************************
;
;
;

;***************************************************************************
;*                                                                         *
;* SEKTION: Labels, Macros, Switches, Structures                           *
;*                                                                         *
;***************************************************************************

;-------------------------------------- Switches -----------
                MC68000
                NEWSYNTAX
                DEBUG on
                SYM
;               MULTIPASS
;               VERBOSEOPTIM

STRINGARRAY     set     1               ; Locale-Tabelle einbinden
CHECKKEYFILE    set     1               ; Nach dem Keyfile testen

;-------------------------------------- Labels ------------
                INCDIR  "Include:"
                MACLIB  "LIB:Includes.preass"
                MACLIB  "LIB:Offsets.preass"
                MACFILE "libraries/PToolLibrary.i"

KICKVERSION     equ     37

;-------------------------------------- Strukturen --------
AppString       CLRSO
as_ID           SO.l    1
as_Str          SO.w    1
AppString_SIZEOF SOVAL

TransferNote    CLRSO
tn_Continue     SO.l    1
tn_CarrierDetect SO.l   1
tn_Seconds      SO.l    1
tn_Bytes        SO.l    1
tn_UserData     SO.l    1
tn_CurrentFile  SO.l    1
tn_FilesToGo    SO.l    1
tn_ProtocolName SO.l    1
tn_Extension    SO.l    1
tn_WatchCarrier SO.l    1
tn_SizeOf       SOVAL

;-------------------------------------- Macros ------------
REVISION        MACRO
                dc.b "0.226"
                ENDM
REVDATE         MACRO
                dc.b "16-Aug-93"
                ENDM
LOCALEENTRY     MACRO
                dc.l    \1
                dc.w    \2-*
                ENDM

;----------------------------------- References ------------
                XREF    _ReadIOReq
                XREF    _WriteIOReq
                XREF    _InitSerial
                XREF    _CloseSerial
                XREF    _SendModemCMD
                XREF    _CheckCarrier
                XREF    _MakeConnect
                XREF    _LogIn
                XREF    _MakeCall
                XREF    _ReceiveCall
                XREF    _OffHook

                XDEF    StartDateStamp
                XDEF    PrgName
                XDEF    PublicMemStr
                XDEF    ZModemWindow
                XDEF    SentBytesAll
                XDEF    SentBytes
                XDEF    ReceivedBytesAll
                XDEF    ReceivedBytes
                XDEF    SentFiles
                XDEF    ReceivedFiles
                XDEF    _PToolBase
                XDEF    _DOSBase
                XDEF    _MetaXprBase
                XDEF    _OwnDevUnitBase
                XDEF    _AlarmIOReq
                XDEF    _Len
                XDEF    _ErrorHandle
                XDEF    _GetString
                XDEF    _MakeLogEntry
                XDEF    _RememberKey
                XDEF    _InstallTransferDisplay
                XDEF    _RemoveTransferDisplay


;***************************************************************************
;*                                                                         *
;* SEKTION: Programm                                                       *
;*                                                                         *
;***************************************************************************

;---------------------- Systemumgebung initialisieren ---------------------
START:          moveq   #0,d7                   ; Errorlevel
                lea     (ptoollibname,PC),a1
                moveq   #2,d0
                move.l  ($4).W,a6
                jsr     (_LVOOpenLibrary,a6)
                move.l  d0,(_PToolBase)
                bne.b   .PToolLibOkay
                bsr     _NoPToolLibrary
                bra     .Exit

.PToolLibOkay   move.l  d0,a6
                move.l  (ptl_DOSBase,a6),(_DOSBase)
                move.l  (ptl_LocaleBase,a6),(_LocaleBase)

                move.l  #CCF_OS_VERSION,d0
                move.w  #KICKVERSION,d1
                jsr     (_LVOCheckConfig,a6)
                tst.l   d0
                beq.b   .ConfigOkay
                lea     (PrgName,PC),a0
                moveq   #0,d2
                jsr     (_LVODisplayConfigErrorDos,a6)
                bra     .ClosePToolLib

.ConfigOkay     lea     (owndevname,PC),a1
                move.l  ($4).W,a6
                jsr     (_LVOOldOpenLibrary,a6)
                ERRORHANDLE (_OwnDevUnitBase),4,.ClosePToolLib,(owndevname,PC)

                lea     (metaxprlibname,PC),a1
                moveq   #3,d0
                jsr     (_LVOOpenLibrary,a6)
                ERRORHANDLE (_MetaXprBase),9,.CloseOwnDevLib,(metaxprlibname,PC),3

                sub.l   a0,a0
                lea     (CatalogName,PC),a1
                sub.l   a2,a2
                move.l  (_LocaleBase,PC),d0
                beq.b   .SkipOpenCatalog
                move.l  d0,a6
                jsr     (_LVOOpenCatalogA,a6)
                move.l  d0,(_MessageCatalog)
.SkipOpenCatalog
;-------------------------- Interne Buffer reservieren --------------------
                lea     (_RememberKey,PC),a0
                move.l  #512,d0
                moveq   #MEMF_ANY,d1
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPTAllocRemember,a6)
                ERRORHANDLE (_FilenameBuffer),2,.CloseCatalog,256,(PublicMemStr,PC)

;------------------------------ Read ConfigFiles --------------------------
                lea     (ConfigFile,PC),a0
                lea     (ConfigTagList,PC),a1
                lea     (_NodeName,PC),a2
                lea     (_RememberKey,PC),a3
                jsr     (_LVOInterpretConfigFileRemember,a6)
                ERRORHANDLE (_ConfigBuffer),11,.CloseCatalog,(ReadConfigError,PC)

;---------------------------- Task-Prioritt setzen -----------------------
                sub.l   a1,a1
                move.l  ($4).w,a6
                jsr     (_LVOFindTask,a6)
                move.l  d0,a1
                move.l  (MyPri,PC),d0
                jsr     (_LVOSetTaskPri,a6)
                move.b  d0,(OldPri)

;------------------------------ Argument-Parsing --------------------------
                lea     (RDArgsTemplate,PC),a0
                move.l  a0,d1
                lea     (CallSystem,PC),a0
                move.l  a0,d2
                moveq   #0,d3
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOReadArgs,a6)
                ERRORHANDLE (_RDArgsStruct),0,(.RestorePri,PC)

                move.l  (ZMWindow,PC),d0
                beq.b   .SkipParse
                move.l  d0,a0
                move.l  (a0),d0                 ; Einstellungen aus der
                beq.b   .NoZMWindow             ; Kommandozeile hat Vorrang
                move.l  #-1,(ZModemWindow)      ; vor dem Configfile
                bra.b   .SkipParse
.NoZMWindow     clr.l   (ZModemWindow)
.SkipParse
;---------------------------- System-Configs lesen ------------------------
                tst.l   (GettyMode)
                bne.b   .SkipSysConfig          ; Dieses Config nur lesen,
                                                ; wenn auch ein Anruf raus
                link    a4,#-256                ; gettigt werden soll!
                move.l  (SystemConfigs,PC),a0
                lea     (-256,a4),a1
                bsr     _CopyUntilNull
                move.l  (CallSystem,PC),a0
                bsr     _CopyUntilNull
                lea     (ConfAppendix,PC),a0
                bsr     _CopyUntilNull

                lea     (-256,a4),a0
                lea     (SysConfTagList,PC),a1
                lea     (_DialString,PC),a2
                lea     (_RememberKey,PC),a3
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOInterpretConfigFileRemember,a6)
                unlk    a4
                move.l  d0,(_SysConfBuffer)
                bne.b   .SkipSysConfig
                moveq   #MSG_ERROR_UNKNOWNSYSTEM,d0
                bsr     _GetString
                move.l  d0,-(SP)
                move.l  SP,a1
                moveq   #11,d0
                bsr     _ErrorHandle
                addq.w  #4,SP
                bra     .FreeRDArgs
.SkipSysConfig
;----------------------------- SetupSerialDevice --------------------------
                move.l  (Device,PC),d0
                bne.b   .DeviceValid
                move.l  (_StandardDev,PC),d0
                bne.b   .DeviceValid
                move.l  #serialdev,d0
.DeviceValid    move.l  d0,a0
                move.l  (Unit,PC),d0
                beq.b   .InitBaud
                move.l  d0,a1
                move.l  (a1),d0
.InitBaud       moveq   #0,d1
                tst.l   (GettyMode)
                bne.b   .Init
                move.l  (Baud,PC),d1
.Init           move.l  (DevLocking,PC),d2
                move.l  (Bruteforce,PC),d3
                bsr     _InitSerial
                tst.l   d0
                beq     .CloseMetaXpr
                move.b  #-1,(DeviceOpen)

;----------------------- Timing-Routinen initialisieren -------------------
                lea     (_AlarmIOReq,PC),a0
                moveq   #UNIT_VBLANK,d0
                bsr     _InitTimerDevice
                ERRORHANDLE ,0,(.CloseSerial,PC)

;----------------------------- InitXpr-Library ----------------------------
                move.l  (_ReadIOReq,PC),a0
                move.l  (_WriteIOReq,PC),a1
                lea     (xprzlibname,PC),a2     ; Im GettyMode den Namen aus
                move.l  (XprLib,PC),d0          ; der Kommandozeile nehmen.
                bne.b   .SetUpFromConf          ; Sonst den aus dem System-
                move.l  (_XprLibrary,PC),d0     ; Config.
                beq.b   .SetUpTransfer
.SetUpFromConf  move.l  d0,a2                   ; Default: "xprzmodem.library"
.SetUpTransfer  move.l  (_MetaXprBase,PC),a6
                jsr     (_LVOTransferSetupShared,a6)
                tst.l   d0
                bne.b   .InitXprError

                lea     (XprOpt,PC),a0
                tst.l   (a0)
                bne.b   .SetOptions
                lea     (_XprOptString,PC),a0
                tst.l   (a0)
                beq.b   .InstallTNote
.SetOptions     move.l  (a0),a0
                jsr     (_LVOSetOptions,a6)
                tst.l   d0
                beq.b   .InitXprError

.InstallTNote   lea     (ZMTransfer,PC),a0
                jsr     (_LVOInstallTransferNote,a6)
                tst.l   d0
                beq.b   .InitXprOkay

.InitXprError   moveq   #MSG_ERROR_INITXPRLIB,d0
                bsr     _GetString
                move.l  d0,-(SP)
                move.l  SP,a1
                moveq   #11,d0
                bsr     _ErrorHandle
                addq.w  #4,SP
                bra     .CloseTimer
.InitXprOkay
;----------------------------- Directory wechseln -------------------------
                move.l  (_Spool,PC),d1
                move.l  #ACCESS_READ,d2
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOLock,a6)
                ERRORHANDLE (_SpoolLock),0,(.CloseTimer,PC)

                move.l  (_SpoolLock,PC),d1
                jsr     (_LVOCurrentDir,a6)
                move.l  d0,(_OldCurrentDir)

;-------------------------------- Keyfile laden ---------------------------
        IFNE CHECKKEYFILE
                lea     (PMailKeyfile,PC),a0
                lea     (_RememberKey,PC),a1
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOLoadFileRemember,a6)
                move.l  d0,(_Keyfile)
                beq     .KeyfileInvalid
                move.l  d0,a2
                move.l  (a2)+,d0
                subq.l  #4,d0
                lea     (4,a2),a0
                jsr     (_LVOCRC32Buffer,a6)
                move.l  (a2),d1
                cmp.l   d0,d1
                beq.b   .KeyfileValid
.KeyfileInvalid bsr     _KeyfileError
                bra     .OldCurrentDir
.KeyfileValid
        ENDC
;------------------------------- Header ausgeben --------------------------
                moveq   #MSG_COPYRIGHT,d0
                bsr     _GetString
                move.l  d0,a0
                pea     (NoPToolError,PC)
                move.l  SP,a1
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPrintFSimple,a6)

                moveq   #MSG_STARTUP_CALL,d0
                tst.l   (GettyMode)
                beq.b   .PrintStartup
                moveq   #MSG_STARTUP_RECEIVE,d0
.PrintStartup   lea     (PrgName,PC),a0
                move.l  a0,(SP)
                bsr     _GetString
                move.l  d0,a0
                jsr     (_LVOPrintFSimple,a6)
                addq.w  #4,SP

;---------------------------- Modem initialisieren ------------------------
                move.l  (_ModemInit,PC),d0
                beq.b   .Call
                move.l  d0,a0
                bsr     _SendModemCMD
                tst.l   d0
                bne.b   .Call
                moveq   #MSG_LOG_MODEMINITFAILED,d0
                pea     (PrgName,PC)
                move.l  SP,a1
                bsr     _MakeLogEntry
                addq.w  #4,SP
                bra     .OldCurrentDir

;------------------------------ Call durchfhren --------------------------
.Call           bsr     _MakeZModemName

        IFNE CHECKKEYFILE
                move.l  (_Keyfile,PC),a2
                move.l  (a2)+,d0
                subq.l  #8,d0
                lea     (8,a2),a0
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOCRC32Buffer,a6)    ; Zweite CRC-Prfsumme
                move.l  (4,a2),d1               ; testen
                cmp.l   d0,d1
                beq.b   .KeyfileValid2
                bsr     _KeyfileError
                bra     .OldCurrentDir
.KeyfileValid2
        ENDC
                move.l  (_FilenameBuffer,PC),d1         ; Existiert das File
                move.l  #ACCESS_READ,d2                 ; berhaupt?
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOLock,a6)
                move.l  d0,d2
                move.l  d2,d1
                jsr     (_LVOUnLock,a6)

                tst.l   d2
                bne.b   .FileExists

                move.l  (_FilenameBuffer,PC),a0
                clr.b   (a0)
                moveq   #0,d0

.FileExists     tst.l   (GettyMode)
                beq.b   .MakeCall

                moveq   #MSG_LOG_RECEIVINGCALL,d0
                move.l  (CallSystem,PC),-(SP)
                pea     (PrgName,PC)
                move.l  SP,a1
                bsr     _MakeLogEntry
                addq.w  #8,SP

                move.l  (_NodeName,PC),a0
                move.l  (CallSystem,PC),a1
                pea     (NullByte,PC)
                move.l  (_FilenameBuffer,PC),-(SP)
                move.l  SP,a5
                move.l  (DefaultTimeout,PC),d0
                bsr     _ReceiveCall
                move.l  d0,d7
                addq.w  #8,SP
                bra.b   .ResetModem

.MakeCall       moveq   #MSG_LOG_MAKECALL,d0
                move.l  (CallSystem,PC),-(SP)
                pea     (PrgName,PC)
                move.l  SP,a1
                bsr     _MakeLogEntry
                addq.w  #8,SP

                move.l  (_NodeName,PC),a0
                move.l  (CallSystem,PC),a1
                move.l  (_Password,PC),a2
                move.l  (_DialString,PC),a3
                move.l  (_ConnectPattern,PC),a4
                pea     (NullByte,PC)
                move.l  (_FilenameBuffer,PC),-(SP)
                move.l  SP,a5
                move.l  (DefaultTimeout,PC),d0
                move.l  (_FileRequests,PC),d1
                bsr     _MakeCall
                move.l  d0,d7
                addq.w  #8,SP

.ResetModem     bsr     _OffHook
                bsr     _CloseSerial
                clr.b   (DeviceOpen)

;------------------------------ LogEntry erstellen ------------------------
                pea     (PrgName,PC)
                move.l  SP,a1

                cmp.l   #-1,d7
                beq.b   .CallSuccesful

                cmp.w   #-1,d7
                beq.b   .CallNotSuccesful

                moveq   #MSG_LOG_CALLFAILED,d0
                bra.b   .MakeLogEntry

.CallNotSuccesful moveq #MSG_LOG_CALLNOTSUCCESSFUL,d0
                bra.b   .MakeLogEntry

.CallSuccesful  moveq   #MSG_LOG_CALLSUCCESSFUL,d0

.MakeLogEntry   bsr     _MakeLogEntry
                addq.w  #4,SP

                cmp.w   #2,d7
                bcs.b   .SkipXFerStat           ; d7=>2
                lea     (EndDateStamp,PC),a0
                move.l  a0,d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVODateStamp,a6)

                move.l  (CallSystem,PC),a0
                lea     (StartDateStamp,PC),a1
                lea     (EndDateStamp,PC),a2
                move.l  (GettyMode,PC),d0
                move.l  (SentBytes,PC),d1
                move.l  (ReceivedBytes,PC),d2
                move.l  (SentBytesAll,PC),d3
                move.l  (ReceivedBytesAll,PC),d4
                move.w  (SentFiles,PC),d5
                move.w  (ReceivedFiles,PC),d6
                bsr     _WriteXFerStats
.SkipXFerStat
;----------------------- Vorgegebene Kommandos ausfhren ------------------
                cmp.w   #-1,d7
                bne.b   .NoExecute

                move.l  (_DOSBase,PC),a6
                lea     (_Execute1,PC),a4
                moveq   #3-1,d3

...             move.l  #SIGBREAKF_CTRL_D,d1
                jsr     (_LVOCheckSignal,a6)
                tst.l   d0
                bne.b   .NoExecute

                move.l  (a4)+,d1
                beq.b   .SkipExecute
                moveq   #0,d2
                moveq   #0,d3
                jsr     (_LVOExecute,a6)
.SkipExecute    dbra    d3,...
.NoExecute
;-------------------------- Systemumgebung freigeben ----------------------
.OldCurrentDir  move.l  (_OldCurrentDir,PC),d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOCurrentDir,a6)
                move.l  (_SpoolLock,PC),d1
                beq.b   .CloseSerial
                jsr     (_LVOUnLock,a6)

.CloseTimer     lea     (_AlarmIOReq,PC),a0
                bsr     _CloseTimerDevice

.CloseSerial    tst.b   (DeviceOpen)
                beq.b   .RestorePri
                bsr     _CloseSerial

.RestorePri     sub.l   a1,a1
                move.l  ($4).w,a6
                jsr     (_LVOFindTask,a6)
                move.l  d0,a1
                move.b  (OldPri,PC),d0
                cmp.b   #-1,d0
                beq.b   .CloseMetaXpr
                jsr     (_LVOSetTaskPri,a6)

.FreeRDArgs     move.l  (_RDArgsStruct,PC),d1
                beq.b   .CloseMetaXpr
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOFreeArgs,a6)

.CloseCatalog   move.l  (_LocaleBase,PC),d0
                beq.b   .CloseMetaXpr
                move.l  (_MessageCatalog,PC),a0
                move.l  d0,a6
                jsr     (_LVOCloseCatalog,a6)

.CloseMetaXpr   move.l  (_MetaXprBase,PC),a1
                move.l  ($4).W,a6
                jsr     (_LVOCloseLibrary,a6)

.CloseOwnDevLib move.l  (_OwnDevUnitBase,PC),a1
                move.l  ($4).W,a6
                jsr     (_LVOCloseLibrary,a6)

.FreeBuffers    lea     (_RememberKey,PC),a0
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPTFreeRemember,a6)

.ClosePToolLib  move.l  (_PToolBase,PC),a1
                move.l  ($4).W,a6
                jsr     (_LVOCloseLibrary,a6)

.Exit           moveq   #RETURN_OK,d0           ; alles okay
                cmp.l   #-1,d7
                beq.b   .bye

                moveq   #RETURN_WARN,d0         ; Connect ist schiefge-
                tst.l   d7                      ; laufen.
                beq.b   .bye

                cmp.w   #$FFFF,d7               ; Whrend der bertragung
                beq.b   .bye                    ; unterbrochen worden.

                moveq   #RETURN_ERROR,d0        ; Connected hatten wir
.bye            rts                             ; dann trat jedoch ein
                                                ; anderer Fehler auf.


;***************************************************************************
;*                                                                         *
;* SEKTION: Unterroutinen                                                  *
;*                                                                         *
;***************************************************************************

;--------------------------- ZModemtransfer-Display -----------------------
_InstallTransferDisplay:
                ; Erzeugt einen zweiten Task der whrend des Transfers
                ; die Daten aus der TransferNote-Struktur anzeigt.
                ;
                ; Parameter: keine
                ; Result   : keine

                PUSHM   d0-d1/a0-a1/a6
                lea     (.ProcTagList,PC),a2
                move.l  (MyPri,PC),d0
                addq.b  #1,d0
                move.l  d0,(36,a2)
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOOutput,a6)
                move.l  d0,(4,a2)
                beq.b   .exit
                move.l  a2,d1
                jsr     (_LVOCreateNewProc,a6)
                move.l  d0,(_TNDispTask)
.exit           POPM
                rts

.DisplayProcName        CSTR    "PMail subprocess"

                CNOP    0,4
.ProcTagList    dc.l    NP_Output,0
                dc.l    NP_CloseOutput,DOSFALSE
                dc.l    NP_Entry,_DisplayProc
                dc.l    NP_Name,.DisplayProcName
                dc.l    NP_Priority,-5
                dc.l    TAG_DONE


_DisplayProc:
                PUSHM   d0-d7/a0-a6
                lea     (ZMTransfer,PC),a2

.DisplayLoop    move.l  #SIGBREAKF_CTRL_C,d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOCheckSignal,a6)
                tst.l   d0
                bne.b   .exit

                tst.l   (tn_CurrentFile,a2)
                beq.b   .SkipDisplay
                moveq   #MSG_TRANSFER_PROGRESS,d0
                bsr     _GetString
                move.l  d0,a0
                move.l  (tn_Seconds,a2),-(SP)
                move.l  (tn_CurrentFile,a2),-(SP)
                move.l  SP,a1
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPrintFSimple,a6)
                addq.w  #8,SP

.SkipDisplay    moveq   #2*50,d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVODelay,a6)
                bra.b   .DisplayLoop

.exit           POPM
                rts


_RemoveTransferDisplay:
                ; Signalisiert dem zweiten Task, da er die Arbeit ein-
                ; stellen soll.
                ;
                ; Parameter: keine
                ; Result   : keine

                PUSHM   d0-d1/a0-a1/a6
                move.l  (_TNDispTask,PC),d0
                beq.b   .exit
                move.l  d0,a1
                move.l  #SIGBREAKF_CTRL_C,d0
                move.l  ($4).w,a6
                jsr     (_LVOSignal,a6)
                clr.l   (_TNDispTask)
                move.l  (_PToolBase,PC),a6
                lea     (.ClrLine,PC),a0
                jsr     (_LVOPrintFSimple,a6)
.exit           POPM
                rts

.ClrLine        CSTR    $9B,$4D,$0D

;----------------------------- Fehler-Behandlung --------------------------
_KeyfileError:
                ; Gibt einen Fehlerrequester aus
                ;
                ; Parameter: keine
                ; Result   : keins

        IFNE CHECKKEYFILE

                PUSHM   d0-d1/a0-a2/a6
                lea     (PrgName,PC),a0
                pea     (KeyfileError_txt,PC)
                move.l  SP,a1
                sub.l   a2,a2
                moveq   #11,d0
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOErrorHandleIntuition,a6)
                addq.w  #4,SP
                POPM
                rts
        ENDC

_ErrorHandle:
                ; Erzeut ber ErrorHandleDos() die Fehlermeldung.
                ;
                ; Parameter: A1=&DataFlow D0=Errornumber
                ; Result   : keins

                PUSHM   d0-d1/a0-a1/a6
                moveq   #0,d1
                lea     (PrgName,PC),a0
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOErrorHandleDos,a6)
                POPM
                rts

_NoPToolLibrary:
                ; Gibt einen Fehler aus, falls die PTool.Library nicht ge-
                ; ffnet werden konnte.
                ;
                ; Parameter: keine
                ; Result   : keins

                lea     (dosname,PC),a1
                move.l  ($4).W,a6
                jsr     (_LVOOldOpenLibrary,a6)
                tst.l   d0
                beq.b   .exit
                move.l  d0,a6
                jsr     (_LVOOutput,a6)
                move.l  d0,d1
                beq.b   .CloseDosLib
                lea     (NoPToolError,PC),a0
                move.l  a0,d2
                moveq   #NoPToolError_len,d3
                jsr     (_LVOWrite,a6)
.CloseDosLib    move.l  a6,a1
                move.l  ($4).W,a6
                jsr     (_LVOCloseLibrary,a6)
.exit           rts


;-------------------------------- Allgemeines -----------------------------
_Len:
                ; Bestimmt die Lnge eines mit Null abgeschlossenen Textes
                ;
                ; Parameter: A0=&Textpuffer
                ; Result   : D0=Lnge ohne das Nullbytes
                ; Kommentar: Verndert keine Register ausser D0!!!

                pea     (a0)            ; Register retten
.loop           tst.b   (a0)+
                bne.b   .loop           ; aktuelles Zeichen gleich Null?
                move.l  a0,d0
                move.l  (SP)+,a0
                sub.l   a0,d0           ; Lnge zurckgeben
                subq.l  #1,d0
                rts


_MakeZModemName
                ; Stellt aus dem Namen des eigenen Systems und dem Namen
                ; des Anrufers/angerufenen Systems den Filenamen her.
                ;
                ; Parameter: keine
                ; Result   : keins
                ; Kommentar: absolute bergangslsung!!!!

                move.l  (_NodeName,PC),a0
                move.l  (_FilenameBuffer,PC),a1
                bsr     _CopyUntilNull
                move.b  #'2',(a1)+
                move.l  (CallSystem,PC),a0
                bsr     _CopyUntilNull
                lea     (NameAppendix,PC),a0
                bra     _CopyUntilNull

_CopyUntilNull  move.b  (a0)+,(a1)+
                bne.b   _CopyUntilNull
                subq.w  #1,a0
                subq.w  #1,a1
                rts


;--------------------------------- XFerStats ------------------------------
_WriteXFerStats:
                ; Erstellt einen XFerStat-Eintrag und schreibt in das File
                ; XFerStats!
                ;
                ; Parameter: A0=SystemName A1=StartDateStamp A2=EndDateStamp
                ;            D0=GettyMode D1=ByteSent D2=ByteReceived
                ;            D3=ByteSentAll D4=ByteReceivedAll D5=FilesSent
                ;            D6=FilesReceived
                ; Result   : keins

                move.l  d7,-(SP)
                PUSHM   d0-d6/a0-a3

                clr.l   (.FileHandle)
                move.l  (_Xfers,PC),d1
                beq.b   .MakeStat
                move.l  #MODE_READWRITE,d2
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOOpen,a6)
                ERRORHANDLE (.FileHandle),0,(.exit,PC)

                move.l  d0,d1
                moveq   #0,d2
                move.l  #OFFSET_END,d3
                jsr     (_LVOSeek,a6)

.MakeStat       movem.l (SP),saveregs
                lea     (.XFerStatFlow,PC),a3
                tst.l   d0
                beq.b   .CallMode
                move.l  #.Receive,(a3)
.CallMode       move.l  a0,(4,a3)

                move.l  a1,a0
                lea     (.StartTime,PC),a1
                lea     (LEN_DATSTRING,a1),a2
                bsr     _GetDateString
                tst.l   d0
                beq     .CloseFile

                movem.l (SP),saveregs
                move.l  a2,a0
                lea     (.EndTime,PC),a1
                lea     (LEN_DATSTRING,a1),a2
                bsr     _GetDateString
                tst.l   d0
                beq.b   .CloseFile

                movem.l (SP),saveregs
                move.l  a1,a0
                move.l  a2,a1
                lea     (.OnlineTime,PC),a2
                bsr     _GetTimeDifference
                tst.l   d0
                beq.b   .CloseFile
                move.l  d1,d7
                beq.b   .CloseFile

                movem.l (SP),saveregs
                lea     (.Byte,PC),a1
                move.l  d4,(a1)+
                move.l  d3,(a1)+
                move.l  d2,(a1)+
                move.l  d1,(a1)+
                move.w  d6,(a1)+
                move.w  d5,(a1)+

                lea     (.CPS,PC),a1
                move.l  d3,d0
                add.l   d4,d0
                divu.w  d7,d0
                move.w  d0,(a1)+
                move.l  d1,d0
                add.l   d2,d0
                divu.w  d7,d0
                move.w  d0,(a1)+
                moveq   #0,d0
                move.w  (-2,a1),d0
                mulu.w  #100,d0
                move.w  (-4,a1),d1
                beq.b   .SkipDiv
                divu.w  d1,d0
.SkipDiv        move.w  d0,(a1)+

                lea     (.XFerStat,PC),a0
                lea     (.XFerStatFlow,PC),a1
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPrintFSimple,a6)

                lea     (.XFerStat,PC),a0
                lea     (.XFerStatFlow,PC),a1
                move.l  (.FileHandle,PC),d0
                beq.b   .CloseFile
                jsr     (_LVOPrintF,a6)

.CloseFile      move.l  (.FileHandle,PC),d1
                beq.b   .exit
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOClose,a6)

.exit           POPM
                move.l  (SP)+,d7
                rts

.XFerStatFlow   dc.l    .Call
                ds.l    1
                dc.l    .StartTime
                dc.l    .StartTime+LEN_DATSTRING
                dc.l    .EndTime
                dc.l    .EndTime+LEN_DATSTRING
                dc.l    .OnlineTime
.CPS            ds.w    3
.Byte           ds.l    2
                ds.l    2
                ds.l    2

.FileHandle     ds.l    1
.StartTime      ds.b    LEN_DATSTRING*2
.EndTime        ds.b    LEN_DATSTRING*2
.OnlineTime     ds.b    LEN_DATSTRING

.XFerStat       dc.b    "%s %-8.8s %s %s > %s %s (%s) %5.d  %5.d %3.d%%",$0A
                CSTR    "| P 0 1024 %8.ld %8.ld # %8.ld %8.ld # %4.d %4.d",$0A

.Call           CSTR    "<"
.Receive        CSTR    ">"
                EVEN



_GetDateString:
                ; Liefert aus einem DateStamp den DatumsString
                ;
                ; Parameter: A0=DateStamp A1=DateBuffer A2=TimeBuffer
                ; Result   : TRUE/FALSE

                PUSHM   d1-d2/a0-a3
                lea     (.DateTime),a3

                move.l  (a0),(a3)
                move.l  (4,a0),(4,a3)           ; DateStamp kopieren
                move.l  (8,a0),(8,a3)

                move.b  #FORMAT_CDN,(dat_Format,a3)
                clr.b   (dat_Flags,a3)
                clr.l   (dat_StrDay,a3)
                move.l  a1,(dat_StrDate,a3)     ; Strings erzeugen
                move.l  a2,(dat_StrTime,a3)
                move.l  a3,d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVODateToStr,a6)

                POPM
                rts

.DateTime       ds.b    dat_SIZEOF

_GetTimeDifference:
                ; Liefert aus zwei DateStamps einen TimeString, der die
                ; Differenz angibt.
                ;
                ; Parameter: A0=DateStamp1 A1=DateStamp2 A2=TimeBuffer
                ; Result   : D0=TRUE/FALSE D1=DiffSeconds

                PUSHM   d2/a0-a3/a6
                lea     (.DateTime),a3

                move.l  (a1),(a3)
                move.l  (4,a1),(4,a3)           ; DateStamp kopieren
                move.l  (8,a1),(8,a3)

                lea     (ds_SIZEOF,a0),a0
                lea     (ds_SIZEOF,a3),a1

                move.l  -(a0),d0
                move.l  -(a1),d1
                cmp.l   d0,d1                   ; Ticks berechnen!!
                bmi.b   .TickOverflow
                sub.l   d0,(a1)
                bra.b   .TickFinished
.TickOverflow   move.l  #60*50,d2
                sub.l   d0,d2
                add.l   d2,(a1)
                tst.l   (-4,a1)
                bne.b   .MinuteOkay
                sub.l   #1,(-8,a1)
                move.l  #24*60,(-4,a1)
.MinuteOkay     sub.l   #1,(-4,a1)

.TickFinished   move.l  -(a0),d0
                move.l  -(a1),d1
                cmp.l   d0,d1
                bmi.b   .MinuteOverflow
                sub.l   d0,(a1)
                bra.b   .MinuteFinished         ; Minuten berechnen!!
.MinuteOverflow move.l  #24*60,d2
                sub.l   d0,d2
                add.l   d2,(a1)
                sub.l   #1,(-4,a1)

.MinuteFinished move.l  -(a0),d0
                sub.l   d0,-(a1)                ; Tage berechnenn!!

                move.b  #FORMAT_CDN,(dat_Format,a3)
                clr.b   (dat_Flags,a3)
                clr.l   (dat_StrDay,a3)
                clr.l   (dat_StrDate,a3)     ; Strings erzeugen
                move.l  a2,(dat_StrTime,a3)
                move.l  a3,d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVODateToStr,a6)
                tst.l   d0
                beq.b   .exit

                move.l  (a3)+,d0
                beq.b   .SkipDays
                mulu.w  #24*60,d0
.SkipDays       add.l   (a3)+,d0
                mulu.w  #60,d0
                move.l  (a3)+,d1
                divu.w  #TICKS_PER_SECOND,d1
                and.l   #$0000FFFF,d1
                add.l   d0,d1
                moveq   #-1,d0

.exit           POPM
                rts

.DateTime       ds.b    dat_SIZEOF


;----------------------------- Logfile-Handling ---------------------------
_WriteLog:
                ; Erstellt einen Logeintrag und gibt ihn auf ein FileHandle
                ; aus.
                ;
                ; Parameter: A0=&String A1=&DataFlow D0=FileHandle
                ; Result   : keins
                ; Kommentar: Ist D0.L=0, wird das FileHandle mittels
                ;            Output() ermittelt.

                PUSHM   d0-d2/a0-a2/a6
                link    a4,#-(LEN_DATSTRING*2)
                move.l  d0,d2

                lea     (.DateTime),a2
                move.l  a2,d1
                move.l  (_DOSBase,PC),a6
                jsr     (_LVODateStamp,a6)
                lea     (-(LEN_DATSTRING*2),a4),a0
                lea     (-(LEN_DATSTRING*1),a4),a1
                move.b  #FORMAT_DOS,(dat_Format,a2)
                clr.b   (dat_Flags,a2)
                clr.l   (dat_StrDay,a2)
                move.l  a0,(dat_StrDate,a2)
                move.l  a1,(dat_StrTime,a2)
                move.l  a2,d1
                jsr     (_LVODateToStr,a6)
                tst.l   d0
                beq.b   .exit
                lea     (.LogString,PC),a0
                lea     (dat_StrDate,a2),a1
                move.l  d2,d0
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPrintF,a6)
                tst.l   d0
                beq.b   .exit

                movem.l (LEN_DATSTRING*2+4,SP),saveregs
                move.l  (_PToolBase,PC),a6
                jsr     (_LVOPrintF,a6)

.exit           unlk    a4
                POPM
                rts

.DateTime       ds.b    dat_SIZEOF
.LogString      CSTR    "(%s/%s) "
                EVEN


_MakeLogEntry:
                ; Erstellt einen Logeintrag und gibt ihn ins Logfile und auf
                ; den Bildschirm aus.
                ;
                ; Parameter: D0=Stringnummer A1=&DataFlow
                ; Result   : keins

                PUSHM   d0-d4/a0-a3/a6
                bsr     _GetString
                move.l  d0,a2
                move.l  a1,a3

                move.l  (_Logfile,PC),d1
                beq.b   .NoDiskIO
                move.l  #MODE_READWRITE,d2
                move.l  (_DOSBase,PC),a6
                jsr     (_LVOOpen,a6)
                ERRORHANDLE d4,0,(.NoDiskIO,PC)

                move.l  d0,d1
                moveq   #0,d2
                move.l  #OFFSET_END,d3
                jsr     (_LVOSeek,a6)

                move.l  d4,d0
                move.l  a2,a0
                move.l  a3,a1
                bsr     _WriteLog

                move.l  d4,d1
                jsr     (_LVOClose,a6)

.NoDiskIO       moveq   #0,d0
                move.l  a2,a0
                move.l  a3,a1
                bsr     _WriteLog

.exit           POPM
                rts

;------------------------------- Lokalisierung ----------------------------
_GetString:
                ; Holt ber die Locale.Library einen String. Sollte Locale
                ; nicht verfgbar sein, wird der interne Catalog benutzt.
                ;
                ; Parameter: D0=Stringnumber
                ; Result   : D0=&String
                ; Kommentar: Kann GetString() den String nicht finden, wird
                ;            ein Zeiger auf eine Fehlermeldung zurck-
                ;            gegeben.
                ;            Die Routine benutzt nicht die Originaltabellen,
                ;            die von CatComp erzeugt werden!!

                PUSHM   d1-d2/a0-a1/a6
                move.l  d0,d2

                tst.l   (_MessageCatalog)
                beq.b   .UseInternCat
                tst.l   (_LocaleBase)
                beq.b   .UseInternCat

                move.l  (_MessageCatalog,PC),a0
                sub.l   a1,a1
                move.l  (_LocaleBase,PC),a6
                jsr     (_LVOGetCatalogStr,a6)
                tst.l   d0
                bne.b   .exit

                move.l  d2,d0
.UseInternCat   lea     (AppStrings,PC),a0
...             cmp.l   (as_ID,a0),d0
                bmi.b   .ErrorExit
                beq.b   .FoundString
                addq.w  #AppString_SIZEOF,a0
                bra.b   ...

.ErrorExit      lea     (LocaleError,PC),a0
                move.l  a0,d0
                bra.b   .exit

.FoundString    add.w   (as_Str,a0),a0
                addq.w  #4,a0
                move.l  a0,d0

.exit           POPM
                rts


;---------------------------- Timer.Device-Handling -----------------------
_InitTimerDevice:
                ; Initialisiert das Timer.Device, sowie zahlreiche
                ; IORequest-Strukturen.
                ;
                ; Parameter: A0=&Buffer [2*LONG]  D0=Unit
                ; Result   : D0=TRUE/FALSE

                PUSHM   d1-d2/a0-a2/a6
                move.l  d0,d2
                move.l  a0,a2

                move.l  ($4).w,a6
                jsr     (_LVOCreateMsgPort,a6)
                move.l  d0,(4,a2)
                beq.b   .exit

                move.l  d0,a0
                moveq   #IOTV_SIZE,d0
                jsr     (_LVOCreateIORequest,a6)
                move.l  d0,(a2)
                bne.b   .GoOn1
                pea     (.exit)
                move.l  a2,a0
                bra     _CloseTimerDevice

.GoOn1          move.l  d0,a1
                lea     (timerdev,PC),a0
                moveq   #UNIT_VBLANK,d0
                moveq   #0,d1
                jsr     (_LVOOpenDevice,a6)
                tst.l   d0
                beq.b   .DevOkay
                moveq   #0,d0
                pea     (.exit)
                move.l  a2,a0
                bra     _CloseTimerDevice

.DevOkay        moveq   #-1,d0
.exit           POPM
                rts

_CloseTimerDevice:
                ; Schliet das Timer.Device, und gibt zahlreiche
                ; IORequest-Strukturen frei.
                ;
                ; Parameter: a0=&Buffer [2*LONG]
                ; Result   : keins
                ; Kommentar: Interne Funktion!

                PUSHM   d0-d1/a0-a2/a6
                move.l  a0,a2

                move.l  ($4).w,a6
                move.l  (a2),d0
                beq.b   .GoOn1
                move.l  d0,a1
                tst.l   (IO_DEVICE,a1)
                beq.b   .GoOn2
                jsr     (_LVOCloseDevice,a6)

.GoOn2          move.l  (a2),a0
                jsr     (_LVODeleteIORequest,a6)

.GoOn1          move.l  (4,a2),d0
                beq.b   .exit
                move.l  d0,a0
                jsr     (_LVODeleteMsgPort,a6)

.exit           POPM
                rts


;***************************************************************************
;*                                                                         *
;* SEKTION: Daten                                                          *
;*                                                                         *
;***************************************************************************
DATA_Seg:

;-------------------------------------- Libraries ---------
ptoollibname    CSTR    "ptool.library"
dosname         CSTR    "dos.library"
owndevname      CSTR    "OwnDevUnit.library"
metaxprlibname  CSTR    "metaxpr.library"
serialdev       CSTR    "serial.device"
xprzlibname     CSTR    "xprzmodem.library"
timerdev        CSTR    "timer.device"
CatalogName     CSTR    "PMail.catalog"

                CNOP    0,4
_PToolBase      ds.l    1
_DOSBase        ds.l    1
_OwnDevUnitBase ds.l    1
_MetaXprBase    ds.l    1
_LocaleBase     ds.l    1
_MessageCatalog ds.l    1

;-------------------------------------- Fehlermeldungen ---
ReadConfigError         CSTR    "Couldn't load UULIB:PMail.Config!"
PublicMemStr            CSTR    "RAM"
                        dc.b    "$VER: "
NoPToolError            dc.b    "PMail v"
                        REVISION
                        dc.b    " ("
                        REVDATE
                        dc.b    ")"
                        dc.b    0
                        dc.b    " requires at least PTool.Library v2.xx!!",$0A,$0A
NoPToolError_len        equ     (*-NoPToolError)

        IFNE CHECKKEYFILE
KeyfileError_txt        dc.b    "I'm very sorry, but this version of PetiMail",$0A
                        dc.b    "is for beta-testing purposes only."
                        dc.b    0
        ENDC

;-------------------------------------- ReadArgs() --------
RDArgsTemplate  CSTR    "CallSystem/A,-Getty/S,-Device/K,-Unit/K/N,-XPRLIB/K,-XPROPT/K,ZMW=ZModemWindow/K/N"

                CNOP    0,4
_RDArgsStruct   ds.l    1

CallSystem      ds.l    1               ; Array fr ReadArgs()
GettyMode       ds.l    1
Device          ds.l    1
Unit            ds.l    1
XprLib          ds.l    1
XprOpt          ds.l    1
ZMWindow        ds.l    1

;-------------------------------------- PMail-Config ------
ConfigFile      CSTR    "UULIB:PMail.config"
NodeName_KW     CSTR    "NODENAME"
ZModemWindow_KW CSTR    "ZMODEMWINDOW"
Spool_KW        CSTR    "SPOOL"
Logfile_KW      CSTR    "LOGFILE"
Bruteforce_KW   CSTR    "BRUTEFORCE"
SystemConfig_KW CSTR    "SYSTEMCONFIGS"
Timeout_KW      CSTR    "TIMEOUT"
MyPri_KW        CSTR    "MYPRI"
Execute1_KW     CSTR    "EXECUTE1"
Execute2_KW     CSTR    "EXECUTE2"
Execute3_KW     CSTR    "EXECUTE3"
DevLocking_KW   CSTR    "DEVICELOCKING"
StandardDev_KW  CSTR    "STANDARDDEVICE"
Xfers_KW        CSTR    "XFERSTATS"

                CNOP    0,4
_ConfigBuffer   ds.l    1

ConfigTagList   dc.l    IC_String,NodeName_KW
                dc.l    IC_YesNo,ZModemWindow_KW
                dc.l    IC_String,Spool_KW
                dc.l    IC_String,Logfile_KW
                dc.l    IC_YesNo,Bruteforce_KW
                dc.l    IC_String,SystemConfig_KW
                dc.l    IC_Number,Timeout_KW
                dc.l    IC_Number,MyPri_KW
                dc.l    IC_String,Execute1_KW
                dc.l    IC_String,Execute2_KW
                dc.l    IC_String,Execute3_KW
                dc.l    IC_YesNo,DevLocking_KW
                dc.l    IC_String,StandardDev_KW
                dc.l    IC_String,Xfers_KW
                dc.l    TAG_DONE

_NodeName       ds.l    1               ; Array fr InterpretConfigFile()
ZModemWindow    ds.l    1
_Spool          ds.l    1
_Logfile        ds.l    1
Bruteforce      ds.l    1
SystemConfigs   ds.l    1
DefaultTimeout  ds.l    1
MyPri           ds.l    1
_Execute1       ds.l    1
_Execute2       ds.l    1
_Execute3       ds.l    1
DevLocking      ds.l    1
_StandardDev    ds.l    1
_Xfers          ds.l    1

;-------------------------------------- System-Config ----
ConfAppendix    CSTR    ".PMConfig"
DialString_KW   CSTR    "DIALSTRING"
Password_KW     CSTR    "PASSWORD"
Baud_KW         CSTR    "BAUD"
ConnectPattern_KW CSTR  "CONNECTPATTERN"
XprLibrary_KW   CSTR    "XPRLIBRARY"
XprOptString_KW CSTR    "XPROPTSTRING"
ModemInit_KW    CSTR    "MODEMINIT"

                CNOP    0,4
_SysConfBuffer  ds.l    1

SysConfTagList  dc.l    IC_String,DialString_KW
                dc.l    IC_String,Password_KW
                dc.l    IC_Number,Baud_KW
                dc.l    IC_String,ConnectPattern_KW
                dc.l    IC_String,XprLibrary_KW
                dc.l    IC_String,XprOptString_KW
                dc.l    IC_String,ModemInit_KW
                dc.l    TAG_DONE

_DialString     ds.l    1               ; Array fr InterpretConfigFile()
_Password       ds.l    1
Baud            ds.l    1
_ConnectPattern ds.l    1
_XprLibrary     ds.l    1
_XprOptString   ds.l    1
_ModemInit      ds.l    1

;-------------------------------------- XFerStats ---------
StartDateStamp  ds.b    ds_SIZEOF
EndDateStamp    ds.b    ds_SIZEOF
SentBytes       ds.l    1
SentBytesAll    ds.l    1
ReceivedBytes   ds.l    1
ReceivedBytesAll ds.l   1
SentFiles       ds.w    1
ReceivedFiles   ds.w    1

;-------------------------------------- Locale ------------
                INCLUDE "A:Sources/PetiMail/PMail_Locale.i"
                IFND MODIFIED_LOCALE
                FAIL
                ENDC

LocaleError     CSTR    "Something went wrong with PMails localisation! Please report!!",$0A

;-------------------------------------- Diverses ----------
        IFNE CHECKKEYFILE
PMailKeyfile    CSTR    "L:PMail.key"
        ENDC
NameAppendix    CSTR    ".LHA"
HangupStr       CSTR    "ATH\r"
PrgName         dc.b    "PMail"
NullByte        dc.b    0

;-------------------------------------- ZModem ------------
                CNOP    0,4
_TNDispTask     ds.l    1
ZMTransfer      dc.l    1
                dc.l    0
                dc.l    0
                dc.l    0
                dc.l    0
                dc.l    0
                dc.l    0
                dc.l    0
                dc.l    1
                dc.l    1

;-------------------------------------- Platzhalter -------
OldPri          dc.b    -1
DeviceOpen      dc.b    0
                CNOP    0,4
_FilenameBuffer ds.l    1
_SpoolLock      ds.l    1
_OldCurrentDir  ds.l    1
_AlarmIOReq     ds.l    2
_RememberKey    ds.l    1
_FileRequests   dc.l    NullByte
        IFNE CHECKKEYFILE
_Keyfile        ds.l    1
        ENDC

                END
