#ifndef PTOOL_LIBRARY_H
#define PTOOL_LIBRARY_H

/**
 **     $VER: PToolLibrary.h 2.000 (31-Aug-93)
 **
 **     (C) Copyright 1993 Peter Simons, Germany
 **         All Rights Reserved
 **/

/*************************************** Macros ***********/
#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif
#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif
#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

/*************************************** LibraryName ******/
#define PTOOLNAME "ptool.library"

/*************************************** LibraryBase ******/
struct PToolBase {
        struct Library  LibNode;
        ULONG   ptl_SysBase;
        ULONG   ptl_DOSBase;
        ULONG   ptl_IntuitionBase;
        ULONG   ptl_LocaleBase;
        ULONG   ptl_MessageCatalog;
        ULONG   ptl_SegList;
        ULONG   ptl_CRC32Table;
        ULONG   ptl_PMCmpTable;
        ULONG   ptl_RandomSeed, ptl_RandomSeed2;
};

/*************************************** CheckConfig ******/
#define CCF_68010       (1L<<0)
#define CCF_68020       (1L<<1)
#define CCF_68030       (1L<<2)
#define CCF_68040       (1L<<3)
#define CCF_68881       (1L<<4)
#define CCF_68882       (1L<<5)
#define CCF_FPU40       (1L<<6)
#define CCF_OS_VERSION  (1L<<16)

#define CCB_68010       0
#define CCB_68020       1
#define CCB_68030       2
#define CCB_68040       3
#define CCB_68881       4
#define CCB_68882       5
#define CCB_FPU40       6
#define CCB_OS_VERSION  16

#define CC_MAXCONFIG    %00000000000000010000000001111111

/*************************************** InterpretConfig **/
#define IC_TagBase      TAG_USER+0xF0000

#define IC_String       IC_TagBase+0x01
#define IC_Number       IC_TagBase+0x02
#define IC_YesNo        IC_TagBase+0x03


#endif  /* PTOOL_LIBRARY_H */
