;****** Auto-Revision Header (do not edit) *******************************
;*
;*  Copyright by PetiWare - freely distributable software
;*
;* Filename         : PToolLibrary.i
;* Created on       : 23-Aug-92
;* Created by       : Peter Simons
;* Current revision : V2.000
;*
;*
;* Purpose: Functionoffsets for PTool.library
;*
;*
;* V2.000 : definitions for v2.xxx of PTool.Library
;*                                               Peter Simons (15-Mr-93)
;*
;* V1.000 : definitions for v1.xxx of PTool.Library
;*
;* V0.000 : --- Initial release ---
;*
;*************************************************************************

        IFND    PTOOL_LIBRARY_I
PTOOL_LIBRARY_I EQU     1

;-------------------------------------- Macros ------------
        IFND EXEC_LIBRARIES_I
                INCLUDE "exec/libraries.i"
        ENDC
        IFND UTILITY_TAGITEM_I
                INCLUDE "utility/tagitem.i"
        ENDC

;-------------------------------------- Offsets -----------
                LIBINIT

                LIBDEF  _LVOAllocNewStack
                LIBDEF  _LVORestoreStack

                LIBDEF  _LVOGetErrorMsg
                LIBDEF  _LVOErrorHandleDos
                LIBDEF  _LVOErrorHandleIntuition

                LIBDEF  _LVOCheckConfig
                LIBDEF  _LVODisplayConfigErrorDos

                LIBDEF  _LVOGetStackSize

                LIBDEF  _LVOParsePatternFast
                LIBDEF  _LVOPatternMatchFast
                LIBDEF  _LVOParsePatternFastArray
                LIBDEF  _LVOPatternMatchFastArray
                LIBDEF  _LVOPatternTest

                LIBDEF  _LVOLoadFile

                LIBDEF  _LVOInterpretConfigBuffer
                LIBDEF  _LVOInterpretConfigFile

                LIBDEF  _LVOPrintF
                LIBDEF  _LVOPrintFSimple

                LIBDEF  _LVOLoadBreak
                LIBDEF  _LVOSaveBreak

                LIBDEF  _LVOGetFileSize

                LIBDEF  _LVOCRC16Buffer
                LIBDEF  _LVOCRC16File

                LIBDEF  _LVOPTAllocRemember
                LIBDEF  _LVOPTFreeRemember
                LIBDEF  _LVOPTFreeOneBlock

                LIBDEF  _LVOLoadFileRemember
                LIBDEF  _LVOInterpretConfigFileRemember

                LIBDEF  _LVOFind
                LIBDEF  _LVOReplace
                LIBDEF  _LVOCmpStrings
                LIBDEF  _LVOCmpStringsSen

                LIBDEF  _LVOCRC32Buffer
                LIBDEF  _LVOCRC32File

                LIBDEF  _PTPrivate

                LIBDEF  _LVOSetRandomSeed
                LIBDEF  _LVOLongRnd
                LIBDEF  _LVORandom

;-------------------------------------- LibraryName -------
PTOOLNAME       MACRO
                CSTR    "ptool.library"
                EVEN
                ENDM

;-------------------------------------- LibraryBase -------
            STRUCTURE PToolBase,LIB_SIZE
                ULONG   ptl_SysBase
                ULONG   ptl_DOSBase
                ULONG   ptl_IntuitionBase
                ULONG   ptl_LocaleBase
                ULONG   ptl_MessageCatalog
                ULONG   ptl_SegList
                ULONG   ptl_CRC32Table
                ULONG   ptl_PMCmpTable
                STRUCT  ptl_RandomSeed,8
                LABEL   ptl_SIZEOF

;-------------------------------------- CheckConfig -------
                BITDEF  CC,68010,0
                BITDEF  CC,68020,1
                BITDEF  CC,68030,2
                BITDEF  CC,68040,3
                BITDEF  CC,68881,4
                BITDEF  CC,68882,5
                BITDEF  CC,FPU40,6
                BITDEF  CC,OS_VERSION,16
CC_MAXCONFIG    EQU     %00000000000000010000000001111111

;-------------------------------------- InterpretConfig ---
IC_TagBase      EQU     TAG_USER+$F0000

IC_String       EQU     IC_TagBase+$01
IC_Number       EQU     IC_TagBase+$02
IC_YesNo        EQU     IC_TagBase+$03

;-------------------------------------- PTAllocRemember ---
PTMemoryList    CLRSO           ; internal structure of a RememberList
ptml_NextBlock  SO.L    1
ptml_Size       SO.L    1
ptml_SIZEOF     SOVAL

;-------------------------------------- ErrorHandle -------
; ERRORHANDLE is a macro that allows easy errorhandling using the libraries
; error-routines. This macro automagically tests the contents of D0 and
; generates the specified errormessage if D0 is zero.
;
; The syntax is:
; ERRORHANDLE SaveTo, Errornummer, Continue, [Dataflow], [DataFlow2]
;
; SaveTo - If you leave this parameter out ('',), the macro generates a
;               "TST.L d0" to set the flags. But you may also specify an
;               address or register, where the contents of D0 should be
;               saved to. For example: "ERRORHANDLE (_DOSBase),..." will
;               generate the code "move.l d0,(_DOSBase)".
;
;               ATTENTION: This doesn't work with address-registers,
;               because the flags aren't set on address-register access.
;
; Errornummer - This is the number of the error that should be generated if
;               D0 is equal to zero. Consult GetErrorMsg() for a detailed
;               description of each error.
;
; Continue - Here you have to pass the address where the macro shall jump
;               to after the errormessage is generated, usually some code
;               that deallocates the libraries and resources.
;
;               The errors that don't need any additional parameters (like
;               error 0 or 5) push this address on the stack and jump there
;               via "rts", so you may use PC-relative addresses here. All
;               other errors jump to the address via bra, so PC-relative
;               addresses are not necessaey and not allowed. :-)
;
; DataFlow - This is the address of the first parameter needed in the
;               errormessage. This is optional, if the error doesn't need
;               any further parameters, but most errors do.
;
;               The datastream is arranged on the stack, so you may use
;               pc-relative addresses here always.
;
; DataFlow2 - Like the first DataFlow and also optional as some errors
;               don't need two parameters.
;
; The macro calls a function named _ErrorHandle. ErrorHandle() should look
; something like that:
;
; _ErrorHandle    movem.l d0-d1/a0-a2/a6,-(SP)
;                 lea     (PrgName,PC),a0
;                 sub.l   a2,a2
;                 move.l  (_PToolBase,PC),a6
;                 jsr     (_LVOErrorHandleIntuition,a6)
;                 movem.l (SP)+,d0-d1/a0-a2/a6
;                 rts
;
; If you prefer ErrorHandleDos() you do not need A2 of course, but then
; you'll have to initialize D1 correctly. This routine gets D0 and A1 as
; parameters: finished.
;
; If you now want to handle an error using IoErr() all you have to do is:
;
;                 [...]
;                 tst.l   d0
;                 bne.b   .NoError
;                 pea     (.GoOn,PC)
;                 bra     _ErrorHandle    ; D0 is already zero!
;
; .NoError        [...]
;
; or:
;
;                 ERRORHANDLE ,0,(.GoOn,PC)
;
; Opening a file savely works like this:
;
;                [...]
;                jsr     (_LVOOpen,a6)
;                ERRORHANDLE (_FileHandle),1,.CloseDosLibrary,(filename,PC)
;                [...]
;
;

ERRORHANDLE     MACRO
errbyte         set     0
        IFC ,\1
                tst.l   d0                      ; Do we have a destination
        ELSE                                    ; for D0?
                move.l  d0,\1                   ; No -> then just test D0
        ENDC
                bne.b   .NoError\@              ; D0 is already 0L
        IFEQ \2
                pea     \3
                bra     _ErrorHandle            ; error 0 --> no parameters
        ELSE
          IFEQ \2-5
                pea     \3
                bra     _ErrorHandle            ; error 5 --> no parameters
          ELSE

                moveq   #\2,d0                  ; write errornumber into D0
            IFNC \5                             ; if a second parameter is
              IFEQ \2-9                         ; passed, push it onto the
                move.w  #\5,-(SP)               ; stack.
errbyte         set     errbyte+2
              ELSE                              ; Exceptions
                pea     \5                      ; err 9 = number.w
errbyte         set     errbyte+4
              ENDC                              ; all other errors get
            ENDC                                ; pointers to a string

            IFEQ \2-2                           ; push first parameter onto
                move.l  #\4,-(SP)               ; the stack
errbyte         set     errbyte+4
            ELSE                                ; Exceptions:
              IFEQ \2-8                         ; err 2 = number.L
                move.l  #\4,-(SP)               ; err 8 = number.L
errbyte         set     errbyte+4
              ELSE
                pea     \4                      ; the rest is a pointer
errbyte         set     errbyte+4
              ENDC
            ENDC
                move.l  SP,a1                   ; Load pointer to the
                bsr     _ErrorHandle            ; DataFlow to A1 and jump
                addq.w  #errbyte,SP             ; into ErrorHandle().
                bra     \3
          ENDC
        ENDC
.NoError\@
                ENDM

        ENDC    ; PTOOL_LIBRARY_I

