;***************************************************************************
;*                                                                         *
;* SEKTION: Labels, Macros, Switches, Structures                           *
;*                                                                         *
;***************************************************************************

;-------------------------------------- Switches -----------
                MC68000
                EXEOBJ
                NEWSYNTAX
                OBJFILE "RAM:PLibTest"
                DEBUG on
                SYM
                MULTIPASS
;               VERBOSEOPTIM

;-------------------------------------- Labels ------------
                MACLIB  "DATAS:Includes.preass"
                MACLIB  "DATAS:Offsets.preass"
                MACFILE "A:Sources/PetiToolLibrary/PToolLibrary.i"

PETILIB_VERSION         equ     2
BUFFERSIZE              equ     $5000

;***************************************************************************
;*                                                                         *
;* SEKTION: Programm                                                       *
;*                                                                         *
;***************************************************************************


;------------------------------- main-program -----------------------------
START           lea     (PToolLibName,PC),a1
                moveq   #PETILIB_VERSION,d0
                move.l  ($4).W,a6
                jsr     (_LVOOpenLibrary,a6)
                tst.l   d0
                beq     .exit
                move.l  d0,a6

;------------------------ test configuration-routines ---------------------
.CheckConfig    moveq   #-1,d0
                moveq   #38,d1
                jsr     (_LVOCheckConfig,a6)

                moveq   #0,d2
                lea     (PrgName,PC),a0
                jsr     (_LVODisplayConfigErrorDos,a6)

;---------------------------- test stack-routines -------------------------
.Stack          jsr     (_LVOGetStackSize,a6)
                move.l  d0,(ErrorPattern1)

                move.l  #5*1024,d0
                lea     (NewStackStruct,PC),a0  ; 5k Stack
                jsr     (_LVOAllocNewStack,a6)
                tst.l   d0
                beq     .CloseLib

;------------------------------ test IO-routines --------------------------
.PrintF         lea     (TestString,PC),a0
                lea     (TestFlow,PC),a1
                jsr     (_LVOPrintFSimple,a6)

;---------------------------- test PTAllocRemember ------------------------
.PTAlloc        lea     (_RememberKey,PC),a0
                move.l  #500,d0
                move.l  #MEMF_ANY,d1
                movem.l d0-d1/a0,-(SP)
                jsr     (_LVOPTAllocRemember,a6)
                movem.l (SP),d0-d1/a0
                jsr     (_LVOPTAllocRemember,a6)
                movem.l (SP),d0-d1/a0
                add.l   #2334,d0
                jsr     (_LVOPTAllocRemember,a6)
                movem.l (SP),d0-d1/a0
                add.l   #234,d0
                jsr     (_LVOPTAllocRemember,a6)
                movem.l (SP)+,d0-d1/a0
                add.l   #-234,d0
                jsr     (_LVOPTAllocRemember,a6)

                lea     (_RememberKey,PC),a0
                move.l  d0,a1
                jsr     (_LVOPTFreeOneBlock,a6)

;-------------------------- test InterpretConfigFile ----------------------
                move.l  #CCF_OS_VERSION,d0
                moveq   #37,d1
                jsr     (_LVOCheckConfig,a6)    ; The following routines
                tst.l   d0                      ; require OS 2.04!
                bne     .leave

.ICF            lea     (Config,PC),a0
                lea     (TagList,PC),a1
                lea     (Buffer,PC),a2
                lea     (_RememberKey,PC),a3
                jsr     (_LVOInterpretConfigFileRemember,a6)
                tst.l   d0
                bne.b   .InterpretOkay
                moveq   #0,d0
                lea     (PrgName,PC),a0
                sub.l   a1,a1
                sub.l   a2,a2
                jsr     (_LVOErrorHandleIntuition,a6)
                bra.b   .SkipConfigTest
.InterpretOkay  lea     (ConfigText,PC),a0
                lea     (Buffer,PC),a1
                jsr     (_LVOPrintFSimple,a6)
.SkipConfigTest
;------------------------------ test errorhandling ------------------------
.Errors         moveq   #8,d0
                lea     (PrgName,PC),a0
                lea     (ErrorPattern1,PC),a1
                move.l  #0,a2
                jsr     (_LVOErrorHandleIntuition,a6)

                moveq   #2,d0
                lea     (PrgName,PC),a0
                lea     (ErrorPattern2,PC),a1
                move.l  #0,a2
                jsr     (_LVOErrorHandleIntuition,a6)

;---------------------------- test patternmatching ------------------------
.Patterns       lea     (pattern,PC),a0
                move.l  #255,d0
                jsr     (_LVOPatternTest,a6)
                lea     (pattern,PC),a0
                lea     (Buffer,PC),a1
                lea     (orbuffer,PC),a2
                jsr     (_LVOParsePatternFastArray,a6)
                lea     (text,PC),a0
                lea     (orbuffer,PC),a1
                jsr     (_LVOPatternMatchFastArray,a6)

;---------------------------- test GetFileSize() --------------------------
.GetFileSize    lea     (Filename,PC),a0
                jsr     (_LVOGetFileSize,a6)

;------------------------------ test LoadFile() ---------------------------
.LoadFile       lea     (Filename,PC),a0
                lea     (_RememberKey,PC),a1
                jsr     (_LVOLoadFileRemember,a6)
                tst.l   d0
                bne.b   .LoadFileOkay
                moveq   #0,d0
                lea     (PrgName,PC),a0
                sub.l   a1,a1
                sub.l   a2,a2
                jsr     (_LVOErrorHandleIntuition,a6)
                bra.b   .leave

.LoadFileOkay   move.l  d0,a2
                move.l  a2,a0
                move.l  (a0)+,d0
                jsr     (_LVOCRC16Buffer,a6)
                lea     (ChecksumText,PC),a0
                move.w  d0,-(SP)
                pea     (Filename,PC)
                move.l  SP,a1
                jsr     (_LVOPrintFSimple,a6)
                addq.w  #6,SP

;-------------------------------- restore stack ---------------------------
.leave          lea     (NewStackStruct,PC),a0          ; free Stack
                jsr     (_LVORestoreStack,a6)

                lea     (_RememberKey,PC),a0            ; free memory
                jsr     (_LVOPTFreeRemember,a6)

;------------------------------ exit gracefully ---------------------------
.CloseLib       move.l  a6,a1
                move.l  ($4).W,a6
                jsr     (_LVOCloseLibrary,a6)

.exit           moveq   #0,d0
                rts


;***************************************************************************
;*                                                                         *
;* SEKTION: Daten, Zeiger                                                  *
;*                                                                         *
;***************************************************************************

PToolLibName    CSTR    "ptool.library"

PrgName         CSTR    "LibraryTest"
Chip            CSTR    "ChipMemory"

pattern         CSTR    "(#?re #?|??test??|die#?|heinz|#?aus?ie?|#?)#?|#?(#?)",0
text            CSTR    "Re: Klaus( die!"

Filename        CSTR    "C:Dir"
Config          CSTR    "UUPUB:PetiToolLibrary/Sources/TestConfig"

Nodename        CSTR    "NodeName"
Username        CSTR    "UserName"
Realname        CSTR    "RealName"
ShowRequester   CSTR    "ShowRequester"
StackSize       CSTR    "StackSize"

TestString      CSTR    "Hello %s! This is a magically test!",$0A
ChecksumText    CSTR    "The file >%s< has the checksum: $%04.x!",$0A

ConfigText      dc.b    "You choosed the following in the configfile:",$0A
                dc.b    "NodeName......: >%s<",$0A
                dc.b    "UserName......: >%s<",$0A
                dc.b    "RealName......: >%s<",$0A
                dc.b    "StackSize.....: %ld",$0A
                dc.b    "ShowRequester.: %ld",$0A
                dc.b    0

                EVEN
Buffer          ds.b    BUFFERSIZE

                CNOP    0,4
ErrorPattern1   dc.l    40*1024 ; Here the return-value of GetStackSize()
ErrorPattern2   dc.l    1200    ; is stored
                dc.l    Chip

_RememberKey    ds.l    1
NewStackStruct  ds.l    3
orbuffer        ds.l    10
TestFlow        dc.l    ShowRequester

TagList         dc.l    IC_String,Nodename
                dc.l    IC_String,Username
                dc.l    IC_String,Realname
                dc.l    IC_Number,StackSize
                dc.l    IC_YesNo,ShowRequester
                dc.l    TAG_DONE

                END


