/*
 * Compile with SAS/C 6.x as follows:
 *
 * sc PToolLibrary_Test.c NOSTARTUP LINK NOSTACKCHECK PARMS=REGISTER
 *
 */

#include <libraries/ptoollibrary.h>
#include <exec/memory.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/ptool.h>

#define PRGNAME "LibraryTest"
#define FILENAME "C:Dir"
#define TESTCONF "UUPUB:PetiToolLibrary/Sources/TestConfig"

int __saveds main(void)
{
        struct PToolLibrary *PToolBase;
        struct ConfStruct {
                STRPTR Nodename;
                STRPTR Username;
                STRPTR Realname;
                STRPTR ShowRequester;
        } ConfStruct;

        void *RememberKey = NULL, *memblock;
        char ConfMsg[] = "You choosed the following in the configfile:\nNodeName......: >%s<\nUserName......: >%s<\nRealName......: >%s<\nShowRequester.: %ld\n";
        static ULONG NewStack[3];

        if (!(PToolBase = (struct PToolLibrary *) OpenLibrary(PTOOLNAME, 2L)))
                return 10;

        DisplayConfigErrorDos(PRGNAME, CheckConfig(-1L, 100), 100, NULL);

        PrintFSimple("StackSize: %ld\n", GetStackSize());
        if(AllocNewStack(NewStack, 5000L))
                RestoreStack(NewStack);
        else
                PrintFSimple("Unable to allocate new stack!");

        PTAllocRemember(&RememberKey, 500L, MEMF_ANY);
        PTAllocRemember(&RememberKey, 238L, MEMF_ANY);
        memblock = PTAllocRemember(&RememberKey,  20L, MEMF_ANY|MEMF_CLEAR);
        PTAllocRemember(&RememberKey, 468L, MEMF_ANY);
        PTAllocRemember(&RememberKey, 400L, MEMF_CHIP);
        PTFreeOneBlock(&RememberKey, memblock);

        if (!(CheckConfig(CCF_OS_VERSION, 37))) {
                /* These routines require 2.04! */

                if (!(InterpretConfigFileRemember(TESTCONF, &ConfStruct,
                                &RememberKey,
                                IC_String, "Nodename",
                                IC_String, "Username",
                                IC_String, "Realname",
                                IC_YesNo, "ShowRequester",
                                TAG_DONE)))
                        PrintFSimple("Couldn't load my configfile!");
                else {
                        PrintFSimple(ConfMsg, ConfStruct);

                ErrorHandleIntuition(PRGNAME, NULL, 8, 10*1024L);
                ErrorHandleIntuition(PRGNAME, NULL, 2, 1200L, "Chip-Ram");

                PrintFSimple("%s is %ld byte large.\n", FILENAME, GetFileSize(FILENAME));
                PrintFSimple("The CRC-32 checksum is: 0x%lx\n", CRC32File(FILENAME));
                }
        }

        PTFreeRemember(&RememberKey);
        CloseLibrary((struct Library *) PToolBase);
        return 0;
}

