;****** Auto-Revision Header (do not edit) *******************************
;*
;*  Copyright by PetiWare - freely distributable software
;*
;* Filename         : PetiToolLibrary.asm
;* Created on       : 23-Aug-92
;* Created by       : Peter Simons
;* Current revision : V2.057
;*
;*
;* Purpose: Dies ist die Supportlibrary fr alle Programme die ich
;*          schreibe!
;*
;*
;* V2.057 : SetRandomSeed(), Random() und LongRnd() hinzugefgt. Der Seed
;*          wird in der Librarybase gespeichert.
;*
;* V2.056 : PrivateHandler eingefgt, bisher mit den Funktionen Decode-
;*          Data() und EncodeData().
;*
;* V2.055 : Die CompareTabelle frs Patternmatching befindet sich jetzt
;*          ebenfalls nicht mehr direkt im Librarycode, sondern wird erst
;*          bei Bedarf berechnet und in der Librarybase gespeichert.
;*
;* V2.054 : Das erstellen einer Tabelle nach dem Start der Library birgt
;*          einige Gefahren, vor allem wenn der Code gleichzeitig von
;*          mehreren Tasks durchlaufen wird. Deshalb habe ich die kriti-
;*          schen Teile in Forbid()/Permit() eingeklammert.
;*
;* V2.053 : Wenn das Selfexpunge-FLAG gesetzt ist, wird an den Library-
;*          namen im Versionstring ein "_BETA" angehngt.
;*
;* V2.052 : Einige unbenutzte Strings aus den Zeiten vor der Lokali-
;*          sierung gefunden und gelscht.
;*
;* V2.051 : Alles was mit CRC32 zu tun hat vllig ausgetauscht. Die
;*          Tabelle wird erst erstellt wenn sie bentigt wird und dann
;*          in der Librarybase gespeichert. Auerdem habe ich die eigent-
;*          liche Routine ausgetauscht.
;*
;* V2.050 : Mehrere Fehler gefunden, vor allem wurden Register nicht
;*          gerettet!!
;*
;* V2.015 : CmpStrings() hat die Register mit "PUSHM d0-d2,-(SP)" ge-
;*          rettet, was sicher nicht im Sinne des Erfinders war. Hat je-
;*          doch keinen Fehler verursacht, da der zweite Parameter ein-
;*          fach berlesen wird.
;*
;* V2.014 : Die -1 am Ende der AppString-Tabelle ntzt garnichts weil der
;*          BMI-Vergleich mit negativen Zahlen nicht funktioniert. :-)
;*          Deshalb auf BCS - Carry set umgestellt.
;*
;*
;* V2.013 : GetString() verlt sich nicht mehr darauf, da die Library-
;*          Base in A6 ist, sondern ldt diese aus einem reserviertem
;*          Speicherplatz.
;*
;* V2.012 : Die Appstring-Tabelle wird sicherheitshalber mit einer -1 ab-
;*          geschlossen, damit die Library nicht ins endlose sucht, wenn
;*          eine falsche Stringnummer angegeben wird.
;*
;* V2.011 : GetErrorMsg hat den Error 11 nicht mehr erkannt und immer
;*          eine Null zurckgegeben.
;*
;* V2.010 : 32 Bit CRC-Routinen hinzugefgt: CRC32File() und CRC32()
;*
;* V2.000 : Da jetzt doch einige neue Funktionen in der Library sind,
;*          die Versionsnummer auf v2.0 gesetzt, damit meine Programme
;*          die Library gezielt anfordern knnen.
;*                                               Peter Simons (15-Mr-93)
;*
;* V1.251 : GetErrorMsg() berarbeitet. Die Routine ist jetzt nicht mehr
;*          in Locale/nicht Locale aufgeteilt, da dies jetzt GetString()
;*          bernimmt.
;*
;* V1.250 : Alle Strings werden jetzt ber GetString() und die Locale-
;*          Library angefordert. Endlich sind auch die KonfigErrors
;*          lokalisiert.
;*
;* V1.201 : InterpretConfigBuffer() auf die neuen Vergleichsroutinen um-
;*          gestellt.
;*
;* V1.200 : Neu: Find(), Replace(), CmpStrings(), CmpStringsSen()
;*
;* V1.190 : Neu: InterpretConfigFileRemember()
;*
;* V1.180 : Neue Routine: LoadFileRemember()!
;*          Arbeitet jetzt mit den RememberKeys zusammen, soda auch ge-
;*          ladene Buffer ber PTFreeRemember() freigegeben werden
;*          knnen.
;*
;* V1.172 : Bei den Routinen die 2.04 brauchen einen Sicherheitscheck
;*          eingebaut!
;*
;* V1.171 : Bei einigen Funktionen Kommentare hinzugefgt, welche OS-
;*          Version sie brauchen.
;*          GetFileSize() luft jetzt auch ohne OS 2.04!
;*
;* V1.170 : Neue Funktionen: PTAllocRemember(), PTFreeRemember() und
;*                           PTFreeOneBlock()
;*
;* V1.162 : Fehler in InterpretConfigBuffer() behoben: Wurde ein Keyword
;*          im Puffer gefunden, war jedoch nicht gltig, so wurden die
;*          folgenden Zeilen nicht erneut durchsucht!
;*                             Thanks to Reinhold Pickartz for reporting!
;*
;* V1.161 : Wenn bei PrintF() ein Pufferberlauf auftritt, wird die
;*          Lnge des Strings ermittelt und ein passender Puffer dyna-
;*          misch reserviert.
;*
;* V1.160 : PrintF() erkennt jetzt einen Pufferberlauf und bricht recht-
;*          zeitig ab.
;*
;* V1.159 : Wurde bei InterpretConfigBuffer() ein Eintrag nicht gefunden,
;*          so wurde vergessen, eine Null ins Array zu schreiben, weshalb
;*          sich alle anderen Zeiger verschoben haben.
;*
;* V1.158 : Neue Routine: CRC16File()
;*
;* V1.157 : Neue Routine: CRC16()
;*
;* V1.156 : LoadBreak() und SaveBreak() setzen jetzt den IoErr auf Null,
;*          wenn sie mit CTRL/C abgebrochen wurden.
;*
;* V1.155 : InterpretConfigBuffer() war kaputt! Ein verdammter Longwort-
;*          Test auf eine Byteadresse lie den Nuller aussteigen.
;*                             Thanks to Reinhold Pickartz for reporting!
;*
;* V1.154 : CatComp berspringt Eintrge, die in beiden Sprachen gleich
;*          sind und gibt bei GetCatalogStr() dann eine Null zurck. Das
;*          hat meine Fehlermeldung 11 ("%s") gekillt!
;*
;* V1.153 : ErrorHandleIntuition() lokalisiert
;*
;* V1.152 : GetErrorMsg() ist jetzt lokalisiert
;*
;* V1.151 : Locale.Library wird jetzt von Init() geffnet und der Catalog
;*          initialisiert, den der Benutzer gewhlt hat.
;*
;* V1.150 : LoadBreak() enthielt als letzten Zugriff einen Write anstatt
;*          eines Reads.
;*
;* V1.149 : GetFileSize() hat A5 nicht gerettet!
;*
;* V1.148 : Fehler in GetFileSize behoben: Die Routine gab 0L zurck,
;*          wenn das File nicht existierte, richtig war jedoch -1L!
;*
;* V1.147 : Neue Funktion: GetFileSize()
;*
;* V1.146 : Zwei neue Routinen: LoadBreak() und SaveBreak()
;*
;* V1.145 : Startup-Code gendert. Er benutzt jetzt PrintFSimple(),
;*          anstatt die Bildschirmausgabe selbst zu machen.
;*
;* V1.144 : Alle Fehlermeldungen sind jetzt englisch. Auerdem wurde
;*          Fehler Nummer 5 gendert.
;*
;* V1.143 : PrintF() hat nicht alle Register gerettet
;*
;* V1.142 : Zwei neue Routinen: PrintF() und PrintFSimple()
;*          Ausserdem ein Monster-Makro namens ERRORHANDLE ins Include-
;*          File eingefgt.
;*
;* V1.141 : Zwei neue Tags fr InterpretConfigBuffer() eingefhrt:
;*          IC_YesNo und IC_Number
;*
;* V1.140 : Neue Routinen zum Verarbeiten von Config-Files:
;*          InterpretConfigFile() und InterpretConfigBuffer()
;*
;* V1.136 : Wurde die Library gestartet, so standen vor der Rckkehr
;*          teilweise wilde Werte in D0, soda die Shell annahm, da
;*          ein Fehler aufgetreten sei.
;*
;* V1.135 : In der Routine DisplayConfigErrorDos() wurde bei RawDoFmt()
;*          der Parameter %u benutzt. Dieser wurde jedoch erst ab V37
;*          eingefhrt, weshalb es unter alten Kickstartversionen einen
;*          etwas seltsamen Output gab.
;*
;* V1.134 : Library kann durch Starten resident gemacht werden. >Flush<
;*          entfernt sie wieder.
;*                                         Danke fr die Idee Thielscher!
;*
;* V1.133 : Neue Fehlermeldungen fr GetErrorMsg()
;*
;* V1.132 : Fehler in ErrorHandleIntuition() behoben! Der Name des Pro-
;*          gramms wurde nicht korrekt gehandhabt.
;*
;* V1.131 : LoadFile() hinzugefgt
;*
;* V1.130 : Die Patternmatching-Routinen aus der TextFormat.library in
;*          die PTool.library bernommen.
;*
;* V1.121 : Neue Fehlermeldungen fr GetErrorMsg()
;*
;* V1.120 : Alle Textfunktionen in die "TextFormat.Library" ausgelagert!
;*                                               Peter Simons (18-Nov-92)
;*
;* V1.113 : CheckConfig hat die OS-Version nicht richtig erkannt!
;*
;* V1.110 : GetStackSize() gibt jetzt immer korrekte Werte zurck, egal
;*          ob der Prozess vom CLI oder von der Workbench kommt. Auf
;*          einen Test, ob es sich berhaupt um einen Prozess handelt
;*          wurde verzichtet, da Tasks keine Libraries ffnen knnen!
;*
;* V1.101 : CheckConfig() maskiert jetzt unbekannte Bits aus
;*
;* V1.100 : Namen der Library gendert: petiware.library -> ptool.library
;*          Dementsprechend auch die LibraryBase von PWL_XXX nach PTL_XXX
;*                                               Peter Simons (17-Nov-92)
;*
;* V1.081 : Einige Register in Expunge() wurden nicht gerettet.
;*
;* V1.061 : Die Flags fr CheckConfig() von PWL_XXX nach CC_XXX umbe-
;*          nannt.
;*
;* V1.060 : GetStackSize() hinzugefgt
;*
;* V1.056 : Library-Type war <UNKNOWN>
;*
;* V1.055 : FunctionTable besteht jetzt aus Offsets --> keine Relocs mehr
;*
;* V1.054 : DisplayConfigErrorDos() gibt jetzt den Programmnamen nicht
;*          doppelt aus!
;*
;* V1.053 : Einige der Error-Routinen haben die Register nicht korrekt
;*          gerettet!!
;*
;* V1.052 : CheckConfig() hinzugefgt
;*
;* V1.051 : Die Stackroutinen laufen jetzt unter jeder OS-Version!
;*
;* V1.050 : Die Library lt sich jetzt auch unter OS-Versionen vor 2.04
;*          ffnen, manche Funktionen bentigen jedoch 2.04. Das mu der
;*          Library-Benutzer selber testen! Daher wurde die Dokumentation
;*          der Funktionen berarbeitet.
;*
;* V1.042 : Sicherheitsabfrage bei GetErrorMsg() eingebaut, um zu hohe
;*          Fehlermeldungen abzufangen.
;*
;* V1.041 : GetErrorMsg() neu geschrieben. Benutzt jetzt RawDoFmt() und
;*          erlaubt deshalb auch Zahlen und hnliches im Text.
;*
;* V1.040 : ErrorHandling hinzugefgt
;*
;* V1.032 : Fehler im Expunge-Handling behoben: Die Library entfernt sich
;*          nur noch, wenn ein Flush durchgefhrt wird und kein Task sie
;*          mehr benutzt.
;*
;* V1.020 : StackRoutinen hinzugefgt
;*
;* V1.004 : Neuer Eintrag in der Library-Base: _DOSBase
;*
;* V1.003 : Ein Eintrag in der Librarybase gespart: pwl_Flags
;*
;* V1.002 : Library gibt jetzt den ID-String aus, wenn sie vom CLI aus
;*          gestartet wird.
;*
;* V1.001 : Aktuelle Library-Version: 1.xxx
;*
;* V0.001 : Das Library-Skelett funktioniert. Bis jetzt sind noch keine
;*          Funktionen implementiert.
;*
;* V0.000 : --- Initial release ---
;*
;*************************************************************************
;
;

;***************************************************************************
;*                                                                         *
;* SEKTION: Labels, Macros, Switches, Structures                           *
;*                                                                         *
;***************************************************************************

;-------------------------------------- Switches -----------
                MC68000
                EXEOBJ
                NEWSYNTAX
                OBJFILE "LIBS:PTool.Library"
;               MULTIPASS
;               VERBOSEOPTIM

SELFEXPUNGE     set     0       ; Library entfernen, sobald OPEN_CNT = 0

;-------------------------------------- Labels ------------
                MACLIB  "LIB:Includes.preass"
                MACLIB  "LIB:Offsets.preass"
                INCDIR  "INCLUDE:"
                MACFILE "libraries/PToolLibrary.i"

LIBVERSION      equ     2
LIBREVISION     equ     57
MY_PRI          equ     0
BLOCK_LEN       equ     $2000           ; Gre der Lade-/Speicherblcke bei
                                        ; LoadBreak() und SaveBreak()

MAX_PRIVATE     equ     0               ; Hchste Routinennummer die der
                                        ; PrivateHandler erkennt.

MAX_ERR_NUMBER  equ     11              ; Hchste Fehlernummer, die von
                                        ; GetErrorMsg() erkannt wird.

CRC32POLY       equ     $EDB88320

;-------------------------------------- Strukturen --------
AppString       CLRSO
as_ID           SO.l    1
as_Str          SO.w    1
AppString_SIZEOF SOVAL

;-------------------------------------- Macros ------------
REVISION        MACRO
                dc.b "2.057"
                ENDM
REVDATE         MACRO
                dc.b "01-Sep-93"
                ENDM
FUNCOFF         MACRO
                dc.w    \1-FunctionTable
                ENDM
LOCALEENTRY     MACRO
                dc.l    \1
                dc.w    \2-*
                ENDM


;***************************************************************************
;*                                                                         *
;* SEKTION: Ausfhrbarer Teil                                              *
;*                                                                         *
;***************************************************************************

                lea     (PetiToolLibName,PC),a1
                move.l  ($4).w,a6
                jsr     (_LVOOldOpenLibrary,a6) ; Wird die Library ge-
                tst.l   d0                      ; startet, so gibt sie
                beq.b   .exit                   ; ihre VersionID auf den
                move.l  d0,a6                   ; Bildschirm aus und install-
                lea     (LibraryID,PC),a0       ; iert sich selbst im
                jsr     (_LVOPrintFSimple,a6)   ; System.
.ClosePTLib     move.l  a6,a1
                move.l  (ptl_SysBase,a1),a6     ; Durch >Flush< kann sie
                jsr     (_LVOCloseLibrary,a6)   ; natuerlich wieder ent-
.exit           moveq   #0,d0                   ; fernt werden.
                rts


;***************************************************************************
;*                                                                         *
;* SEKTION: Library-Header                                                 *
;*                                                                         *
;***************************************************************************

ResidentHeader  dc.w    RTC_MATCHWORD
                dc.l    ResidentHeader
                dc.l    EndOfCode
                dc.b    RTF_AUTOINIT
                dc.b    LIBVERSION
                dc.b    NT_LIBRARY
                dc.b    MY_PRI
                dc.l    PetiToolLibName
                dc.l    LibraryID
                dc.l    Init

Init            dc.l    ptl_SIZEOF
                dc.l    FunctionTable
                dc.l    DataTable
                dc.l    _InitRoutine

DataTable       INITBYTE LN_TYPE,NT_LIBRARY
                INITLONG LN_NAME,PetiToolLibName
                INITBYTE LIB_FLAGS,LIBF_SUMUSED|LIBF_CHANGED
                INITWORD LIB_VERSION,LIBVERSION
                INITWORD LIB_REVISION,LIBREVISION
                INITLONG LIB_IDSTRING,LibraryID
                dc.l     0                      ; Endmarkierung


;--------------------- Tabelle der Funktionen der Library ----------------

FunctionTable   dc.w    -1

                FUNCOFF _Open                   ; Standard-Libraryfunktionen
                FUNCOFF _Close
                FUNCOFF _Expunge
                FUNCOFF _Null

                FUNCOFF _AllocNewStack
                FUNCOFF _RestoreStack

                FUNCOFF _GetErrorMsg
                FUNCOFF _ErrorHandleDos
                FUNCOFF _ErrorHandleIntuition

                FUNCOFF _CheckConfig
                FUNCOFF _DisplayConfigErrorDos

                FUNCOFF _GetStackSize

                FUNCOFF _ParsePatternFast
                FUNCOFF _PatternMatchFast
                FUNCOFF _ParsePatternFastArray
                FUNCOFF _PatternMatchFastArray
                FUNCOFF _PatternTest

                FUNCOFF _LoadFile

                FUNCOFF _InterpretConfigBuffer
                FUNCOFF _InterpretConfigFile

                FUNCOFF _PrintF
                FUNCOFF _PrintFSimple

                FUNCOFF _LoadBreak
                FUNCOFF _SaveBreak

                FUNCOFF _GetFileSize

                FUNCOFF _CRC16
                FUNCOFF _CRC16File

                FUNCOFF _PTAllocRemember
                FUNCOFF _PTFreeRemember
                FUNCOFF _PTFreeOneBlock

                FUNCOFF _LoadFileRemember
                FUNCOFF _InterpretConfigFileRemember

                FUNCOFF _Find
                FUNCOFF _Replace
                FUNCOFF _CmpStrings
                FUNCOFF _CmpStringsSen

                FUNCOFF _CRC32
                FUNCOFF _CRC32File

                FUNCOFF _PrivateHandler

                FUNCOFF _SetRandomSeed
                FUNCOFF _LongRnd
                FUNCOFF _Random

                dc.w    -1                      ; Endmarkierung


;***************************************************************************
;*                                                                         *
;* SEKTION: Library-Skelett                                                *
;*                                                                         *
;***************************************************************************

_InitRoutine:
                ; Diese Routine wird vom Betriebssystem aufgerufen, wenn
                ; die Library geladen wird. Alles was die Routine tun muss,
                ; ist die Segmentliste abspeichern, da diese zum Freigeben
                ; des Speichers nachher bentigt wird
                ;
                ; Parameter: A0=Seglist A6=ExecBase D0=LibraryBase
                ; Result   : D0=LibraryBase
                ; Kommentar: Einige Funktionen der Library brauchen OS 2.04,
                ;            es wird jedoch nicht geprueft, welches Betriebs-
                ;            system-Version vorhanden ist. Das bleibt dem
                ;            "Benutzer" berlassen!!

                PUSHM   d1/a0-a2/a5-a6
                move.l  d0,a5
                move.l  a6,(ptl_SysBase,a5)
                move.l  a0,(ptl_SegList,a5)
                clr.l   (ptl_MessageCatalog,a5)

                lea     (dosname,PC),a1
                jsr     (_LVOOldOpenLibrary,a6)
                move.l  d0,(ptl_DOSBase,a5)
                beq.b   .exit

                lea     (intuiname,PC),a1
                jsr     (_LVOOldOpenLibrary,a6)
                move.l  d0,(ptl_IntuitionBase,a5)
                beq.b   .exit

                lea     (ptl_RandomSeed,a5),a0  ; Initialize RandomSeed
                lea     (4,a0),a1
                move.l  (ptl_IntuitionBase,a5),a6
                jsr     (_LVOCurrentTime,a6)

                lea     (localename,PC),a1
                moveq   #38,d0
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOOpenLibrary,a6)
                move.l  d0,(ptl_LocaleBase,a5)
                beq.b   .finished

                sub.l   a0,a0
                lea     (CatalogName,PC),a1
                sub.l   a2,a2
                move.l  (ptl_LocaleBase,a5),a6
                jsr     (_LVOOpenCatalogA,a6)
                move.l  d0,(ptl_MessageCatalog,a5)

.finished       move.l  a5,d0
                move.l  d0,(_PToolBase)
.exit           POPM
                rts


_Open:
                ; Diese Routine wird vom Betriebssystem aufgerufen, wenn
                ; jemand die Library ffnen will. Wir brauchen lediglich
                ; das Delayed-Expunge-Bit zu lschen und den Benutzer-
                ; zhler eins hochzusetzen.
                ;
                ; Parameter: A6=LibraryBase
                ; Result   : D0=LibraryBase

                addq.w  #1,(LIB_OPENCNT,a6)
                bclr.b  #LIBB_DELEXP,(LIB_FLAGS,a6)
                move.l  a6,d0
                rts

_Close:         ; Diese Routine schliet die Library und tested, ob sie
                ; noch von einem Task benutzt wird. Wenn nicht, und das
                ; DELAYED_EXPUNGE-Bit gesetzt ist, entfernt sie sich selbst!
                ;
                ; Parameter: A6=&LibraryBase
                ; Result   : D0=Null

                moveq   #0,d0
                subq.w  #1,(LIB_OPENCNT,a6)
                bne.b   .Close

        IFEQ SELFEXPUNGE
                btst.b  #LIBB_DELEXP,(LIB_FLAGS,a6)
                bne.b   _Expunge
        ELSE
                bra.b   _Expunge                ; sofort entfernen
        ENDC

.Close          rts


_Expunge:
                ; Diese Routine entfernt die Library aus dem Speicher
                ; und gibt die Segmentliste zurck.
                ;
                ; Parameter: A6=LibraryBase
                ; Result   : D0=SegList

                PUSHM   d2/a0-a1/a5-a6

                tst.w   (LIB_OPENCNT,a6)
                beq.b   .expunge
                bset.b  #LIBB_DELEXP,(LIB_FLAGS,a6)
                bra.b   .exit

.expunge        move.l  (ptl_SegList,a6),d2
                move.l  (ptl_SysBase,a6),a5
                exg.l   a5,a6

                move.l  (ptl_CRC32Table,a5),d0
                beq.b   .CRCTableUnused
                move.l  d0,a1
                move.l  #256*4,d0
                jsr     (_LVOFreeMem,a6)

.CRCTableUnused move.l  (ptl_PMCmpTable,a5),d0
                beq.b   .PMCTableUnused
                move.l  d0,a1
                move.l  #256*1,d0
                jsr     (_LVOFreeMem,a6)

.PMCTableUnused move.l  (ptl_IntuitionBase,a5),a1
                jsr     (_LVOCloseLibrary,a6)
                move.l  (ptl_DOSBase,a5),a1
                jsr     (_LVOCloseLibrary,a6)

                tst.l   (ptl_LocaleBase,a5)
                beq.b   .SkipLocale
                move.l  (ptl_MessageCatalog,a5),a0
                move.l  (ptl_LocaleBase,a5),a6
                jsr     (_LVOCloseCatalog,a6)
                move.l  (ptl_LocaleBase,a5),a1
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOCloseLibrary,a6)

.SkipLocale     move.l  a5,a1
                jsr     (_LVORemove,a6)

                moveq   #0,d0
                move.l  a5,a1
                move.w  (LIB_NEGSIZE,a5),d0
                sub.w   d0,a1
                add.w   (LIB_POSSIZE,a5),d0
                jsr     (_LVOFreeMem,a6)
                move.l  d2,d0

.exit           POPM
                rts

_Null:
                ; Frag mich jetzt bitte keiner, wofr diese Funktion gut
                ; sein soll!
                ;
                ; Parameter: keine
                ; Result   : D0=Null

                moveq   #0,d0
                rts


;***************************************************************************
;*                                                                         *
;* SEKTION: Interne Library-Funktionen                                     *
;*                                                                         *
;***************************************************************************
_Check204_0:
                ; Funktion : Testet ob OS 2.04 installiert ist und springt
                ;            mit einer Null in D0 aus der Library, wenn
                ;            nicht!
                ;
                ; Parameter: keine
                ; Result   : keins
                ; Kommentar: Verndert keine Register!

                pea     (a0)
                move.l  ($4).W,a0
                cmp.w   #37,(LIB_VERSION,a0)
                bpl.b   .return
                addq.w  #8,SP
                moveq   #0,d0
                rts
.return         move.l  (SP)+,a0
                rts


_Check204_1:
                ; Funktion : Testet ob OS 2.04 installiert ist und springt
                ;            mit einer -1L in D0 aus der Library, wenn
                ;            nicht!
                ;
                ; Parameter: keine
                ; Result   : keins
                ; Kommentar: Verndert keine Register!

                pea     (a0)
                move.l  ($4).W,a0
                cmp.w   #37,(LIB_VERSION,a0)
                bpl.b   .return
                addq.w  #8,SP
                moveq   #-1,d0
                rts
.return         move.l  (SP)+,a0
                rts


_Len:
                ; Funktion : Bestimmt die Lnge eines mit Null
                ;            abgeschlossenen Textes
                ;
                ; Parameter: A0=&Textpuffer
                ; Result   : D0=Lnge ohne das Nullbytes
                ; Kommentar: Verndert keine Register ausser D0!!!

                pea     (a0)            ; Register retten
.loop           tst.b   (a0)+
                bne.b   .loop           ; aktuelles Zeichen gleich Null?
                move.l  a0,d0
                move.l  (SP)+,a0
                sub.l   a0,d0           ; Lnge zurckgeben
                subq.l  #1,d0
                rts


_CopyString:
                ; Funktion : Kopiert einen mit Null abgeschlossenen String
                ;            von einem Puffer zu einem anderen.
                ;
                ; Parameter: A0=&String A1=&Text-Puffer
                ; Result   : A0=StringEnde+1 A1=aktuelle Pufferposition

...             move.b  (a0)+,(a1)+
                bne.b   ...
                subq.w  #1,a1
                rts


_GetString:
                ; Holt ber die Locale.Library einen String. Sollte Locale
                ; nicht verfgbar sein, wird der interne Catalog benutzt.
                ;
                ; Parameter: D0=Stringnumber
                ; Result   : D0=&String
                ; Kommentar: Kann GetString() den String nicht finden, wird
                ;            ein Zeiger auf eine Fehlermeldung zurck-
                ;            gegeben.
                ;            Die Routine benutzt nicht die Originaltabellen,
                ;            die von CatComp erzeugt werden!!

                PUSHM   d1-d2/a0-a1/a6
                move.l  (_PToolBase,PC),a6
                move.l  d0,d2

                tst.l   (ptl_MessageCatalog,a6)
                beq.b   .UseInternCat
                tst.l   (ptl_LocaleBase,a6)
                beq.b   .UseInternCat

                move.l  (ptl_MessageCatalog,a6),a0
                sub.l   a1,a1
                move.l  (ptl_LocaleBase,a6),a6
                jsr     (_LVOGetCatalogStr,a6)
                tst.l   d0
                bne.b   .exit

                move.l  d2,d0
.UseInternCat   lea     (AppStrings,PC),a0
...             cmp.l   (as_ID,a0),d0
                bcs.b   .ErrorExit              ; Wenn kleiner als
                beq.b   .FoundString
                addq.w  #AppString_SIZEOF,a0
                bra.b   ...

.ErrorExit      moveq   #0,d0
                bra.b   .exit

.FoundString    add.w   (as_Str,a0),a0
                addq.w  #4,a0
                move.l  a0,d0

.exit           POPM
                rts


_PrivateHandler:
                ; Ruft anhand eines Parameters eine andere Routine auf.
                ;
                ; Parameter: D7=FunctionNumber
                ; Result   : siehe Unterroutine
                ; Kommentar: 0 = DecodeData()

                cmp.l   #MAX_PRIVATE+1,d7       ; falschen Nummern
                bpl.b   .exit                   ; vorbeugen

                clr.l   -(SP)
                movem.l d7/a0,-(SP)
                lea     (.Table,PC),a0
                add.l   d7,d7
                add.l   d7,a0
                add.w   (a0),a0                 ; relative Adressierung
                move.l  a0,(4*2,SP)
                movem.l (SP)+,d7/a0             ; Funktion anspringen ohne
.exit           rts                             ; ein Register zu lschen!!

.Table          dc.w    _DecodeData-*


_DecodeData:
                ; Dekodiert einen Datenblock unter Verwendung eines Pass-
                ; wortes.
                ;
                ; Parameter: A0=&EncodedData A1=&Puffer A2=&Password D0=Len
                ; Result   : keins
                ; Kommentar: Die dekodierten Daten sind nur 1/2 so gro,
                ;            der Puffer wird jedoch in voller Lnge ge-
                ;            braucht.

                PUSHM   d1-d3/a0-a5
                move.l  a0,a3
                move.l  a1,a4
                move.l  a2,a5
                move.l  d0,d3

                move.l  d3,d2
                lsr.l   #1,d2
                subq.l  #1,d2
.DecryptLoop    move.w  (a0)+,d0
                move.b  (a2)+,d1
                bne.b   .StillValid
                move.l  a5,a2
.StillValid     lsl.w   #8,d1
                move.b  (a2)+,d1
                bne.b   .StillValid2
                move.l  a5,a2
.StillValid2    sub.w   d1,d0
                eor.w   d1,d0
                move.w  d0,(a1)+
                dbra    d2,.DecryptLoop

                move.l  a4,a0
                move.l  a4,a1
                move.l  d3,d1
                lsr.l   #2,d1
                subq.l  #1,d1
...             movep   (0,a0),d0
                move.w  d0,(a1)+
                addq.w  #4,a0
                dbra    d1,...

                POPM
                rts


;***************************************************************************
;*                                                                         *
;* SEKTION: ffentliche Library-Funktionen                                 *
;*                                                                         *
;***************************************************************************

;-------------------------------- SpeicherHandling ------------------------
_PTAllocRemember:
                ; Reserviert einen Speicherbereich und verkettet ihn mit
                ; eventuell vorher reservierten Blcken in einer Liste
                ;
                ; Parameter: A0=&RememberKey D0=Size D1=Flags
                ; Result   : D0=Address / NULL
                ; Kommentar: siehe <exec/memory.i>
                ;            Zwei Tasks drfen sich nie einen Remember-Key
                ;            teilen!!!

                PUSHM   d2/a2/a6
                move.l  a0,a2

                addq.l  #ptml_SIZEOF,d0
                move.l  d0,d2
                move.l  (ptl_SysBase,a6),a6             ; Speicher anfor-
                jsr     (_LVOAllocMem,a6)               ; dern und testen ob
                tst.l   d0                              ; erfolgreich
                beq.b   .exit

                move.l  d0,a1                           ; Block fr Verkett-
                clr.l   (ptml_NextBlock,a1)             ; ung vorbereiten
                move.l  d2,(ptml_Size,a1)

...             tst.l   (ptml_NextBlock,a2)             ; letzten Eintrag in
                beq.b   .FoundLastEntry                 ; der Memoryliste
                move.l  (ptml_NextBlock,a2),a2          ; suchen
                bra.b   ...
.FoundLastEntry move.l  a1,(a2)                         ; Block anfgen

                lea     (ptml_SIZEOF,a1),a1             ; Header berspringen
                move.l  a1,d0                           ; und die Adresse
                                                        ; zurckgeben
.exit           POPM
                rts


_PTFreeRemember:
                ; Gibt anhand eines RememberKeys eine Speicherliste frei
                ;
                ; Parameter: A0=&RememberKey
                ; Result   : keins
                ; Kommentar: Zwei Tasks drfen sich nie einen Remember-Key
                ;            teilen!!!

                PUSHM   a2/a6
                move.l  a0,a2
                move.l  (ptl_SysBase,a6),a6
                tst.l   (a2)
                beq.b   .exit
                move.l  (ptml_NextBlock,a2),a0
                clr.l   (a2)
                move.l  a0,a2

...             cmp.l   #0,a2
                beq.b   .exit
                move.l  a2,a1
                move.l  (ptml_Size,a2),d0
                move.l  (ptml_NextBlock,a2),a2
                jsr     (_LVOFreeMem,a6)
                bra.b   ...

.exit           POPM
                rts


_PTFreeOneBlock:
                ; Gibt einen einzelnen Speicherblock frei und entfernt ihn
                ; aus der Remember-Liste.
                ;
                ; Parameter: A0=&RememberKey A1=&Address
                ; Result   : keins
                ; Kommentar: Zwei Tasks drfen sich nie einen Remember-Key
                ;            teilen!!!

                pea     (a6)
                lea     (-(ptml_SIZEOF),a1),a1

...             tst.l   (ptml_NextBlock,a0)
                beq.b   .exit
                cmp.l   (ptml_NextBlock,a0),a1
                beq.b   .FoundBlock
                move.l  (ptml_NextBlock,a0),a0
                bra.b   ...

.FoundBlock     move.l  (ptml_NextBlock,a1),(ptml_NextBlock,a0)

                move.l  (ptml_Size,a1),d0
                move.l  (ptl_SysBase,a6),a6
                jsr     (_LVOFreeMem,a6)

.exit           move.l  (SP)+,a6
                rts



;----------------------------- Prfsummen-Berechnung ----------------------
_CRC32File:
                ; Berechnet eine 32-Bit-CRC ber ein File
                ;
                ; Parameter: A0=&Filename
                ; Result   : D0.L=CRC oder (-1L)
                ; Kommentar: Bentigt mindestens OS V2.04!!!!

                bsr     _Check204_1

                PUSHM   d2/a2/a6
                bsr     _LoadFile
                tst.l   d0
                beq.b   .Error
                move.l  d0,a2
                move.l  a2,a0
                move.l  (a0)+,d0
                bsr.b   _CRC32
                move.l  d0,d2
                move.l  a2,a1
                move.l  (ptl_SysBase,a6),a6
                jsr     (_LVOFreeVec,a6)
                move.l  d2,d0
.exit           POPM
                rts

.Error          moveq   #-1,d0
                bra.b   .exit


_CRC32:
                ; Berechnet eine 32-Bit-CRC ber einen Speicherblock
                ;
                ; Parameter: A0=&Buffer D0=Length
                ; Result   : D0.L=CRC / NULL (FAILURE)

                PUSHM   d2-d7

                move.l  d0,d2
                bsr.b   .GetCRC32Table
                tst.l   d0
                beq.b   .exit
                move.l  d0,a1
                move.l  d2,d0

                moveq   #0,d1                   ; Initial CRC
                moveq   #8,d7                   ; shiftwert fuer lsr.l

                tst.l   d0                      ; laenge==0 ?
                beq.b   .fini                   ; wenn ja -> abgang!

.loop:          moveq   #0,d2
                move.b  d1,d2
                move.b  (a0)+,d3
                eor.b   d3,d2
                add.l   d2,d2
                add.l   d2,d2
                move.l  (a1,d2.w),d2
                lsr.l   d7,d1
                eor.l   d2,d1
                subq.l  #1,d0
                bne.b   .loop

.fini           move.l  d1,d0                   ; ab ins richtige registrer
.exit           POPM
                rts


.GetCRC32Table:
                PUSHM   d1-d7/a0-a2/a6
                lea     (ptl_CRC32Table,a6),a2
                move.l  (ptl_SysBase,a6),a6
                jsr     (_LVOForbid,a6)

                move.l  (a2),d0                 ; besteht die Tabelle schon?
                bne.b   .finished

                move.l  #256*4,d0
                moveq   #0,d1                   ; Speicher reservieren und
                jsr     (_LVOAllocMem,a6)       ; die Adresse in der Lib-
                move.l  d0,(a2)                 ; Base eintragen
                beq.b   .finished
                move.l  d0,a0

                move.w  #256-1,d7               ; 256 werte (2 werte pro loop)
                move.l  #CRC32POLY,d5           ; die magische nummer
                moveq   #1,d4                   ; shiftwert fuer lsr.l
                                                ; und addwert fuer die CRC
                moveq   #0,d0
.Loop1:
                moveq   #8-1,d6                 ; 8 durchlaeufe
                move.l  d0,d1
                move.l  d0,d2
.Loop2:         lsr.l   d4,d1                   ; shiften
                bcc.b   .l1                     ; wenn Bit0==1 dann
                eor.l   d5,d1                   ; eor CRC32POLY
.l1:            dbra    d6,.Loop2               ; und das ganze 8 mal

                move.l  d1,(a0)+
                add.w   d4,d0
                dbra    d7,.Loop1

                move.l  (a2),d0                 ; Tabellenadresse wieder
.finished       jsr     (_LVOPermit,a6)         ; laden
                POPM
                rts



_CRC16File:
                ; Berechnet eine 16-Bit-CRC ber ein File
                ;
                ; Parameter: A0=&Filename
                ; Result   : D0.W=CRC oder (-1L)
                ; Kommentar: Bentigt mindestens OS V2.04!!!!

                bsr     _Check204_1

                PUSHM   d2/a2/a6
                bsr     _LoadFile
                tst.l   d0
                beq.b   .Error
                move.l  d0,a2
                move.l  a2,a0
                move.l  (a0)+,d0
                bsr.b   _CRC16
                move.l  d0,d2
                move.l  a2,a1
                move.l  (ptl_SysBase,a6),a6
                jsr     (_LVOFreeVec,a6)
                move.l  d2,d0
.exit           POPM
                rts

.Error          moveq   #-1,d0
                bra.b   .exit



_CRC16:
                ; Berechnet eine 16-Bit-CRC ber einen Speicherblock
                ;
                ; Parameter: A0=&String D0=Length
                ; Result   : D0.W=CRC

                PUSHM   d2-d3
                moveq   #0,d2
                moveq   #0,d3
                tst.l   d0
                bmi.b   .exit

...             moveq   #0,d1
                move.b  (a0)+,d1
                move.w  d1,d3
                eor.w   d2,d3
                and.w   #$f,d3
                mulu    #$1081,d3
                lsr.w   #4,d2
                eor.w   d3,d2
                lsr.w   #4,d1
                eor.w   d2,d1
                and.w   #$f,d1
                mulu    #$1081,d1
                lsr.w   #4,d2
                eor.w   d1,d2
                subq.l  #1,d0
                bne.b   ...

.exit           move.l  d2,d0
                POPM
                rts


;------------------------------ Bildschirmausgaben ------------------------
_PrintF:
                ; Formatiert einen String und gibt ihn auf ein FileHandle
                ; aus.
                ;
                ; Parameter: A0=&String A1=&DataFlow D0=FileHandle
                ; Result   : D0=TRUE/FALSE

                PUSHM   d2-d5/a0-a3/a5-a6
                link.w  a4,#-258                ; Speicher reservieren
                move.l  a6,a5
                move.l  d0,d2                   ; Das bergebene Handle
                                                ; retten
                lea     (.PutProc,PC),a2
                lea     (-258,a4),a3
                clr.w   (a3)
                move.l  (ptl_SysBase,a5),a6
                movem.l a0-a3,-(SP)
                jsr     (_LVORawDoFmt,a6)
                cmp.w   #255,(a3)
                bpl.b   .BufferVersion
                add.w   #16,SP

                move.l  (ptl_DOSBase,a5),a6
                move.w  (a3)+,d0
                subq.w  #1,d0
                and.l   #$0000FFFF,d0
                beq.b   .exit
                move.l  d0,d3
                move.l  d2,d0
                bne.b   .SkipOutput
                jsr     (_LVOOutput,a6)
.SkipOutput     move.l  d0,d1
                beq.b   .exit
                lea     (-258+2,a4),a0
                move.l  a0,d2
                jsr     (_LVOWrite,a6)
                moveq   #-1,d0
.exit           unlk    a4
                POPM
                rts

.PutProc        move.w  d1,-(SP)
                move.w  (a3),d1
                cmp.w   #255,d1
                bmi.b   .WriteOkay
                bra.b   .SkipChar
.WriteOkay      move.b  d0,(2,a3,d1.w)
.SkipChar       addq.w  #1,(a3)
                move.w  (SP)+,d1
                rts

.BufferVersion  moveq   #0,d0
                move.w  (a3),d0
                addq.l  #1,d0
                move.l  d0,d5
                moveq   #MEMF_ANY,d1
                jsr     (_LVOAllocMem,a6)
                tst.l   d0
                beq.b   .exit
                movem.l (SP)+,a0-a3
                move.l  d0,a3
                lea     (.PutProc2,PC),a2
                jsr     (_LVORawDoFmt,a6)

                move.l  (ptl_DOSBase,a5),a6
                move.l  a3,a0
                bsr     _Len
                move.l  d0,d3
                move.l  d2,d0
                bne.b   .SkipOutput2
                jsr     (_LVOOutput,a6)
.SkipOutput2    move.l  d0,d1
                beq.b   .FreeMem
                move.l  a3,d2
                jsr     (_LVOWrite,a6)
                move.l  a3,a1
                move.l  d5,d0
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOFreeMem,a6)
                moveq   #-1,d0
                bra.b   .exit

.FreeMem        move.l  a3,a1
                move.l  d5,d0
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOFreeMem,a6)
                moveq   #0,d0
                bra.b   .exit

.PutProc2       move.b  d0,(a3)+
                rts


_PrintFSimple:
                ; Formatiert einen String und gibt ihn auf auf das von
                ; Output zurckgegebene FileHandle aus.
                ;
                ; Parameter: A0=&String A1=&DataFlow
                ; Result   : D0=TRUE/FALSE

                moveq   #0,d0
                bra     _PrintF

;----------------------------- Config-File-Routinen -----------------------
_InterpretConfigFile:
                ; Ldt ein Konfigfile und interpretiert die KEYWORDS
                ;
                ; Parameter: A0=&Filename A1=&Taglist A2=&Array
                ; Result   : D0=&Buffer oder NULL
                ; Kommentar: Die Routine bentigt OS V2.04+
                ;            Der Buffer mu mit FreeVec() freigegeben werden

                bsr     _Check204_0

                PUSHM   d2/a0-a2
                bsr     _LoadFile
                tst.l   d0
                beq.b   .exit
                movem.l (SP),saveregs
                move.l  d0,d2
                move.l  d0,a0
                addq.w  #4,a0
                bsr.b   _InterpretConfigBuffer
                move.l  d2,d0
.exit           POPM
                rts

_InterpretConfigFileRemember:
                ; Ldt ein Konfigfile und interpretiert die KEYWORDS
                ;
                ; Parameter: A0=&Filename A1=&Taglist A2=&Array
                ;            A3=RememberKey
                ; Result   : D0=&Buffer oder NULL
                ; Kommentar: Die Routine bentigt OS V2.04+

                bsr     _Check204_0

                PUSHM   d2/a0-a3
                move.l  a3,a1
                bsr     _LoadFileRemember
                tst.l   d0
                beq.b   .exit
                movem.l (SP),saveregs
                move.l  d0,d2
                move.l  d0,a0
                addq.w  #4,a0
                bsr.b   _InterpretConfigBuffer
                move.l  d2,d0
.exit           POPM
                rts


_InterpretConfigBuffer:
                ; Interpretiert die KEYWORDS eines Konfigfiles in einem
                ; Textpuffer
                ;
                ; Parameter: A0=&Buffer A1=&Taglist A2=&Array
                ; Result   : keins
                ; Kommentar: Bentigt mindestens OS V2.04!!!!

                bsr     _Check204_0

                PUSHM   d2/a0-a6

                move.l  a2,a4
                move.l  a1,a3
                move.l  a0,a2
                move.l  a0,a5

;------------- Keywords im Text finden und speichern ------
.TaglistLoop    cmp.l   #TAG_DONE,(a3)
                beq.b   .AllKeywordsFound
                move.l  a2,a0
...             move.l  (4,a3),a1
                bsr     _ICFind
                tst.l   d0
                beq.b   .KeywordNotValid
                move.l  d0,a1
                cmp.l   a5,d0
                beq.b   .KeyWordValid1
                cmp.b   #$0A,(-1,a1)
                beq.b   .KeyWordValid1          ; ein eventuell folgendes
                lea     (1,a1),a0               ; KEYWORD finden, das gltig
                bra.b   ...                     ; ist
.KeyWordValid1  move.l  (4,a3),a0
                bsr     _Len
                cmp.b   #' ',(a1,d0.l)
                beq.b   .KeywordValid
                cmp.b   #$0A,(a1,d0.l)
                beq.b   .KeywordValid
                cmp.b   #$09,(a1,d0.l)
                beq.b   .KeywordValid
                tst.b   (a1,d0.l)
                bne.b   .KeywordNotValid
.KeywordValid   lea     (a1,d0.l),a1
...             cmp.b   #' ',(a1)+              ; Spaces skippen
                beq.b   ...
                cmp.b   #$09,(-1,a1)            ; Tabs skippen
                beq.b   ...
                subq.w  #1,a1
                move.l  a1,(a4)+
                bra.b   .GoOnLoop
.KeywordNotValid:
                clr.l   (a4)+
.GoOnLoop       addq.w  #8,a3
                bra.b   .TaglistLoop


;------------- Die gespeicherten Keywords analysieren -----
.AllKeywordsFound:
                movem.l (SP),saveregs
                move.l  a6,a5
                move.l  a2,a4
                move.l  a1,a3

.TagListLoop2   cmp.l   #TAG_DONE,(a3)
                beq.b   .exit
                tst.l   (a4)
                beq.b   .AnalyseLoopEnd

                cmp.l   #IC_String,(a3)
                bne.b   .NoString
                move.l  (a4),a0
                bsr.b   .FindEOK
                clr.b   (a0)
                bra.b   .AnalyseLoopEnd

.NoString       cmp.l   #IC_Number,(a3)
                bne.b   .NoNumber
                move.l  (a4),d1
                move.l  a4,d2
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOStrToLong,a6)
                bra.b   .AnalyseLoopEnd

.NoNumber       cmp.l   #IC_YesNo,(a3)
                bne.b   .NotValid
                move.l  (a4),a0
                bsr.b   .FindEOK
                clr.b   (a0)
                move.l  (a4),a0
                bsr     _Len
                lea     (YesString,PC),a1
                bsr     _CmpStrings
                tst.l   d0
                beq.b   .NotYes
                move.l  #-1,(a4)
                bra.b   .AnalyseLoopEnd
.NotYes         clr.l   (a4)                    ; "No" defaults
                bra.b   .AnalyseLoopEnd

.NotValid       clr.l   (a4)
.AnalyseLoopEnd addq.w  #8,a3
                addq.w  #4,a4
                bra.b   .TagListLoop2

.exit           POPM
                rts

.FindEOK        cmp.b   #$0A,(a0)               ; FindEndOfKeyword
                beq.b   .FoundEOL
                tst.b   (a0)
                beq.b   .FoundEOL
                addq.w  #1,a0
                bra.b   .FindEOK
.FoundEOL       cmp.b   #$09,(-1,a0)
                beq.b   .FoundEmpty
                cmp.b   #' ',(-1,a0)
                beq.b   .FoundEmpty
                rts
.FoundEmpty     subq.w  #1,a0
                bra.b   .FoundEOL


_ICFind:
                ; Funktion : Sucht nach einem String in einem Textpuffer
                ;
                ; Parameter: A0=&Buffer A1=&String
                ; Result   : D0=Adresse des Strings oder NULL
                ; Kommentar: Die Routine ist speziell fr das Suchen von
                ;            Keywords geschrieben. Sie ueberspringt bei-
                ;            spielsweise automatisch alle Zeilen, die mit
                ;            einem '#' beginnen. Ausserdem wird die Zeile
                ;            abgebrochen, sobald ein ';' auftaucht.

                PUSHM   d2/a2-a3
                move.l  a0,a3
                move.l  a1,a2
                move.l  a1,a0
                bsr     _Len
                move.l  d0,d2
                beq.b   .exit

                moveq   #0,d0
                bsr.b   .LineBeginValid
.FindLoop       tst.b   (a3)
                beq.b   .exit
                cmp.b   #$0A,(a3)
                bne.b   .NoEndOfLine
                bsr.b   .FindEndOfLine
                bsr.b   .LineBeginValid
.NoEndOfLine    cmp.b   #';',(a3)
                bne.b   .CmpString
                bsr.b   .FindEndOfLine
                bsr.b   .LineBeginValid
                bra.b   .FindLoop
.CmpString      move.l  a2,a0
                move.l  a3,a1
                move.l  d2,d0
                bsr     _CmpStrings
                tst.l   d0
                bne.b   .FoundString
                addq.w  #1,a3
                bra.b   .FindLoop
.FoundString    move.l  a3,d0
.exit           POPM
                rts

.FindEndOfLine  cmp.b   #$0A,(a3)
                beq.b   .FoundEOL
                tst.b   (a3)+
                bne.b   .FindEndOfLine
                subq.w  #1,a3
                rts
.FoundEOL       addq.w  #1,a3
                rts

.LineBeginValid cmp.b   #'#',(a3)
                bne.b   .LBVExit
                bsr.b   .FindEndOfLine
                tst.b   (a3)
                beq.b   .LBVExit
                bra.b   .LineBeginValid
.LBVExit        rts


;------------------------------- Disketten-IO -----------------------------
_GetFileSize:
                ; Ermittelt die Lnge eines Files
                ;
                ; Parameter: A0=&Filename
                ; Result   : D0=FileLength / Error (-1)

                PUSHM   d2-d4/a5-a6

                move.l  a0,d1
                move.l  #ACCESS_READ,d2
                move.l  (ptl_DOSBase,a6),a5
                exg.l   a5,a6
                jsr     (_LVOLock,a6)           ; Lock auf das File holen
                move.l  d0,d3
                beq.b   .ErrorExit

                move.l  #fib_SIZEOF,d0
                moveq   #MEMF_ANY,d1
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOAllocMem,a6)       ; Speicher fr FileInfoBuffer
                move.l  d0,d4                   ; anfordern
                beq.b   .ErrorUnlock

                move.l  d3,d1
                move.l  d4,d2
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOExamine,a6)        ; FileInfoBuffer holen
                tst.l   d0
                beq.b   .ErrorFreeVec

                move.l  d4,a1
                move.l  (fib_Size,a1),d4        ; Filelnge holen und

                move.l  (ptl_SysBase,a5),a6     ; FileInfoBuffer wieder
                move.l  #fib_SIZEOF,d0          ; freigeben
                jsr     (_LVOFreeMem,a6)

                move.l  d3,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOUnLock,a6)

                move.l  d4,d0
.exit           POPM
                rts

.ErrorFreeVec   move.l  d4,a1
                move.l  #fib_SIZEOF,d0
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOFreeMem,a6)
.ErrorUnlock    move.l  d3,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOUnLock,a6)
.ErrorExit      moveq   #-1,d0
                bra.b   .exit


_LoadBreak:
                ; Ldt einen Block in kleinen Teilen und testet
                ; zwischendurch nach CTRL+C
                ;
                ; Parameter: D1=FileHandle D2=&Puffer D3=Length
                ; Result   : D0=Readlength / Error (-1)
                ; Kommentar: Bentigt mindestens OS V2.04!!!!

                bsr     _Check204_1

                PUSHM   d2-d6/a6
                move.l  (ptl_DOSBase,a6),a6
                move.l  d1,d4                   ; Register retten
                move.l  d3,d5
                moveq   #0,d6

                divu    #BLOCK_LEN,d5           ; Anzahl der Ladevor-
                tst.w   d5                      ; gnge berechnen
                beq.b   .LoadRest               ; Bei zu kleinen Gren
                subq.w  #1,d5                   ; $FFFF-Schleife abfangen
                move.l  #BLOCK_LEN,d3

...             move.l  d4,d1                   ; Blockweise lesen
                jsr     (_LVORead,a6)
                tst.l   d0
                beq.b   .SkipLoad
                cmp.l   #-1,d0
                beq.b   .Error
                add.l   d0,d6
                move.l  #SIGBREAKF_CTRL_C,d1
                jsr     (_LVOCheckSignal,a6)
                tst.l   d0
                bne.b   .Break
                add.l   #BLOCK_LEN,d2
                dbra    d5,...

.LoadRest       clr.w   d5                      ; Rest noch laden
                swap    d5
                move.l  d5,d3
                beq.b   .SkipLoad               ; Wenn Rest gleich Null
                move.l  d4,d1                   ; berspringen
                jsr     (_LVORead,a6)
                tst.l   d0
                beq.b   .SkipLoad
                cmp.l   #-1,d0
                beq.b   .Error
                add.l   d0,d6

.SkipLoad       move.l  d6,d0
.exit           POPM
                rts

.Break          moveq   #0,d1
                jsr     (_LVOSetIoErr,a6)
.Error          moveq   #-1,d0                  ; Laden wurde unterbrochen
                bra.b   .exit



_SaveBreak:
                ; Speichert einen Block ab in kleinen Teilen ab, und testet
                ; zwischendurch nach CTRL+C
                ;
                ; Parameter: D1=FileHandle D2=&Puffer D3=Length
                ; Result   : D0=WriteLength/Error (-1)
                ; Kommentar: Bentigt mindestens OS V2.04!!!!

                bsr     _Check204_1

                PUSHM   d2-d6/a6
                move.l  (ptl_DOSBase,a6),a6
                move.l  d1,d4                   ; Register retten
                move.l  d3,d5
                moveq   #0,d6

                divu    #BLOCK_LEN,d5           ; Anzahl der Speichervor-
                tst.w   d5                      ; gnge berechnen
                beq.b   .SaveRest               ; Bei zu kleinen Gren
                subq.w  #1,d5                   ; $FFFF-Schleife abfangen
                move.l  #BLOCK_LEN,d3

...             move.l  d4,d1                   ; Blockweise schreiben
                jsr     (_LVOWrite,a6)
                cmp.l   #-1,d0
                beq.b   .Error
                add.l   d0,d6
                move.l  #SIGBREAKF_CTRL_C,d1
                jsr     (_LVOCheckSignal,a6)
                tst.l   d0
                bne.b   .Break
                add.l   #BLOCK_LEN,d2
                dbra    d5,...

.SaveRest       clr.w   d5                      ; Rest noch auf Diskette
                swap    d5                      ; bringen
                move.l  d5,d3
                beq.b   .SkipSave               ; Wenn Rest gleich Null
                move.l  d4,d1                   ; berspringen
                jsr     (_LVOWrite,a6)
                cmp.l   #-1,d0
                beq.b   .Error
                add.l   d0,d6

.SkipSave       move.l  d6,d0
.exit           POPM
                rts

.Break          moveq   #0,d1
                jsr     (_LVOSetIoErr,a6)
.Error          moveq   #-1,d0                  ; Speichern wurde unter-
                bra.b   .exit                   ; brochen


_LoadFile:
                ; Reserviert einen Buffer und ldt ein File hinein
                ;
                ; Parameter: A0=&Filename
                ; Result   : D0=&Bufferaddress / Error
                ; Kommentar: Die Routine bentigt OS V2.04+
                ;            Der Puffer wird mit AllocVec() reserviert,
                ;            kann also einfach mit FreeVec() wieder freige-
                ;            geben werden.
                ;            Im Puffer steht erst ein Longword mit der File-
                ;            lnge, danach der eigentlich Fileinhalt.
                ;            Sollte ein Fehler auftreten, kann mir IoErr()
                ;            die Fehlernummer abgefragt werden.

                bsr     _Check204_0

                PUSHM   d2-d4/a4-a6

                move.l  a0,d1
                move.l  #ACCESS_READ,d2
                move.l  (ptl_DOSBase,a6),a5
                exg.l   a5,a6
                jsr     (_LVOLock,a6)           ; Lock auf das File holen
                move.l  d0,d3
                beq.b   .exit

                move.l  #fib_SIZEOF,d0
                moveq   #MEMF_ANY,d1
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOAllocVec,a6)       ; Speicher fr FileInfoBuffer
                move.l  d0,d4                   ; anfordern
                beq.b   .ErrorUnlock

                move.l  d3,d1
                move.l  d4,d2
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOExamine,a6)        ; FileInfoBuffer holen
                tst.l   d0
                beq.b   .ErrorFreeVec

                move.l  d4,a1
                move.l  (fib_Size,a1),d4        ; Filelnge holen und
                beq.b   .ErrorFreeVec           ; FileInfoBuffer wieder
                move.l  (ptl_SysBase,a5),a6     ; freigeben
                jsr     (_LVOFreeVec,a6)

                move.l  d4,d0
                addq.l  #5,d0
                moveq   #MEMF_ANY,d1
                jsr     (_LVOAllocVec,a6)       ; Speicher fr FileInfoBuffer
                tst.l   d0
                beq.b   .ErrorUnlock

                move.l  d0,a4
                move.l  d4,(a4)                 ; Filelnge in den Puffer
                move.l  a4,d4                   ; schreiben

                move.l  d3,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOOpenFromLock,a6)   ; File zum Lesen ffnen
                tst.l   d0
                beq.b   .ErrorFreeVec
                move.l  d0,d4

                move.l  d4,d1
                move.l  a4,d2
                addq.l  #4,d2
                move.l  (a4),d3                 ; File in den Puffer laden
                jsr     (_LVORead,a6)
                cmp.l   #-1,d0
                beq.b   .ErrorClose

                move.l  d4,d1
                jsr     (_LVOClose,a6)          ; File schlieen

                move.l  (a4),d0
                clr.b   (4,a4,d0.l)             ; Nullbyte anhngen

                move.l  a4,d0
.exit           POPM
                rts

.ErrorFreeVec   move.l  d4,a1
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOFreeVec,a6)
.ErrorUnlock    move.l  d3,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOUnLock,a6)
                moveq   #0,d0
                bra.b   .exit

.ErrorClose     move.l  a4,a1
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVOFreeVec,a6)
                move.l  d4,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOClose,a6)
                moveq   #0,d0
                bra.b   .exit


_LoadFileRemember:
                ; Reserviert einen Buffer mit den PTAllocRemember-Funktionen
                ; und ldt ein File hinein.
                ;
                ; Parameter: A0=&Filename A1=&RememberKey
                ; Result   : D0=&Bufferaddress / Error
                ; Kommentar: Der Puffer kann einfach mit PTFreeRemember()
                ;            wieder freigegeben werden.
                ;            Im Puffer steht erst ein Longword mit der File-
                ;            lnge, danach der eigentlich Fileinhalt.
                ;            Sollte ein Fehler auftreten, kann mir IoErr()
                ;            die Fehlernummer abgefragt werden.

                PUSHM   d2-d4/a3-a6
                move.l  a1,a3

                move.l  a0,d1
                move.l  #ACCESS_READ,d2
                move.l  (ptl_DOSBase,a6),a5
                exg.l   a5,a6
                jsr     (_LVOLock,a6)           ; Lock auf das File holen
                move.l  d0,d3
                beq.b   .exit

                move.l  a3,a0
                move.l  #fib_SIZEOF,d0
                moveq   #MEMF_ANY,d1
                move.l  a5,a6
                jsr     (_LVOPTAllocRemember,a6) ; Speicher fr FileInfoBuf-
                move.l  d0,d4                    ; fer anfordern
                beq.b   .ErrorUnlock

                move.l  d3,d1
                move.l  d4,d2
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOExamine,a6)        ; FileInfoBuffer holen
                tst.l   d0
                beq.b   .ErrorFree

                move.l  d4,a1
                move.l  (fib_Size,a1),d4        ; Filelnge holen und
                beq.b   .ErrorFree              ; FileInfoBuffer wieder
                move.l  a5,a6                   ; freigeben
                move.l  a3,a0
                jsr     (_LVOPTFreeOneBlock,a6)

                move.l  a3,a0
                move.l  d4,d0
                addq.l  #5,d0
                moveq   #MEMF_ANY,d1
                jsr     (_LVOPTAllocRemember,a6) ; Speicher fr FileInfo-
                tst.l   d0                       ; Buffer
                beq.b   .ErrorUnlock

                move.l  d0,a4
                move.l  d4,(a4)                 ; Filelnge in den Puffer
                move.l  a4,d4                   ; schreiben

                move.l  d3,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOOpenFromLock,a6)   ; File zum Lesen ffnen
                tst.l   d0
                beq.b   .ErrorFree
                move.l  d0,d4

                move.l  d4,d1
                move.l  a4,d2
                addq.l  #4,d2
                move.l  (a4),d3                 ; File in den Puffer laden
                jsr     (_LVORead,a6)
                cmp.l   #-1,d0
                beq.b   .ErrorClose

                move.l  d4,d1
                jsr     (_LVOClose,a6)          ; File schlieen

                move.l  (a4),d0
                clr.b   (4,a4,d0.l)             ; Nullbyte anhngen

                move.l  a4,d0
.exit           POPM
                rts

.ErrorFree      move.l  a3,a0
                move.l  d4,a1
                move.l  a5,a6
                jsr     (_LVOPTFreeOneBlock,a6)
.ErrorUnlock    move.l  d3,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOUnLock,a6)
                moveq   #0,d0
                bra.b   .exit

.ErrorClose     move.l  a3,a0
                move.l  a4,a1
                move.l  a5,a6
                jsr     (_LVOPTFreeOneBlock,a6)
                move.l  d4,d1
                move.l  (ptl_DOSBase,a5),a6
                jsr     (_LVOClose,a6)
                moveq   #0,d0
                bra.b   .exit


;------------------------------- Stack-Routinen ---------------------------
_GetStackSize:
                ; Gibt die Gre des aktuellen Stacks in Byte zurck
                ;
                ; Parameter: keine
                ; Result   : D0=StackSize

                pea     (a6)
                move.l  (ptl_SysBase,a6),a6
                sub.l   a1,a1
                jsr     (_LVOFindTask,a6)
                move.l  d0,a0
                tst.l   (pr_TaskNum,a0)
                beq.b   .NoCLIProc
                move.l  (pr_CLI,a0),a0
                add.l   a0,a0
                add.l   a0,a0
                move.l  (cli_DefaultStack,a0),d0
                add.l   d0,d0
                add.l   d0,d0
                bra.b   .exit
.NoCLIProc      move.l  (pr_StackSize,a0),d0
.exit           move.l  (SP)+,a6
                rts


_AllocNewStack:
                ; Diese Routine reserviert einen neuen Stack und trgt ihn
                ; in die Taskstruktur ein.
                ;
                ; Parameter: D0=Stacksize  A0=StackDataBuffer (3 LWords)
                ; Result   : Erfolg (-1) oder Error (0)

                movem.l a2/a6,-(SP)

                move.l  a0,a2
                move.l  d0,(1*4,a2)

                move.l  #$00010001,d1           ; MEMF_PUBLIC|MEMF_CLEAR
                move.l  (ptl_SysBase,a6),a6
                jsr     (-$C6,a6)               ; AllocMem()
                move.l  d0,(0*4,a2)             ; new_SPLower
                beq.b   .ErrorExit
                add.l   d0,(1*4,a2)             ; new_SPUpper

                move.l  (1*4,a2),a1
                movem.l (SP)+,d0-d1/a0
                movem.l d0-d1/a0,-(a1)
                move.l  a1,(2*4,a2)             ; new_SPReg

                cmp.w   #37,($14,a6)            ; LIB_VERSION
                bpl.b   .UseOS

                jsr     (-$78,a6)               ; Multitasking verbieten,
                sub.l   a1,a1                   ; damit kein Taskwechsel er-
                jsr     (-$126,a6)              ; folgt bevor wir fertig
                move.l  d0,a1                   ; sind

                move.l  ($3A,a1),d0             ; SPLower mit Eintrag im
                move.l  (0*4,a2),($3A,a1)       ; StackDataBuffer tauschen
                move.l  d0,(0*4,a2)

                move.l  ($3E,a1),d0             ; SPUpper tauschen
                move.l  (1*4,a2),($3E,a1)       ;
                move.l  d0,(1*4,a2)

                move.l  (2*4,a2),d0             ; SPReg ist in der Task-
                move.l  d0,($36,a1)             ; struktur nicht gltig,
                move.l  SP,(2*4,a2)             ; deshalb den SP in den
                                                ; Puffer eintragen

                move.l  d0,SP                   ; Stack tauschen!
                jsr     (-$7E,a6)
                bra.b   .Exit

.UseOS          move.l  a2,a0
                jsr     (-$2DC,a6)              ; StackSwap()

.Exit           moveq   #-1,d0
.ErrorExit      movem.l (SP)+,a2/a6
                rts


_RestoreStack:
                ; Diese Routine restauriert den Systemstack, nachdem mit
                ; mit AllocNewStack() ein Neuer angefordert wurde.
                ;
                ; Parameter: A0=StackDataBuffer
                ; Result   : keins

                move.l  (2*4,a0),a1
                move.l  (SP)+,-(a1)             ; Register und RTS-Adresse
                movem.l a2/a6,-(a1)             ; auf dem Systemstack (!!)
                move.l  a1,(2*4,a0)             ; retten

                move.l  a0,a2
                move.l  (ptl_SysBase,a6),a6

                cmp.w   #37,($14,a6)            ; LIB_VERSION
                bpl.b   .UseOS

                jsr     (-$78,a6)               ; Disable()
                sub.l   a1,a1
                jsr     (-$126,a6)              ; FindTask()
                move.l  d0,a0

                move.l  ($3A,a0),a1             ; SPLower
                move.l  (0*4,a2),($3A,a0)

                move.l  ($3E,a0),d0             ; SPUpper
                move.l  (1*4,a2),($3E,a0)

                move.l  (2*4,a2),($36,a0)       ; SPReg
                move.l  (2*4,a2),SP

                jsr     (-$7E,a6)               ; Enable()
                bra.b   .GoOn

.UseOS          jsr     (-$2DC,a6)              ; StackSwap()

                move.l  (0*4,a2),a1             ; Werte sind nur gltig,
                move.l  (1*4,a2),d0             ; wenn die OS-Routinen zum
.GoOn           sub.l   a1,d0                   ; Tauschen benutzt wurden!
                jsr     (-$D2,a6)               ; FreeMem()

                movem.l (SP)+,a2/a6
                rts


;------------------------------ Fehler-Handling ---------------------------
_GetErrorMsg:
                ; Funktion : Gibt aufgrund einer Fehlernummer einen Errortext
                ;            zurck. Sollte als Fehlernummer eine 0 bergeben
                ;            werden, wird via Fault() der Fehlertext
                ;            ermittelt.
                ;            Der Parameter hngt von der Fehlermeldung ab.
                ;            Manche Fehlermeldungen knnen auch eine Para-
                ;            meterliste verlangen. Diese werden in die
                ;            Fehlermeldung hineinkopiert.
                ;            Der Puffer sollte 256 Zeichen lang sein.
                ;
                ; Parameter: A0=&ProgrammName A1=&Text-Puffer [A2=&Parameter]
                ;            D0=Fehlernummer
                ; Result   : Textlnge oder Null
                ; Kommentar: Fehlernummer 0 bentigt die DOS-Funktionen
                ;            IoErr() und Fault(). Diese sind erst ab OS
                ;            2.04 verfgbar!
                ;            Seit V1.151 lokalisiert!!

                clr.b   (a1)
                tst.l   d0
                bne.b   .No204Needed
                bsr     _Check204_0

.No204Needed    cmp.b   #MAX_ERR_NUMBER+1,d0
                bmi.b   .GetErrorMsg
                moveq   #0,d0
                rts

.GetErrorMsg:
                PUSHM   d1-d4/a0-a6
                move.l  d0,d2
                beq.b   .UseFault
                move.l  a1,a3
                move.l  a2,a4
                move.l  a6,a5

                move.l  a0,d1
                beq.b   .SkipPrgName
                tst.b   (a0)
                beq.b   .SkipPrgName
                bsr     _CopyString
                move.b  #':',(a1)+
                move.b  #' ',(a1)+
.SkipPrgName    pea     (a1)
                bsr     _GetString
                move.l  d0,a0
                move.l  a4,a1
                lea     (.WriteChar,PC),a2
                move.l  (SP)+,a3
                move.l  (ptl_SysBase,a5),a6
                jsr     (_LVORawDoFmt,a6)
                move.l  a3,a0
                bra.b   .finished

.UseFault       move.l  a0,a2
                move.l  a1,a3
                move.l  (ptl_DOSBase,a6),a6
                jsr     (_LVOIoErr,a6)
                move.l  d0,d1
                move.l  a2,d2
                move.l  a3,d3
                move.l  #256,d4
                jsr     (_LVOFault,a6)
                move.l  a3,a0

.finished       bsr     _Len
                POPM
                rts

.WriteChar      move.b  d0,(a3)+
                rts



_ErrorHandleDos:
                ; Funktion : Gibt aufgrund einer Fehlernummer einen Errortext
                ;            auf den Bildschirm aus.
                ;            Enthlt D1 eine Null, wird der Standard-Output
                ;            benutzt.
                ;
                ; Parameter: A0=&ProgrammName A1=&Parameter
                ;            D0=Fehlernummer D1=OutputHan.
                ; Result   : keins
                ; Kommentar: Fehlernummer 0 bentigt die DOS-Funktionen
                ;            IoErr() und Fault(). Diese sind erst ab OS
                ;            2.04 verfgbar!

                PUSHM   d2-d3/a2/a6
                link.w  a5,#-256
                move.l  a1,a2
                lea     (-256,a5),a1
                move.l  d1,-(SP)
                bsr     _GetErrorMsg
                move.l  (SP)+,d1
                tst.l   d0
                beq.b   .exit
                move.l  (ptl_DOSBase,a6),a6
                tst.l   d1
                bne.b   .SkipOutput
                jsr     (_LVOOutput,a6)
                move.l  d0,d1
.SkipOutput     lea     (-256,a5),a0
                bsr     _Len
                move.b  #$0A,(a0,d0.l)
                clr.b   (1,a0,d0.l)
                addq.l  #1,d0
                move.l  a0,d2
                move.l  d0,d3
                jsr     (_LVOWrite,a6)
.exit           unlk    a5
                POPM
                rts


_ErrorHandleIntuition:
                ; Funktion : Erzeugt aufgrund einer Fehlernummer einen
                ;            ErrorRequester.
                ;            Ist der WindowPointer gleich Null, wird der
                ;            Requester auf dem Workbench-Screen dargestellt
                ;
                ; Parameter: A0=&ProgrammName A1=&Parameter A2=&WindowPointer
                ;            D0=Fehlernummer
                ; Result   : keins
                ; Kommentar: Die Routine bentigt mindestens OS 2.04!!
                ;            Seit V1.152 lokalisiert!

                bsr     _Check204_0

                PUSHM   a2-a3/a6

                link.w  a5,#-256
                move.l  a2,a3
                move.l  a1,a2
                lea     (-256,a5),a1
                pea     (a0)
                sub.l   a0,a0
                bsr     _GetErrorMsg
                move.l  (SP)+,a0
                tst.l   d0
                beq.b   .exit

                link.w  a4,#-(EasyStruct_SIZEOF)
                lea     (-(EasyStruct_SIZEOF),a5),a1
                move.l  #EasyStruct_SIZEOF,(es_StructSize,a1)
                clr.l   (es_Flags,a1)
                move.l  a0,(es_Title,a1)
                lea     (-256,a5),a0
                move.l  a0,(es_TextFormat,a1)
                moveq   #MSG_PTL_GOON_GAD,d0
                bsr     _GetString
                move.l  d0,(es_GadgetFormat,a1)
                move.l  a3,a0
                move.l  #0,a2
                move.l  #0,a3
                move.l  (ptl_IntuitionBase,a6),a6
                jsr     (_LVOEasyRequestArgs,a6)
                unlk    a4
.exit           unlk    a5
                POPM
                rts


;------------------------------ CheckConfiguration ------------------------
_CheckConfig:
                ; Funktion : Testet ob bestimmte Systemanforderungen er-
                ;            fllt sind.
                ;
                ; Parameter: D0=Flags  D1.W=OS(Exec)-Version
                ; Result   : D0=Nicht-erfllte Flags
                ; Kommentar: fr eine Liste der Flags siehe
                ;            <PToolLibrary.i>
                ;            CheckConfig() rettet D1.w!!

                move.l  d1,-(SP)

                and.l   #CC_MAXCONFIG,d0
                beq.b   .finished

                btst.l  #CCB_OS_VERSION,d0
                beq.b   .NoOSTest
                subq.w  #1,d1
                move.l  (ptl_SysBase,a6),a0
                cmp.w   (LIB_VERSION,a0),d1
                bpl.b   .NoOSTest               ; Test failed
                and.l   #($FFFFFFFF^CCF_OS_VERSION),d0

.NoOSTest       moveq   #CCB_FPU40,d1
...             btst.l  d1,d0
                bne.b   .CheckBit
.GoOn           subq.l  #1,d1
                bpl.b   ...
                bra.b   .finished

.CheckBit       btst.b  d1,(AttnFlags+1,a0)
                beq.b   .GoOn
                bclr.l  d1,d0
                bra.b   .GoOn

.finished       move.l  (SP)+,d1
                rts


_DisplayConfigErrorDos:
                ; Funktion : Gibt die zu CheckConfig() gehrenden Fehler-
                ;            meldungen aus
                ;
                ; Parameter: A0=&ProgrammName D0=Flags D1.w=OS-Version
                ;            D2=OutputHandle
                ; Result   : keins

                tst.l   d0
                beq     .finished

                move.l  d3,-(SP)
                move.l  d0,d3

                link.w  a5,#-8

                movem.l d0-d2/a0/a6,-(SP)

                btst.l  #CCB_OS_VERSION,d3
                beq.b   .NoOSError

                moveq   #MSG_OSERROR,d0
                bsr     _GetString
                move.l  d0,a0
                lea     (-8,a5),a1
                move.w  d1,(a1)
                lea     (.WriteChar,PC),a2
                link.w  a4,#-30
                lea     (-30,a4),a3
                move.l  (ptl_SysBase,a6),a6
                jsr     (_LVORawDoFmt,a6)

                movem.l (34,SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                lea     (-30,a4),a0
                move.l  a0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos
                unlk    a4

.NoOSError      btst.l  #CCB_68010,d3
                beq.b   .No68010Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NO68010ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos

.No68010Error   btst.l  #CCB_68020,d3
                beq.b   .No68020Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NO68020ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos


.No68020Error   btst.l  #CCB_68030,d3
                beq.b   .No68030Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NO68030ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos

.No68030Error   btst.l  #CCB_68040,d3
                beq.b   .No68040Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NO68040ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos

.No68040Error   btst.l  #CCB_68881,d3
                beq.b   .No68881Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NO68881ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos

.No68881Error   btst.l  #CCB_68882,d3
                beq.b   .No68882Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NO68882ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos

.No68882Error   btst.l  #CCB_FPU40,d3
                beq.b   .NoFPU40Error
                movem.l (SP),d0-d2/a0/a6
                move.l  d2,d1
                lea     (-8,a5),a1
                move.l  a0,(0,a1)
                moveq   #MSG_NOFPU40ERROR,d0
                bsr     _GetString
                move.l  d0,(4,a1)
                moveq   #MSG_FATAL_ERROR,d0
                bsr     _GetString
                move.l  d0,a0
                moveq   #3,d0
                bsr     _ErrorHandleDos

.NoFPU40Error  ;nop

                movem.l (SP)+,d0-d2/a0/a6
                unlk    a5
                move.l (SP)+,d3
.finished       rts

.WriteChar      move.b  d0,(a3)+
                rts

;------------------------------ Suchen und Ersetzen -----------------------
_Find:
                ; Funktion : sucht einen String in einem Textpuffer
                ;
                ; Parameter: A0=&Textpuffer A1=&String D0=StringLnge
                ; Result   : D0=Adresse der Textstelle oder NULL
                ; Kommentar: Wird als Stringlnge eine Null bergeben, wird
                ;            die Lnges des Strings selbst ermittelt. Der
                ;            Haupttext mu mit einem Null-Byte abgeschlossen
                ;            sein.

                PUSHM   d1-d2/a0-a2
                tst.l   d0
                beq.b   .CalcLength
.GotLength      move.l  d0,d2
                lea     (CmpTab,PC),a2
.continue       moveq   #0,d1
                move.b  (a1),d1
                move.b  (a2,d1.w),d1            ; search for first character
.loop           move.b  (a0)+,d0                ; of search-string
                beq.b   .exit
                move.b  (a2,d0.w),d0            ; Break when NULL is reached
                cmp.b   d0,d1
                bne.b   .loop

                subq.w  #1,a0
                move.l  d2,d0
                bsr.b   _CmpStrings             ; test if whole string is
                tst.l   d0                      ; found
                bne.b   .GotIt                  ; GotIt-> move address to D0
                addq.w  #1,a0
                bra.b   .continue               ; continue search

.exit           sub.l   a0,a0                   ; didn`t find anything
.GotIt          move.l  a0,d0
                POPM
                rts

.CalcLength     exg.l   a0,a1
                bsr     _Len                    ; Calculate length of
                move.l  d0,d2                   ; search-string for
                exg.l   a0,a1                   ; _CmpStrings
                bra.b   .GotLength


_Replace:
                ; Funktion : sucht einen String in einem Textpuffer und er-
                ;            setzt ihn durch einen anderen
                ;
                ; Parameter: A0=&Textpuffer A1=&Zielpuffer A2=&Such-String
                ;            A3=&Ersatzstring D0=ZielPuffer-Gre
                ;            D1=Such-StringLnge
                ;
                ; Result   : D0=Wie oft gefunden und ersetzt
                ; Kommentar: Wird als Such-Stringlnge eine Null bergeben,
                ;            wird die Lnges des Strings selbst ermittelt.
                ;            Der Haupttext und der Ersatzstring mssen mit
                ;            einem Null-Byte abgeschlossen sein.
                ;            Wird eine -1 zurckgegeben, trat ein Buffer-
                ;            berlauf auf.

                PUSHM   d2/a2-a5
                moveq   #0,d2                   ; clear replace-counter
                move.l  a1,a4
                add.l   d0,a4                   ; Calculate max targetbuffer

                tst.l   d1
                bne.b   .GotLength
                exg.l   a2,a0
                bsr     _Len
                move.l  d0,d1                   ; length of find-string
                exg.l   a2,a0

.GotLength      exg.l   a1,a2                   ; bring parameters in the
.continue       bsr.b   _Find                   ; right registers
                tst.l   d0
                beq.b   .finished
                addq.l  #1,d2                   ; increase replace-counter

                sub.l   a0,d0
.loop           beq.b   .GoOn2
                move.b  (a0)+,(a2)+
                cmp.l   a2,a4
                beq.b   .Overflow
                subq.l  #1,d0
                bra.b   .loop
.GoOn2          add.l   d1,a0

                move.l  a3,a5                   ; &RepString retten
.Copy_Loop      move.b  (a3)+,(a2)+
                beq.b   .GoOn
                cmp.l   a2,a4
                beq.b   .Overflow
                bra.b   .Copy_Loop

.GoOn           move.l  a5,a3
                subq.w  #1,a2
                bra.b   .continue

.finished       move.b  (a0)+,(a2)+
                beq.b   .exit
                cmp.l   a2,a4
                bne.b   .finished

.Overflow       moveq   #-1,d2

.exit           move.l  d2,d0
                POPM
                rts


_CmpStrings:
                ; Funktion : Vergleicht zwei Strings ohne Gro-/Kleinschrift
                ;
                ; Parameter: A0=&String1 A1=&String2 D0=Lnge des krzeren
                ; Result   : D0=Gleich (-1) oder verschieden (0)

                PUSHM   d1-d2/a0-a2
                lea     (CmpTab,PC),a2
                move.l  d0,d2
                subq.l  #1,d2
                moveq   #0,d0
                moveq   #0,d1
.loop           move.b  (a0)+,d0
                move.b  (a2,d0.w),d0            ; flush characters before you
                move.b  (a1)+,d1                ; compare them
                move.b  (a2,d1.w),d1
                cmp.b   d0,d1
                dbne    d2,.loop
                move.w  d2,d0
                bmi.b   .Same
                moveq   #0,d0
.Same           ext.l   d0
.exit           POPM
                rts

_CmpStringsSen:
                ; Funktion : Vergleicht zwei Strings mit Gro-/Kleinschrift
                ;
                ; Parameter: A0=&String1 A1=&String2 D0=Lnge des krzeren
                ; Result   : D0=Gleich (-1) oder verschieden (0)

                PUSHM   d1-d2/a0-a1
                move.l  d0,d2
                subq.l  #1,d2
                moveq   #0,d0
                moveq   #0,d1
.loop           move.b  (a0)+,d0
                move.b  (a1)+,d1                ; compare them
                cmp.b   d0,d1
                dbne    d2,.loop
                move.w  d2,d0
                bmi.b   .same
                moveq   #0,d0
.same           ext.l   d0
.exit           POPM
                rts


;----------------------------- PatternMatching Faaast ---------------------
_PatternTest:
                ; Funktion : Testet ein Pattern und gibt dessen Status zurck
                ;
                ; Parameter: A0=&Pattern D0=maximale Lnge+1
                ; Result   : D0=Status
                ; Kommentar:  0=Pattern okay
                ;             1=Or-Verknpfung okay
                ;            -1=Or-Verknpfung fehlerhaft
                ;            -2=Pattern zu lang

                move.l  d0,d1
                beq.b   .SkipLengthTest
                bsr     _Len
                cmp.l   d0,d1
                bmi.b   .LengthError
.SkipLengthTest cmp.b   #'(',(a0)
                bne.b   .PatternOkay
                cmp.b   #')',(-1,a0,d0.l)
                bne.b   .ArrayError
.ArrayOkay      moveq   #1,d0
                rts
.PatternOkay    moveq   #0,d0
                rts
.ArrayError     moveq   #-1,d0
                rts
.LengthError    moveq   #-2,d0
                rts



_PatternMatchFastArray:
                ; Funktion : Testet ob ein String auf ein Pattern zutrift
                ;
                ; Parameter: A0=&Text A1=&Orbuffer
                ; Result   : D0=0 (FALSE) / -1 (TRUE)
                ; Kommentar: Pattern mu erst mit _ParsePatternFastArray
                ;            behandelt werden!

                PUSHM   a2-a3
                moveq   #0,d0
                move.l  a1,a2
                move.l  a0,a3
.loop           tst.l   (a2)
                beq.b   .finished
                move.l  a3,a0
                move.l  (a2)+,a1
                bsr     _PatternMatchFast
                tst.l   d0
                beq.b   .loop
.finished       POPM
                rts


_ParsePatternFastArray:
                ; Funktion : Wandelt ein Pattern in das interne Format um
                ; Parameter: A0=&Pattern A1=&Patternbuffer A2=&Orbuffer
                ; Result   : keins
                ; Kommentar: Erkennt zustzlich noch () und | Operatoren

                PUSHM   a2-a5
                cmp.b   #'(',(a0)
                beq.b   .ParseArray
                move.l  a1,a2
                lea     (8,a2),a1
                move.l  a1,(a2)+
                clr.l   (a2)
                bsr     _ParsePatternFast
                bra.b   .exit

.ParseArray     addq.w  #1,a0
                link.w  a5,#-255
                lea     (-255,a5),a3
                cmp.b   #')',(a0)
                beq.b   .finished
.CopyLoop       move.b  (a0)+,(a3)+
                bne.b   .CopyLoop

                lea     (-255,a5),a3
                move.l  a2,a4
                move.l  a3,(a2)+
.PreProcLoop    cmp.b   #'|',(a3)
                beq.b   .FoundOr
                tst.b   (a3)+
                bne.b   .PreProcLoop
                clr.b   (-2,a3)
                bra.b   .GoOn
.FoundOr        clr.b   (a3)+
                move.l  a3,(a2)+
                bra.b   .PreProcLoop
.GoOn           clr.l   (a2)
                move.l  a1,a3

.ParseLoop      move.l  (a4),a0
                move.l  a3,(a4)+
                move.l  a3,a1
                bsr     _ParsePatternFast
                tst.l   (a4)
                beq.b   .finished
.FindEOFPattern tst.b   (a3)+
                bne.b   .FindEOFPattern
                cmp.b   #-1,(a3)
                bne.b   .FindEOFPattern
                addq.w  #1,a3
                bra.b   .ParseLoop

.finished       unlk    a5
.exit           POPM
                rts



_PatternMatchFast:
                ; Testet ob ein String auf ein Pattern zutrift
                ;
                ; Parameter: A0=&Text A1=&Patternbuffer
                ; Result   : D0=0 (FALSE) / -1 (TRUE)
                ; Kommentar: Pattern mu erst mit _ParsePatternFast
                ;            behandelt werden!

                move.l  d7,-(SP)
                addq.w  #1,a1                   ; Pad-Byte berspringen
                exg.l   a0,a1
                moveq   #0,d7                   ; D7=Result (DEFAULT=FALSE)
                tst.b   (a0)
                bne.b   .GoOn                   ; Patternlnge = 0 --> Fehler!
                cmp.b   #-1,(1,a0)
                beq.b   .finished
.GoOn           tst.b   (a1)
                beq.b   .finished               ; Textlnge    = 0 --> Fehler!

                tst.b   (a0)                    ; Erste Zeichen ein Pattern?
                beq.b   .StartPatternMatch      ; Ja  : In die Hauptschleife

                bsr     _Len                    ; Patternlnge berechnen
                move.l  d0,d1
                bsr     _PMCmpStrings           ; Stimmen die ersten Zeichen
                tst.l   d0                      ; des Patterns mit dem Text
                beq.b   .finished               ; berein?
                lea     (1,a0,d1.l),a0          ; Nein: --> Ende
                lea     (1,a1,d1.l),a1
                cmp.b   #-1,(a0)                ; Wenn dies das einzige Pattern
                bne.b   .PatternMatch           ; war, mu der Text ebenfalls
                tst.b   (-1,a1)                 ; zu Ende sein!
                beq.b   .PatternMatchEnd
                bra.b   .finished

.StartPatternMatch:
                addq.w  #1,a0                   ; Null berspringen

.PatternMatch   bsr     _Len
                cmp.b   #-1,(1,a0,d0.l)         ; letztes Pattern??
                beq.b   .MatchLastPattern
                move.l  d0,d1
                bsr.b   _PMFind
                tst.l   d0
                beq.b   .finished
                lea     (1,a0,d1.l),a0
                lea     (1,a1,d1.l),a1
                bra.b   .PatternMatch

.MatchLastPattern:
                tst.b   (a0)                    ; letzte Zeichen war ein Joker?
                beq.b   .PatternMatchEnd        ; Ja  : --> Fertig!
                move.l  d0,d1

                exg.l   a0,a1
                bsr     _Len                    ; Ende vom Text finden
                exg.l   a0,a1
                tst.l   d0
                beq.b   .finished
                lea     (a1,d0.l),a1
                sub.l   d1,a1

                move.l  d1,d0
                bsr     _PMCmpStrings           ; Stimmen die letzten Zeichen
                tst.l   d0                      ; des Patterns mit dem Text
                beq.b   .finished               ; berein?

.PatternMatchEnd:
                moveq   #-1,d7
.finished       move.l  d7,d0                   ; Rckgabewert holen
                move.l  (SP)+,d7
                rts                             ; Bye, bye!


_ParsePatternFast:
                ; Wandelt ein Pattern ins interne Format
                ;
                ; Parameter: A0=&Pattern A1=&Patternbuffer
                ; Result   : keine
                ; Kommentar: Routine erkennt nur "#?" und "?" als Patterns,
                ;            da sie in erster Linie schnell sein soll!! Dem
                ;            Patternpuffer mu ein Byte <> 0 vorrangehen!!

                move.b  #-1,(a1)+
.SplitLoop      cmp.b   #'#',(a0)       ; aktuelles Zeichen ein "#" ??
                beq.b   .FoundPattern   ; Ja: Verzweigen
.CopyChar       move.b  (a0)+,(a1)+     ; Nein: Zeichen kopieren
                bne.b   .SplitLoop      ; String zu Ende
                bra.b   .SplitEnd       ; Nchstes Zeichen testen

.FoundQM        move.b  d0,(a1)+        ; Fragezeichen schreiben
                bra.b   .SplitLoop


.FoundPattern   cmp.b   #'?',(1,a0)     ; Ist das folgende Zeichen ein "?"
                bne.b   .CopyChar       ; Nein: aktuelles Zeichen kopieren
                tst.b   (-1,a1)         ; Ja  : Pattern gefunden und Endmar-
                beq.b   .SkipPattern    ;       kierung im Array schreiben
                clr.b   (a1)+           ; Vorsicht: Zwei Joker nacheinander
.SkipPattern    addq.w  #2,a0           ;           werden bersprungen
.SkipQM         cmp.b   #'?',(a0)       ; Fragezeichen nach Jokern lschen
                bne.b   .SplitLoop
                addq.w  #1,a0
                bra.b   .SkipQM

.SplitEnd       move.b  #-1,(a1)        ; Endmarkierung: 0.b,-1.b
                rts

_PMFind:        movem.l d1-d2/a0-a2,-(SP)
                tst.l   d0
                beq.b   .exit
                move.l  d0,d2
                bsr     _GetPMCmpTab
                tst.l   d0
                beq.b   .exit
                move.l  d0,a2
                moveq   #0,d1
.continue       moveq   #0,d0
                move.b  (a0),d1
                move.b  (a2,d1.w),d1
.loop           move.b  (a1)+,d0                ; erste Zeichen im Text finden
                beq.b   .exit
                move.b  (a2,d0.w),d0            ; Break when NULL is reached
                cmp.b   d0,d1
                bne.b   .loop

                subq.w  #1,a1
                move.l  d2,d0
                bsr.b   _PMCmpStrings           ; test if whole string is
                tst.l   d0                      ; found
                bne.b   .GotIt                  ; GotIt-> move address to D0
                addq.w  #1,a1
                bra.b   .continue               ; continue search

.exit           sub.l   a0,a0                   ; didn`t find anything
.GotIt          move.l  a0,d0
                movem.l (SP)+,d1-d2/a0-a2
                rts


_PMCmpStrings:  movem.l d1-d2/a0-a2,-(SP)
                move.l  d0,d2
                bsr     _GetPMCmpTab
                tst.l   d0
                beq.b   .exit
                move.l  d0,a2
                subq.l  #1,d2
                moveq   #0,d0
                moveq   #0,d1
.CmpLoop        move.b  (a1)+,d1
                beq.b   .NotSame                ; String2 finished
                move.b  (a2,d1.w),d1
                move.b  (a0)+,d0
                move.b  (a2,d0.w),d0
                bne.b   .NoQM                   ; QM=QuestionMark :-))
                move.b  d1,d0
.NoQM           cmp.b   d0,d1
                dbne    d2,.CmpLoop
                move.w  d2,d0
                bmi.b   .Same
.NotSame        moveq   #0,d0
.Same           ext.l   d0
.exit           movem.l (SP)+,d1-d2/a0-a2
                rts


_GetPMCmpTab:
                PUSHM   d1/a0-a2/a6
                move.l  (_PToolBase,PC),a6
                lea     (ptl_PMCmpTable,a6),a2
                move.l  (ptl_SysBase,a6),a6
                jsr     (_LVOForbid,a6)

                move.l  (a2),d0                 ; besteht die Tabelle schon?
                bne.b   .finished

                move.l  #256*1,d0
                moveq   #0,d1                   ; Speicher reservieren und
                jsr     (_LVOAllocMem,a6)       ; die Adresse in der Lib-
                move.l  d0,(a2)                 ; Base eintragen
                beq.b   .finished
                move.l  d0,a1

                lea     (CmpTab,PC),a0
                move.w  #256-1,d0
...             move.b  (a0)+,(a1)+
                dbra    d0,...

                move.l  (a2),a0                 ; Fragezeichen patchen
                clr.b   (63,a0)

                move.l  (a2),d0
.finished       jsr     (_LVOPermit,a6)         ; laden
                POPM
                rts


;------------------------------- Zufallszahlen ----------------------------
_SetRandomSeed:
                ; Setzt den "seed"
                ;
                ; Parameter: D0=NeuerSeed
                ; Result   : keins

                PUSHM   d0-d1
                ADD.L   D0,D1           ; user seed in d0 (d1 too)
                MOVEM.L D0/D1,(ptl_RandomSeed,a6)
                POPM
                rts

_LongRnd:
                ; Berechnet eine Zufallszahl
                ;
                ; Parameter: keine
                ; Result   : D0.L=Zufallszahl

                PUSHM   d1-d3
                MOVEM.L (ptl_RandomSeed,a6),D0/D1
                                        ; D0=LSB's, D1=MSB's of random number
                ANDI.B  #$0E,D0         ; ensure upper 59 bits are an...
                ORI.B   #$20,D0         ; ...odd binary number
                MOVE.L  D0,D2
                MOVE.L  D1,D3
                ADD.L   D2,D2           ; accounts for 1 of 17 left shifts
                ADDX.L  D3,D3           ; [D2/D3] = RND*2
                ADD.L   D2,D0
                ADDX.L  D3,D1           ; [D0/D1] = RND*3
                SWAP    D3              ; shift [D2/D3] additional 16 times
                SWAP    D2
                MOVE.W  D2,D3
                CLR.W   D2
                ADD.L   D2,D0           ; add to [D0/D1]
                ADDX.L  D3,D1
                MOVEM.L D0/D1,(ptl_RandomSeed,a6) ; save for next time
                MOVE.L  D1,D0           ; most random part to D0
                POPM
                RTS


_Random:
                ; Berechnet eine Zufallszahl mit Limit
                ;
                ; Parameter: D0=UpperLimit
                ; Result   : D0.W=Zufallszahl

                PUSHM   d1-d2
                MOVE.W  D0,D2           ; save upper limit
                BEQ.S   .NullRange      ; range of 0 returns 0 always
                BSR.S   _LongRnd        ; get a longword random number
                CLR.W   D0              ; use upper word (it's most random)
                SWAP    D0
                DIVU.W  D2,D0           ; divide by range...
                CLR.W   D0              ; ...and use remainder for the value
                SWAP    D0              ; result in D0.W
.NullRange      POPM
                RTS




;***************************************************************************
;*                                                                         *
;* SEKTION: Daten, Zeiger                                                  *
;*                                                                         *
;***************************************************************************

                CNOP    0,4
_PToolBase      ds.l    1

PetiToolLibName PTOOLNAME
dosname         CSTR    "dos.library"
intuiname       CSTR    "intuition.library"
localename      CSTR    "locale.library"
CatalogName     CSTR    "ptool.catalog"

                dc.b    "$VER: "
LibraryID       dc.b    "PetiToolLibrary"
        IFNE SELFEXPUNGE
                dc.b    "_BETA"
        ENDC
                dc.b    " v"
                REVISION
                dc.b    " ("
                REVDATE
                dc.b    ")",$0A
                dc.b    "written by Peter Simons",$0A
                dc.b    $00

YesString       dc.b    "yes"

CmpTab          DC.B    $00,$01,$02,$03,$04,$05,$06,$07 ; tab for flushing
                DC.B    $08,$09,$0A,$0B,$0C,$0D,$0E,$0F ; the characters
                DC.B    $10,$11,$12,$13,$14,$15,$16,$17
                DC.B    $18,$19,$1A,$1B,$1C,$1D,$1E,$1F
                DC.B    $20,$21,$22,$23,$24,$25,$26,$27
                DC.B    $28,$29,$2A,$2B,$2C,$2D,$2E,$2F
                DC.B    $30,$31,$32,$33,$34,$35,$36,$37
                DC.B    $38,$39,$3A,$3B,$3C,$3D,$3E,$3F
                DC.B    $40,$61,$62,$63,$64,$65,$66,$67
                DC.B    $68,$69,$6A,$6B,$6C,$6D,$6E,$6F
                DC.B    $70,$71,$72,$73,$74,$75,$76,$77
                DC.B    $78,$79,$7A,$6B,$5C,$5D,$5E,$5F
                DC.B    $60,$61,$62,$63,$64,$65,$66,$67
                DC.B    $68,$69,$6A,$6B,$6C,$6D,$6E,$6F
                DC.B    $70,$71,$72,$73,$74,$75,$76,$77
                DC.B    $78,$79,$7A,$7B,$7C,$7D,$7E,$7F
                DC.B    $80,$81,$82,$83,$84,$85,$86,$87
                DC.B    $88,$89,$8A,$8B,$8C,$8D,$8E,$8F
                DC.B    $90,$91,$92,$93,$94,$95,$96,$97
                DC.B    $98,$99,$9A,$9B,$9C,$9D,$9E,$9F
                DC.B    $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7
                DC.B    $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF
                DC.B    $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7
                DC.B    $B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
                DC.B    $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7
                DC.B    $C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF
                DC.B    $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7
                DC.B    $D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF
                DC.B    $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7
                DC.B    $E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
                DC.B    $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7
                DC.B    $F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF

;-------------------------------------- Locale ------------
                INCLUDE "A:Sources/PetiToolLibrary/PToolLibrary_Locale.i"
                IFND MODIFIED_LOCALE
                FAIL
                ENDC

EndOfCode:      END
