#ifndef CLIB_PTOOL_PROTOS_H
#define CLIB_PTOOL_PROTOS_H

/**
 **     $VER: ptool_protos.h 2.x (1-Sep-93)
 **
 **     (C) Copyright 1993 Peter Simons, Germany
 **         All Rights Reserved
 **/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif
#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

/************************************** Prototypes ********/
LONG AllocNewStack(ULONG[3], ULONG);
void RestoreStack(ULONG[3]);
ULONG CheckConfig(ULONG, UWORD);
void DisplayConfigErrorDos(STRPTR, ULONG, UWORD, BPTR);
ULONG GetStackSize(void);
void ParsePatternFast(STRPTR, STRPTR);
LONG PatternMatchFast(STRPTR, STRPTR);
void ParsePatternFastArray(STRPTR, STRPTR, ULONG **);
LONG PatternMatchFastArray(STRPTR, STRPTR);
LONG PatternTest(STRPTR, ULONG);
void *LoadFile(STRPTR);
LONG LoadBreak(BPTR, STRPTR, LONG);
LONG SaveBreak(BPTR, STRPTR, LONG);
LONG GetFileSize(STRPTR);
UWORD CRC16Buffer(STRPTR, ULONG);
UWORD CRC16File(STRPTR);
void *PTAllocRemember(void **, ULONG, ULONG);
void PTFreeRemember(void **);
void PTFreeOneBlock(void **, void *);
void *LoadFileRemember(STRPTR, void **);
STRPTR Find(STRPTR, STRPTR, ULONG);
STRPTR Replace(STRPTR, STRPTR, STRPTR, STRPTR, ULONG, ULONG);
LONG CmpStrings(STRPTR, STRPTR, ULONG);
LONG CmpStringsSen(STRPTR, STRPTR, ULONG);
ULONG GetErrorMsg(STRPTR, STRPTR, ULONG, ...);
void ErrorHandleDos(STRPTR, ULONG, BPTR, ...);
void ErrorHandleIntuition(STRPTR, struct Window *, ULONG, ...);
LONG PrintF(BPTR, STRPTR, ...);
LONG PrintFSimple(STRPTR, ...);
void InterpretConfigBuffer(STRPTR, STRPTR *, ...);
void *InterpretConfigFile(STRPTR, STRPTR *, ...);
void *InterpretConfigFileRemember(STRPTR, void *, void **, ...);
ULONG CRC32Buffer(STRPTR, ULONG);
ULONG CRC32File(STRPTR);
void SetRandomSeed(ULONG);
ULONG LongRnd(void);
ULONG Random(ULONG);

#endif  /* CLIB_PTOOL_PROTOS_H */
